'From Squeak 2.0 of May 22, 1998 on 10 June 1998 at 7:58:18 am'!

!EToyWorldView class methodsFor: 'initialization' stamp: 'jm 6/10/1998 07:44'!
openOn: aWorld label: labelString
	"Open a view with the given label on the given world."

	| windowExtent topView topLeft |
	windowExtent _ aWorld extent + (2@2).  "add border width"
	topView _ self fullColorWhenInactive
		ifTrue: [topView _ ColorSystemView new]
		ifFalse: [topView _ StandardSystemView new].
	topView model: CautiousModel new;
		borderWidth: 1;
		addSubView: (self new initialize model: aWorld).
	topView controller openNoTerminate.
	topLeft _ ((Display extent - windowExtent) // 2) max: (0@0).
	topView resizeTo: (topLeft extent: windowExtent).
	aWorld setStandardTexture.
	labelString isEmpty
		ifTrue: [topView noLabel]
		ifFalse: [topView label: labelString].
	Processor terminateActive.
! !


!ProjectViewMorph methodsFor: 'all' stamp: 'jm 6/10/1998 07:49'!
extent: aPoint
	"Set my image form to the given extent."
	| newExtent scaleP scale fillColor |
	((bounds extent = aPoint) and:
	 [image depth = Display depth]) ifFalse: [
		lastProjectThumbnail
			ifNil: [newExtent _ aPoint]
			ifNotNil: [
				scaleP _ aPoint / lastProjectThumbnail extent.
				scale _ scaleP "scaleP x asFloat max: scaleP y asFloat".
				newExtent _ (lastProjectThumbnail extent * scale) rounded].
		self image: (Form extent: newExtent depth: Display depth).
		((project world ~~ nil) and: [project world isKindOf: Morph])
			ifTrue: [fillColor _ project world color]
			ifFalse: [fillColor _ Color veryLightGray].
		image fill: image boundingBox fillColor: fillColor.
		lastProjectThumbnail _ nil].
! !


!WorldMorph methodsFor: 'events' stamp: 'jm 6/10/1998 07:57'!
mouseDown: evt
	"Handle a mouse down event on the world."

	evt hand newKeyboardFocus: self.
	evt hand invokeMetaMenu: evt.

! !


