'From Squeak 2.0 of May 22, 1998 on 15 June 1998 at 3:47:35 pm'!
"Change Set:		tearOffValueTile
Date:			15 June 1998
Author:			Scott Wallace

Allows 'literal' tile to be torn off from an object whose value represents a literal, via its orange tear-off-tile halo handle.  The effect is most immediately seen in the viewer, where every value readout that represents a number, a boolean, a color, or a player, for example, will deliver a literal tile when you drag from its orange tear-off-tile handle."!


!Color methodsFor: 'other' stamp: 'sw 6/10/1998 17:50'!
newTileMorphRepresentative
	^ ColorTileMorph new colorSwatchColor: self! !


!Morph methodsFor: 'dec97 additions' stamp: 'sw 6/10/1998 17:42'!
tearOffTile
	| aValue |
	costumee ifNotNil: [^ costumee tearOffTileForSelf].
	
	(aValue _ self valueAsConstant) ifNotNil:
		[^ self world primaryHand attachMorph: aValue newTileMorphRepresentative].
 
	^ self assuredCostumee tearOffTileForSelf! !

!Morph methodsFor: 'jun98 additions' stamp: 'sw 6/10/1998 17:33'!
valueAsConstant
	"If the receiver can be perceived by the end-user as bearing a data value of any type other than player-reference, return the literal representing its value at this very moment -- for the purpose of a value-tile being constructed."

	^ nil! !


!ColorTileMorph methodsFor: 'other' stamp: 'sw 6/10/1998 17:49'!
colorSwatchColor: aColor
	colorSwatch color: aColor! !


!StringMorph methodsFor: 'accessing' stamp: 'sw 6/10/1998 18:03'!
valueAsConstant
	^ self contents! !


!ThumbnailMorph methodsFor: 'all' stamp: 'sw 6/15/1998 15:18'!
tearOffTile
	(objectToView isKindOf: Player) ifTrue: [^ objectToView tearOffTileForSelf].

	objectToView ifNil: [^ nil].
	^ objectToView isMorph
		ifTrue:
			[objectToView]
		ifFalse:
			[objectToView costume]
! !


!UpdatingRectangleMorph methodsFor: 'accessing' stamp: 'sw 6/10/1998 17:45'!
valueAsConstant
	^ self readFromTarget! !


!UpdatingStringMorph methodsFor: 'accessing' stamp: 'sw 6/11/1998 16:27'!
valueAsConstant
	^ self valueFromContents! !


