'From Squeak 2.4c of May 10, 1999 on 7 June 1999 at 12:02:34 am'!
"Change Set:		projTriggerMerged-sw
Date:			6 June 1999
Author:			Scott Wallace

Note: this is a revised version of a changeset formerly called simply 'projectTrigger'; this revised version merges that earlier code with changes to Project.enter: from two other sources, namely Andreas's FlashProjectZoom (update 1225) and Dan's project.enter.st from earlier on 6 June 99.

When a morphic project is entered, if its World has any scripts set to run on 'opening', then trigger them.

When a morphic project is exitted, if its World has any scripts set to run on 'closing', then trigger them."!


!Project methodsFor: 'menu messages' stamp: 'sw 6/6/1999 23:43'!
enter: returningFlag
	"Install my ChangeSet, Transcript, and scheduled views as current globals. If returningFlag is true, we are return to the project from whence the current project was entered; don't change its previousProject link in this case."

	| showZoom recorderOrNil |
	self == CurrentProject ifTrue: [^ self].
	"Check the guards"
	guards ifNotNil:
		[guards _ guards reject: [:obj | obj isNil].
		guards do: [:obj | obj okayToEnterProject ifFalse: [^ self]]].

	World isMorph ifTrue: [World triggerClosingScripts].

	"Update the display depth and make a thumbnail of the current project"
	CurrentProject displayDepth: Display depth.
	CurrentProject makeThumbnail.

	"Show the project transition.
	Note: The project zoom is run in the context of the old project,
		so that eventual errors can be handled accordingly"
	displayDepth == nil ifTrue:[displayDepth _ Display depth].
	Display newDepthNoRestore: displayDepth.
	showZoom _ Preferences showProjectZoom
		and: ["Only show zoom if there is room for the both displays plus a megabyte"
			Smalltalk garbageCollectMost > (Display boundingBox area*displayDepth//8+1000000)].
	showZoom ifTrue:[self displayZoom: CurrentProject parent ~~ self].

	(world isMorph and: [world hasProperty: #letTheMusicPlay])
		ifTrue: [world removeProperty: #letTheMusicPlay]
		ifFalse: [Smalltalk at: #ScorePlayer ifPresent:
					[:playerClass | playerClass allInstancesDo: [:player | player pause]]].

	returningFlag
		ifTrue: [nextProject _ CurrentProject]
		ifFalse: [previousProject _ CurrentProject].

	CurrentProject saveState.
	CurrentProject _ self.
	Smalltalk newChanges: changeSet.
	TranscriptStream newTranscript: transcript.
	Sensor flushKeyboard.
	World isMorph ifTrue:
		[recorderOrNil _ World pauseEventRecorder].

	world isMorph
		ifTrue:
			[World _ world.  "Signifies Morphic"
			world install.
			recorderOrNil ifNotNil: [recorderOrNil resumeIn: World].
			world triggerOpeningScripts.
			self spawnNewProcessAndTerminateOld: true]
		ifFalse:
			[World _ nil.  "Signifies MVC"
			Smalltalk at: #ScheduledControllers put: world.
			ScheduledControllers restore.
			ScheduledControllers searchForActiveController]
! !


!WorldMorph methodsFor: 'install / exit' stamp: 'sw 6/6/1999 11:50'!
triggerClosingScripts
	"If the receiver has any scripts set to run on closing, run them now"
	| aPlayer |
	(aPlayer _ self player) ifNotNil:
		[aPlayer runAllClosingScripts]! !

!WorldMorph methodsFor: 'install / exit' stamp: 'sw 6/6/1999 11:44'!
triggerOpeningScripts
	"If the receiver has any scripts set to run on opening, run them now"
	| aPlayer |
	(aPlayer _ self player) ifNotNil:
		[aPlayer runAllOpeningScripts]! !


