'From Squeak 2.4b of April 23, 1999 on 7 June 1999 at 8:26 am'!
"Change Set:		flashSndLevel-jhm
Date:			7 June 1999
Author:			John Maloney

Adds a global volume control for sounds played by Flash. The level is held
in a class variable of FlashMorph. Does not apply to streamed sounds."!

MatrixTransformMorph subclass: #FlashMorph
	instanceVariableNames: 'colorTransform '
	classVariableNames: 'FlashSoundVolume '
	poolDictionaries: ''
	category: 'MM-Flash-Morphs'!

!FlashMorph methodsFor: 'sound' stamp: 'jm 6/7/1999 08:25'!
playFlashSound: aSound
	"Play the given sound at the volume level for Flash sounds."

	FlashSoundVolume ifNil: [FlashSoundVolume _ 0.3].
	(MixedSound new add: aSound pan: 0.5 volume: FlashSoundVolume) play.
! !


!FlashSpriteMorph methodsFor: 'stepping' stamp: 'jm 6/7/1999 08:22'!
stepToFrame: frame
	"Step to the given frame"
	| fullRect postDamage lastVisible resortNeeded |
	frame = frameNumber ifTrue:[^self].
	frame > loadedFrames ifTrue:[^self].
	postDamage _ damageRecorder isNil.
	postDamage ifTrue:[damageRecorder _ FlashDamageRecorder new].
	lastVisible _ nil.
	resortNeeded _ false.
	submorphs do:[:m|
		(m isFlashMorph and:[m isFlashCharacter]) ifTrue:[
			m stepToFrame: frame.
			m visible ifTrue:[
				(lastVisible notNil and:[lastVisible depth < m depth])
					ifTrue:[resortNeeded _ true].
				lastVisible _ m.
				(bounds containsRect: m bounds) ifFalse:[bounds _ bounds merge: m bounds].
			].
		].
	].
	resortNeeded ifTrue:[submorphs _ submorphs sortBy:[:m1 :m2| m1 depth > m2 depth]].
	frameNumber _ frame.
	(sounds at: frame ifAbsent:[#()]) do: [:sound | sound ifNotNil:[self playFlashSound: sound]].
	(actions at: frame ifAbsent:[#()]) do:[:action| action sentTo: self].
	(postDamage and:[owner notNil]) ifTrue:[
		damageRecorder updateIsNeeded ifTrue:[
			"fullRect _ damageRecorder fullDamageRect.
			fullRect _ (self transform localBoundsToGlobal: fullRect)."
			fullRect _ bounds.
			owner invalidRect: (fullRect insetBy: -1).
		].
	].
	postDamage ifTrue:[
		damageRecorder _ nil].! !


!FlashPlayerMorph methodsFor: 'stepping' stamp: 'jm 6/7/1999 08:22'!
stepToFrame: frame
	| fullRect postDamage |
	frame = frameNumber ifTrue:[^self].
	frame > loadedFrames ifTrue:[^self].
	postDamage _ damageRecorder isNil.
	postDamage ifTrue:[damageRecorder _ FlashDamageRecorder new].
	frame = (frameNumber+1) ifTrue:[
		self stepToFrameForward: frame.
	] ifFalse:[
		activeMorphs _ activeMorphs select:[:any| false].
		submorphs do:[:m|
			(m isFlashMorph and:[m isFlashCharacter]) ifTrue:[
				m stepToFrame: frame.
				m visible ifTrue:[activeMorphs add: m].
			]].
	].
	frameNumber _ frame.
	(sounds at: frame ifAbsent:[#()]) do: [:sound | sound ifNotNil:[self playFlashSound: sound]].
	self executeActionsAt: frame.
	(postDamage and:[owner notNil]) ifTrue:[
		damageRecorder updateIsNeeded ifTrue:[
			fullRect _ damageRecorder fullDamageRect: self localBounds.
			fullRect _ (self transform localBoundsToGlobal: fullRect).
			owner invalidRect: (fullRect insetBy: -1).
		].
	].
	postDamage ifTrue:[damageRecorder _ nil].! !


