'From Squeak 2.0 of May 22, 1998 on 30 June 1998 at 9:41:16 am'!

!AuthorizedSwikiAction methodsFor: 'URL processing' stamp: 'tk 6/22/1998 14:15'!
restore: nameOfSwiki
	"Read all files in the directory 'nameOfSwiki'.  Reconstruct the url map."

	| fName |
	super restore: nameOfSwiki.
	fName _ ServerAction serverDirectory, name, (ServerAction pathSeparator), 
				'authorizer'.
	(FileDirectory new fileExists: fName) ifTrue: [
		authorizer _ (FileStream oldFileNamed: fName) fileInObjectAndCode].
! !


!BlockContext methodsFor: 'evaluating' stamp: 'tk 6/24/1998 15:32'!
ifError: errorHandlerBlock
	"Evaluate the block represented by the receiver. If an error occurs the given is evaluated with the error message and the receiver as parameters. The error handler block may return a value to be used if the receiver block gets an error. The receiver should not contain an explicit return statement as this would leave an obsolete error handler hanging around."
	"Examples:
		[1 whatsUpDoc] ifError: [:err :rcvr | ^ 'huh?'].
		[1 / 0] ifError: [:err :rcvr |
			'division by 0' = err
				ifTrue: [^ Float infinity]
				ifFalse: [self error: err]]
"

	| lastHandler val activeProcess |
	activeProcess _ Processor activeProcess.
	lastHandler _ activeProcess errorHandler.
	activeProcess errorHandler: [:aString :aReceiver |
		activeProcess errorHandler: lastHandler.
		^ errorHandlerBlock value: aString value: aReceiver].
	val _ self value.
	activeProcess errorHandler: lastHandler.
	^ val
! !


!BookMorph methodsFor: 'menu' stamp: 'tk 6/14/1998 14:26'!
insertPageColored: aColor

	| sz newPage bw bc |
	currentPage == nil
		ifTrue:
			[sz _ pageSize.
			bw _ 0.
			bc _ Color blue muchLighter]
		ifFalse:
			[sz _ currentPage extent.
			bw _ currentPage borderWidth.
			bc _ currentPage borderColor].
	newPagePrototype
		ifNil: [
			newPage _ PasteUpMorph new extent: sz; color: aColor.
			newPage borderWidth: bw; borderColor: bc]
		ifNotNil: [Cursor wait showWhile: 
				[newPage _ newPagePrototype veryDeepCopy]].
	newPage resizeToFit: false.
	pages isEmpty
		ifTrue: [pages add: (currentPage _ newPage)]
		ifFalse: [pages add: newPage after: currentPage].
	self nextPage.
! !


!HandMorph methodsFor: 'meta menu' stamp: 'tk 6/14/1998 14:29'!
copyToPasteBuffer
	"Save this morph in the paste buffer. This is mostly useful for copying morphs between projects."

	argument isMorph
		ifTrue: [Cursor wait showWhile: 
					[PasteBuffer _ argument veryDeepCopy]]
		ifFalse: [PasteBuffer _ nil].

! !

!HandMorph methodsFor: 'meta menu' stamp: 'tk 6/14/1998 14:34'!
objectToPaste
	"It may need to be sent #startRunning by the client"
	^ Cursor wait showWhile: [PasteBuffer veryDeepCopy]

	"PasteBuffer usableDuplicateIn: self world"
! !

!HandMorph methodsFor: 'meta menu' stamp: 'tk 6/14/1998 14:35'!
pasteMorph

	| aPastee |
	PasteBuffer ifNil: [^ self inform: 'Nothing to paste.'].
	self attachMorph: (aPastee _ self objectToPaste).
	aPastee costumee ifNotNil: [aPastee costumee startRunning]
! !


!PWS class methodsFor: 'HTTPcodes' stamp: 'tk 6/24/1998 16:24'!
unauthorizedFor: realm
	^'HTTP/1.0 401 Unauthorized', self crlf, 'WWW-Authenticate: Basic realm="Squeak/',realm,'"',
	self crlfcrlf, '<html><title>Unauthorized</title><body><h2>Unauthorized for ',realm, '</h2></body></html>'

! !


!PasteUpMorph methodsFor: 'dropping/grabbing' stamp: 'tk 6/30/1998 09:15'!
rootForGrabOf: aMorph
	"If open to drag-n-drop, allow submorph to be extracted. If parts bin, copy the submorph."
	| root |
	root _ aMorph.
	[root = self] whileFalse:
		[root owner == self ifTrue:
			[self isPartsBin
				ifTrue:
					[^ root veryDeepCopy].
			self openToDragNDrop
					ifTrue: [^ root]].
		root _ root owner].
	^ super rootForGrabOf: aMorph
! !

!PasteUpMorph methodsFor: 'scripting' stamp: 'tk 6/14/1998 15:18'!
scriptorForTextualScript: aSelector ofPlayer: aPlayer
	| aScriptor |
	self world ifNil: [^ nil].
	aScriptor _ ScriptEditorMorph new setMorph: aPlayer costume scriptName: aSelector.
	aScriptor position: (self primaryHand position - (10 @ 10)).
	^ aScriptor! !


!String methodsFor: 'accessing' stamp: 'tk 6/21/1998 11:41'!
atPin: index 
	"Return this element of an indexable object, letting the index wrap around from the end to the beginning.  See Object at:.  Needed here when index is not an integer and has to be coerced.  "
	<primitive: 63>
	^(super atWrap: index) asCharacter! !


BookMorph removeSelector: #saveBookToFile!
HandMorph removeSelector: #saveMorphInFile!
