'From Squeak 2.0 of May 22, 1998 on 30 June 1998 at 3:50:11 pm'!

!ServerDirectory methodsFor: 'updates' stamp: 'tk 6/30/1998 15:20'!
checkNames: list
	"Look at these names for update and see if they are OK"

list do: [:local |
	(local count: [:char | char == $.]) > 1 ifTrue: [
		self inform: 'File name ',local,'
may not have more than one period'.
	^ false].
	(local at: 1) isDigit ifTrue: [
		self inform: 'File name ',local,'
may not begin with a number'.
	^ false].
	(local findDelimiters: '%/* ' startingAt: 1) <= local size ifTrue: [
		self inform: 'File name ',local,'
may not contain % / * or space'.
	^ false]].
^ true
! !

!ServerDirectory methodsFor: 'updates' stamp: 'tk 6/30/1998 15:25'!
putUpdate: fileStrm
	"Put this file out as an Update on the servers of my group.  Each version of the system has its own set of update files.  'updates.list' holds the master list.  Each update is a fileIn whose name begins with a number.  See Utilities class absorbUpdatesFromServer."

	| myServers updateStrm sequence newName myName response local restOfText seq |
"	(ScheduledControllers scheduledControllers detect: [:each |
		each model == Transcript] ifNone: [nil]) ifNil: [
			^ self inform: 'Please open a Transcript window, and 
then start putting out this update again.'].
"
	local _ fileStrm localName.
	(self checkNames: (Array with: local)) ifFalse: [^ nil].	"allowed characters"
	myName _ group ifNil: [self moniker] ifNotNil: [group key].
	response _ (PopUpMenu labels: 'Install update\Cancel update' withCRs)
		startUpWithCaption: 'Do you really want to broadcast the file ', local, 
			'\to every Squeak user who updates from ' withCRs, myName, '?'.
	response = 1 ifFalse: [^ nil].	"abort"

	(myServers _ self checkServers) size = 0 ifTrue: [^ self].
	updateStrm _ myServers first getFileNamed: 'updates.list'.
	"get last number and add 1"
	sequence _ Utilities lastUpdateNum: updateStrm.
	seq _ (sequence+1) printString.
	seq size = 1 ifTrue: [seq _ '00', seq].
	seq size = 2 ifTrue: [seq _ '0', seq].
	newName _ seq, local.
	restOfText _ Utilities position: updateStrm 	"sets the postion!!!!"
			atVersion: (Smalltalk at: #EToySystem) version.
	restOfText size > 0 ifTrue: [
		response _ (PopUpMenu labels: 'Make update for my older version\Cancel update' withCRs)
			startUpWithCaption: 'This system, ', (Smalltalk at: #EToySystem) version,
				' is not the latest version'.
		response = 1 ifFalse: [^ nil].	"abort"
		].
	"append name to updates"
	(updateStrm skip: -1; next) == Character cr ifFalse: [
		updateStrm nextPut: Character cr].
	updateStrm nextPutAll: newName; nextPut: Character cr; nextPutAll: restOfText.

	myServers do: [:aServer |
		fileStrm reset.	"reopen"
		aServer putFile: fileStrm named: newName.
		updateStrm reset.
		aServer putFile: updateStrm named: 'updates.list'.
		Transcript cr; show: 'Update succeeded on server ', aServer moniker].
		
	Transcript cr; show: 'Be sure to test your new update!!'; cr.
	"rename the file locally (may fail)"
	fileStrm directory rename: local toBe: newName.
!
]style[(19 225 39 2051)f1b,f1,f1LUtilities class absorbUpdatesFromServer;,f1! !

!ServerDirectory methodsFor: 'updates' stamp: 'tk 6/30/1998 15:24'!
putUpdateMulti: list
	"Put these files out as an Update on the servers of my group.  List is an array of local file names without number prefixes.  Each version of the system has its own set of update files.  'updates.list' holds the master list.  Each update is a fileIn whose name begins with a number.  See Utilities class absorbUpdatesFromServer."

	| myServers updateStrm sequence myName response restOfText seq start add newNames file |
	(self checkNames: list) ifFalse: [^ nil].
	myName _ group ifNil: [self moniker] ifNotNil: [group key].
	response _ (PopUpMenu labels: 'Install update\Cancel update' withCRs)
		startUpWithCaption: 'Do you really want to broadcast ', list size printString, ' updates',
			'\to every Squeak user who updates from ' withCRs, myName, '?'.
	response = 1 ifFalse: [^ nil].	"abort"

	(myServers _ self checkServers) size = 0 ifTrue: [^ self].
	updateStrm _ myServers first getFileNamed: 'updates.list'.
	"get last number and add 1"
	start _ sequence _ Utilities lastUpdateNum: updateStrm.
	add _ WriteStream on: (String new: 200).
	newNames _ list collect: [:each | 
		seq _ (sequence _ sequence+1) printString.
		seq size = 1 ifTrue: [seq _ '00', seq].
		seq size = 2 ifTrue: [seq _ '0', seq].
		add nextPutAll: seq; nextPutAll: each; cr.
		seq, each].
	restOfText _ Utilities position: updateStrm 	"sets the postion!!!!"
			atVersion: (Smalltalk at: #EToySystem) version.
	restOfText size > 0 ifTrue: [
		response _ (PopUpMenu labels: 'Make update for my older version\Cancel update' withCRs)
			startUpWithCaption: 'This system, ', (Smalltalk at: #EToySystem) version,
				' is not the latest version'.
		response = 1 ifFalse: [^ nil].	"abort"
		].
	"append name to updates"
	(updateStrm skip: -1; next) == Character cr ifFalse: [
		updateStrm nextPut: Character cr].
	updateStrm nextPutAll: add contents; nextPutAll: restOfText.

	myServers do: [:aServer |
		list doWithIndex: [:local :ind |
			file _ FileStream oldFileNamed: local.
			aServer putFile: file named: (newNames at: ind).
			file close].
		updateStrm reset.
		aServer putFile: updateStrm named: 'updates.list'.
		Transcript cr; show: 'Updates succeeded on server ', aServer moniker].
		
	Transcript cr; show: 'Be sure to test your new update!!'; cr.
	"rename the file locally (may fail)"
	file _ FileStream oldFileNamed: (list first).
	file close.
	list doWithIndex: [:local :ind |
		file directory rename: local toBe: (newNames at: ind)].
! !


!Utilities class methodsFor: 'fetching updates' stamp: 'di 6/30/1998 15:49'!
broadcastUpdatesFrom: n1 to: n2 except: skipList
"
	ChangeSorter removeChangeSetsNamedSuchThat:
		[:name | name first isDigit and: [name initialInteger > 412]].
	Utilities absorbUpdatesWriteFiles: true zapNums: false.
	Utilities broadcastUpdatesFrom: 413 to: 999 except: #().
"
	| fileNames fileNamesInOrder fileNamesUnnumbered names choice |
	names _ ServerDirectory groupNames asSortedArray.
	choice _ (SelectionMenu labelList: names selections: names) startUp.
	choice == nil ifTrue: [^ self].

	fileNames _ FileDirectory default fileNames select:
		[:n | n first isDigit
			and: [(n initialInteger between: n1 and: n2)
			and: [(skipList includes: n initialInteger) not]]].
	fileNamesInOrder _ fileNames asSortedCollection.
	fileNamesUnnumbered _ fileNamesInOrder collect:
		[:n | n copyFrom: (n findFirst: [:c | c isDigit not]) to: n size].
	fileNamesInOrder with: fileNamesUnnumbered do:
		[:n :nu | FileDirectory default rename: n toBe: nu].
	(ServerDirectory groupNamed: choice) putUpdateMulti: fileNamesUnnumbered
! !


