'From Squeak 2.5 of August 6, 1999 on 16 September 1999 at 5:18:49 pm'!
"Change Set:		WnldTweaks-ar
Date:			16 September 1999
Author:			Andreas Raab

Several tweaks for easier control in a Wonderland."!

ImageMorph subclass: #WonderlandCameraControls
	instanceVariableNames: 'myCamera myScheduler myUndoStack moveAction myMoveScale myRotationScale '
	classVariableNames: ''
	poolDictionaries: 'WonderlandConstants '
	category: 'Wonderland-Morphs'!

!WonderlandActor methodsFor: 'get property' stamp: 'ar 9/16/1999 16:30'!
getTexturePointer
	^myTexture! !


!WonderlandCameraControls methodsFor: 'camera control' stamp: 'ar 9/16/1999 16:36'!
moveCamera
	"Move the camera an amount and direction determined by the current position of the mouse and which modifier keys are held down."
	| offset dt |
	myMoveScale == nil ifTrue:[myMoveScale _ 0.1].
	myRotationScale == nil ifTrue:[myRotationScale _ 0.01].
	dt _ myScheduler getElapsedTime.
	offset _ (self center) - (0@8) - (Sensor mousePoint).

	(Sensor shiftPressed)
		ifTrue: [ (Sensor controlKeyPressed)
					ifTrue: [
						myCamera turnRightNow: up numberOfTurns: (dt * (offset y) * myRotationScale)
										undoable: false.
							]
					ifFalse: [
						myCamera moveRightNow: up distance: (dt * (offset y) * myMoveScale)
										undoable: false.
						myCamera moveRightNow: left distance: (dt * (offset x) * myMoveScale)
										undoable: false.
							].
				]
		ifFalse: [ (Sensor controlKeyPressed)
					ifTrue: [
						myCamera turnRightNow: left numberOfTurns: (dt * (offset x) * myRotationScale)
										undoable: false.
							]
					ifFalse: [
						myCamera moveRightNow: forward distance: (dt * (offset y) * myMoveScale)
										undoable: false.
						myCamera turnRightNow: left numberOfTurns: (dt * (offset x) * myRotationScale)
										undoable: false.
							].
				].
! !

!WonderlandCameraControls methodsFor: 'properties' stamp: 'ar 9/16/1999 16:36'!
getMoveScale
	^myMoveScale! !

!WonderlandCameraControls methodsFor: 'properties' stamp: 'ar 9/16/1999 16:36'!
getRotationScale
	^myRotationScale! !

!WonderlandCameraControls methodsFor: 'properties' stamp: 'ar 9/16/1999 16:36'!
setMoveScale: aNumber
	myMoveScale _ aNumber.! !

!WonderlandCameraControls methodsFor: 'properties' stamp: 'ar 9/16/1999 16:37'!
setRotationScale: aNumber
	myRotationScale _ aNumber.! !


!WonderlandCameraMorph methodsFor: 'controls' stamp: 'ar 9/16/1999 16:38'!
getCameraControls
	myControls == nil ifTrue:[
		self showCameraControls.
		self hideCameraControls.
	].
	^myControls! !

!WonderlandCameraMorph methodsFor: 'event handling' stamp: 'ar 9/16/1999 16:39'!
firstPersonKeystroke: evt
	"Handle a keyboard event"
	| keyValue |
	lastCursorPoint _ evt cursorPoint.
	keyValue _ evt keyValue.
	evt shiftPressed ifTrue:[
		keyValue = 28 ifTrue:[^myCamera move: left distance: 0.25].
		keyValue = 29 ifTrue:[^myCamera move: right distance: 0.25].
		keyValue = 30 ifTrue:[^myCamera move: forward distance: 0.25].
		keyValue = 31 ifTrue:[^myCamera move: backward distance: 0.25].
	] ifFalse:[
		keyValue = 28 ifTrue:[^myCamera turn: left turns:  0.0625 duration: 0.25 style: abruptly].
		keyValue = 29 ifTrue:[^myCamera turn: right turns:  0.0625 duration: 0.25 style: abruptly].
		keyValue = 30 ifTrue:[^myCamera move: forward].
		keyValue = 31 ifTrue:[^myCamera move: backward].
	].! !


