'From Squeak 2.5 of August 6, 1999 on 30 August 1999 at 1:44:30 pm'!
AlignmentMorph subclass: #Tetris
	instanceVariableNames: 'board scoreDisplay '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Games'!
!Tetris commentStamp: 'di 8/30/1999 13:44' prior: 0!
This is a port of JTetris.java 1.0.0.

How to start:
choose new morph.../Games/Tetris

How to play:
1) using buttons
2) using keyboard:
	drop - spacebar
	move to left - left arrow
	move to right - right arrow
	rotate clockwise - up arrow
	rotate anticlockwise - down arrow
NOTE: mouse must be over Tetris!


!Tetris methodsFor: 'access' stamp: 'am 8/22/1999 11:07'!
board

	board ifNil: [
		board _ TetrisBoard withScoreDisplay: self scoreDisplay.
	].
	^ board
! !

!Tetris methodsFor: 'access' stamp: 'am 8/22/1999 10:50'!
scoreDisplay

	scoreDisplay ifNil: [
		scoreDisplay _ LedMorph new
			digits: 4;
			extent: (4*10@15).
	].
	^ scoreDisplay
! !


!Tetris methodsFor: 'initialization' stamp: 'AM 8/2/1999 12:07'!
buildButton: aButton target: aTarget label: aLabel selector: aSelector
	"wrap a button or switch in an alignmentMorph to allow a row of buttons to fill space"

	| a |
	aButton 
		target: aTarget;
		label: aLabel;
		actionSelector: aSelector;
		borderColor: #raised;
		borderWidth: 2;
		color: color.
	a _ AlignmentMorph newColumn
		centering: #center;
		hResizing: #spaceFill;
		vResizing: #shrinkWrap;
		color: color.
	a addMorph: aButton.
	^ a

! !

!Tetris methodsFor: 'initialization' stamp: 'am 8/22/1999 10:55'!
initialize

	super initialize.
	color _ Color lightGray.
	orientation _ #vertical.
	centering _ #center.
	vResizing _ #shrinkWrap.
	hResizing _ #spaceFill.
	inset _ 3.
	self addMorph: self board.
	self addMorph: self showScoreDisplay.
	self addMorph: self makeMovementControls.
	self addMorph: self makeGameControls.
! !

!Tetris methodsFor: 'initialization' stamp: 'am 8/8/1999 15:10'!
makeGameControls

	| row but |
	row _ AlignmentMorph newRow
		color: color;
		borderWidth: 0;
		inset: 3.
	row hResizing: #spaceFill; vResizing: #shrinkWrap; centering: #center; extent: 5@5.
	row addMorph:
		(but _ self
			buildButton: SimpleButtonMorph new
			target: self
			label: 'Quit'
			selector: #delete).
	but setBalloonText: 'quit'.
	row addMorph:
		(but _ self
			buildButton: SimpleButtonMorph new
			target: self board
			label: 'Pause'
			selector: #pause).
	but setBalloonText: 'pause'.
	row addMorph:
		(but _ self
			buildButton: SimpleButtonMorph new
			target: self board
			label: 'New game'
			selector: #newGame).
	but setBalloonText: 'new game'.
	^ row
! !

!Tetris methodsFor: 'initialization' stamp: 'am 8/8/1999 13:56'!
makeMovementControls

	| row but |
	row _ AlignmentMorph newRow
		color: color;
		borderWidth: 0;
		inset: 3.
	row hResizing: #spaceFill; vResizing: #shrinkWrap; centering: #center; extent: 5@5.
	row addMorph:
		(but _ self
			buildButton: SimpleButtonMorph new
			target: self board
			label: '->'
			selector: #moveRight).
	but setBalloonText: 'move to the right'.
	row addMorph:
		(but _ self
			buildButton: SimpleButtonMorph new
			target: self board
			label: ' ) '
			selector: #rotateClockWise).
	but setBalloonText: 'rotate clockwise'.
	row addMorph:
		(but _ self
			buildButton: SimpleButtonMorph new
			target: self board
			label: ' | '
			selector: #drop).
	but setBalloonText: 'drop'.
	row addMorph:
		(but _ self
			buildButton: SimpleButtonMorph new
			target: self board
			label: ' ( '
			selector: #rotateAntiClockWise).
	but setBalloonText: 'rotate anticlockwise'.
	row addMorph:
		(but _ self
			buildButton: SimpleButtonMorph new
			target: self board
			label: '<-'
			selector: #moveLeft).
	but setBalloonText: 'move to the left'.
	^ row
! !

!Tetris methodsFor: 'initialization' stamp: 'am 8/22/1999 11:15'!
showScoreDisplay

	| row |
	row _ AlignmentMorph newRow
		color: color;
		borderWidth: 0;
		inset: 3.
	row hResizing: #rigid; vResizing: #shrinkWrap; centering: #center; extent: 5@5.
	row addMorph: (self wrapPanel: self scoreDisplay label: 'Score:').
	^ row
! !

!Tetris methodsFor: 'initialization' stamp: 'am 8/22/1999 11:12'!
wrapPanel: anLedPanel label: aLabel
	"wrap an LED panel in an alignmentMorph with a label to its left"

	| a |
	a _ AlignmentMorph newRow
		centering: #center;
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap;
		borderWidth: 0;
		inset: 3;
		color: color lighter.
	a addMorph: anLedPanel.
	a addMorph: (StringMorph contents: aLabel). 
	^ a

! !


!Tetris methodsFor: 'events' stamp: 'am 8/28/1999 14:22'!
handlesMouseOver: evt
	^ true
! !

!Tetris methodsFor: 'events' stamp: 'am 8/28/1999 14:21'!
keyStroke: evt
        | char |
        char _ evt keyCharacter.
        char asciiValue = 28 ifTrue: [board moveLeft].
        char asciiValue = 29 ifTrue: [board moveRight].
        char asciiValue = 30 ifTrue: [board rotateClockWise].
        char asciiValue = 31 ifTrue: [board rotateAntiClockWise].
        char asciiValue = 32 ifTrue: [board drop].
! !

!Tetris methodsFor: 'events' stamp: 'am 8/28/1999 14:22'!
mouseEnter: evt
        evt hand newKeyboardFocus: self
! !

!Tetris methodsFor: 'events' stamp: 'am 8/28/1999 14:22'!
mouseLeave: evt
        evt hand newKeyboardFocus: nil
! !
