'From Squeak 2.5 of August 6, 1999 [latest update: #1480] on 27 September 1999 at 12:39:24 pm'!
"Change Set:		alignmentMenu-sw
Date:			27 September 1999
Author:			Scott Wallace

Makes alignment items directly available in the various text menus; in the case of the morphic halo, it is packaged together with emphasis choice in the light-brown halo handle."!


!Morph methodsFor: 'accessing' stamp: 'sw 9/27/1999 12:24'!
balloonHelpTextForHandle: aHandle
	|  itsSelector |
	itsSelector _ aHandle eventHandler firstMouseSelector.
	#(	(startRot:with:				'Rotate')
		(startGrow:with:				'Change size') 
		(doDup:with:				'Duplicate')
		(maybeDoDup:with:			'Duplicate')
		(doGrab:with:				'Pick up')
		(startDrag:with:				'Move')
		(doMenu:with:				'Menu')
		(doDebug:with:				'Debug')
		(mouseDownOnHelpHandle:	'Help')
		(tearOffTile					'Make a Tile')
		(paintBackground			'Paint background')
		(openViewerForArgument	'View me')
		(dismiss						'Remove')
		(mouseDownInDimissHandle:with:	'Move to trash')
		(editDrawing				'Repaint')
		(startScale:with:				'Change scale') 
		(chooseFont					'Change font')
		(chooseStyle					'Change style')
		(chooseEmphasisOrAlignment	'Emphasis & alignment')
		(makeNewDrawingWithin	'Paint new object'))  "This last one not currently in use"


	do:
		[:pair | itsSelector == pair first ifTrue: [^ pair last]].
	^ 'unknown halo handle'! !

!Morph methodsFor: 'halos and balloon help' stamp: 'sw 9/27/1999 12:13'!
addFontHandlesTo: aHalo box: box
	"Add handles for controlling font, style, and emphasis choices to the halo"
	| s |
	s _ aHalo handleSize.
	aHalo addHandleAt: (box bottomLeft + ((s+2)@0))
		color: Color lightGreen on: #mouseDown send: #chooseFont to: self.
	aHalo addHandleAt: (box bottomLeft + ((s+2*2)@0))
		color: Color lightRed on: #mouseDown send: #chooseStyle to: self.
	aHalo addHandleAt: (box bottomRight - ((s+2)@0))
		color: Color lightBrown darker on: #mouseDown send: #chooseEmphasisOrAlignment to: self.

! !


!ParagraphEditor methodsFor: 'menu messages' stamp: 'sw 9/27/1999 11:42'!
changeEmphasisOrAlignment
	| aList reply  |
	aList _ #(plain bold italic narrow underlined struckOut leftFlush centered rightFlush justified).
	reply _ (SelectionMenu labelList: aList lines: #(6) selections: aList) startUp.
	reply ~~ nil ifTrue:
		[(#(leftFlush centered rightFlush justified) includes: reply)
			ifTrue:
				[paragraph perform: reply.
				self recomputeInterval]
			ifFalse:
				[self setEmphasis: reply.
				paragraph composeAll.
				self recomputeSelection.
				self mvcRedisplay]].
	^ true! !

!ParagraphEditor methodsFor: 'menu messages' stamp: 'sw 9/27/1999 11:54'!
chooseAlignment
	self changeAlignment! !

!ParagraphEditor methodsFor: 'menu messages' stamp: 'sw 9/27/1999 12:16'!
shiftedYellowButtonMenu
	"Answer the menu to be presented when the yellow button is pressed while the shift key is down"
	^ PopUpMenu labels: 
'set font... (k)
set style... (K)
set alignment...
explain
pretty print
file it in
recognizer (r)
spawn (o)
browse it (b)
senders of it (n)
implementors of it (m)
references to it (N)
selectors containing it (W)
method strings with it (E)
method source with it
special menu...
more...' 
		lines: #(3 8 15)
		selections: #(offerFontMenu changeStyle chooseAlignment explain prettyPrint fileItIn recognizeCharacters spawn browseIt sendersOfIt implementorsOfIt referencesToIt  methodNamesContainingIt methodStringsContainingit methodSourceContainingIt  presentSpecialMenu yellowButtonActivity)! !


!ParagraphEditor class methodsFor: 'class initialization' stamp: 'sw 9/27/1999 11:54'!
shiftedYellowButtonMenu
	"Answer the menu to be presented when the yellow button is pressed while the shift key is down"

	^ SelectionMenu labels: 
'set font... (k)
set style... (K)
set alignment...
explain
pretty print
file it in
recognizer (r)
spawn (o)
browse it (b)
senders of it (n)
implementors of it (m)
references to it (N)
selectors containing it (W)
method strings with it (E)
method source with it
special menu...
more...' 
		lines: #(3 8 15)
		selections: #(offerFontMenu changeStyle chooseAlignment explain prettyPrint fileItIn recognizeCharacters spawn browseIt sendersOfIt implementorsOfIt referencesToIt  methodNamesContainingIt methodStringsContainingit methodSourceContainingIt  presentSpecialMenu yellowButtonActivity)! !


!PluggableTextMorph methodsFor: 'menu commands' stamp: 'sw 9/27/1999 11:57'!
chooseAlignment
	self handleEdit: [textMorph editor changeAlignment]! !


!TextMorph methodsFor: 'editing' stamp: 'sw 9/27/1999 12:13'!
chooseEmphasisOrAlignment
	self editor changeEmphasisOrAlignment.
	self updateFromParagraph! !


