'From Squeak2.6 of 12 October 1999 [latest update: #1559] on 18 October 1999 at 10:48:04 pm'!
"Change Set:		MorphOpenFixes
Date:			18 October 1999
Author:			Dan Ingalls

A number of fixes so that open... opetions will work right in a morphic window in MVC.
"!


!Browser class methodsFor: 'instance creation' stamp: 'di 10/18/1999 22:03'!
new

	^super new systemOrganizer: SystemOrganization! !


!FileList class methodsFor: 'instance creation' stamp: 'di 10/18/1999 22:31'!
openEditorOn: aFileStream editString: editString
	"Open an editor on the given FileStream."
	| fileModel topView fileContentsView |
	World ifNotNil: [^ (self openMorphOn: aFileStream editString: editString) openInWorld ].

	fileModel _ FileList new setFileStream: aFileStream.	"closes the stream"
	topView _ StandardSystemView new.
	topView
		model: fileModel;
		label: aFileStream fullName;
		minimumSize: 180@120.
	topView borderWidth: 1.

	fileContentsView _ PluggableTextView on: fileModel 
		text: #contents accept: #put:
		readSelection: #contentsSelection menu: #fileContentsMenu:shifted:.
	fileContentsView window: (0@0 extent: 180@120).
	topView addSubView: fileContentsView.
	editString ifNotNil: [fileContentsView editString: editString.
			fileContentsView hasUnacceptedEdits: true].

	topView controller open.
! !

!FileList class methodsFor: 'instance creation' stamp: 'di 10/18/1999 22:34'!
openMorphOn: aFileStream editString: editString 
	"Open a morphic view of a FileList on the given file."
	| fileModel window fileContentsView |

	fileModel _ FileList new setFileStream: aFileStream.	"closes the stream"
	window _ (SystemWindow labelled: aFileStream fullName) model: fileModel.

	window addMorph: (fileContentsView _ PluggableTextMorph on: fileModel 
			text: #contents accept: #put:
			readSelection: #contentsSelection 
			menu: #fileContentsMenu:shifted:)
		frame: (0@0 corner: 1@1).
	editString ifNotNil: [fileContentsView editString: editString.
			fileContentsView hasUnacceptedEdits: true].

	^ window! !


!HandMorph methodsFor: 'world menu' stamp: 'di 10/18/1999 22:38'!
openMenu
	"Build the open window menu for the world."
	| menu |
	menu _ (MenuMorph entitled: 'open...') defaultTarget: self.
	menu addStayUpItem.
	menu add: 'browser' action: #openBrowser.
	menu add: 'workspace' action: #openWorkspace.
	menu add: 'file list' action: #openFileList.
	menu add: 'file...' action: #openFileDirectly.
	menu add: 'transcript' action: #openTranscript.
	menu add: 'selector finder' action: #openSelectorBrowser.
	menu addLine.
	menu add: 'simple change sorter' selector: #openChangeSorter: argument: 1.
	menu add: 'dual change sorter' selector: #openChangeSorter: argument: 2.
	menu addLine.
	menu add: 'email reader' action: #openEmail.
	menu add: 'web browser' action: #openWebBrowser.
	menu add: 'IRC chat' action: #openIRC.
	menu addLine.
	(Preferences allowMVCprojects and: [Smalltalk includesKey: #StandardSystemView])
		ifTrue: [menu add: 'project (mvc)' action: #openMVCProject].
	menu add: 'project (morphic)' action: #openMorphicProject.
	menu add: 'project (construction)' action: #openConstructionProject.
	^ menu
! !

!HandMorph methodsFor: 'world menu commands' stamp: 'di 10/18/1999 22:24'!
openBrowser
	(Browser new openAsMorphEditing: nil)
		setLabel: 'System Browser';
		openInWorld: self world! !

!HandMorph methodsFor: 'world menu commands' stamp: 'di 10/18/1999 22:44'!
openChangeSorter: oneOrTwo
	oneOrTwo = 1
		ifTrue: [ChangeSorter new morphicWindow openInWorld: self world]
		ifFalse: [DualChangeSorter new morphicWindow openInWorld: self world]! !

!HandMorph methodsFor: 'world menu commands' stamp: 'di 10/18/1999 22:33'!
openFileDirectly
	| file |
	(file _ StandardFileMenu oldFile) ifNotNil:
		[(FileList openMorphOn: (file directory readOnlyFileNamed: file name) editString: nil)
			openInWorld: self world]! !

!HandMorph methodsFor: 'world menu commands' stamp: 'di 10/18/1999 22:12'!
openSelectorBrowser
	SelectorBrowser new morphicWindow openInWorld: self world! !

!HandMorph methodsFor: 'world menu commands' stamp: 'di 10/18/1999 22:39'!
openTranscript
	(Transcript openAsMorphLabel: 'Transcript')
		openInWorld: self world! !


