'From Squeak2.6 of 11 October 1999 [latest update: #1587] on 31 October 1999 at 12:49:20 am'!
"Change Set:		mvcSmartUpdating
Date:			31 October 1999
Author:			Scott Wallace

Brings the smart-updating features (implemented earlier for morphic) to the primary mvc tools, viz. browsers and inspectors. 

The updating takes place automatically when you activate a window -- but of course if there are unsubmitted changes in the window, they will not be discarded; instead, you will get a warning of the conflict when you try to submit.

MVC tools benefitting from this update are: the standard browsers (system, system-category, class, message-category), all message-list browsers, and versions browsers, and Inspectors.

In the case of Inspectors, note that the field list is updated *and* the value pane is updated when the window is activated.

Tools that do *not* yet incorporate the smart-updating include:

	protocol browsers
	hierarchy browsers
	inheritance browsers

Incidentally fixed in this update:

*  cmd-f shortcut for find-class in the sys-category-list pane now works."!

ListView subclass: #PluggableListView
	instanceVariableNames: 'getListSelector getSelectionSelector setSelectionSelector getMenuSelector getMenuTitleSelector keystrokeActionSelector autoDeselect items '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Interface-Pluggable'!
StringHolderView subclass: #PluggableTextView
	instanceVariableNames: 'getTextSelector setTextSelector getSelectionSelector getMenuSelector hasEditingConflicts '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Interface-Pluggable'!
View subclass: #StandardSystemView
	instanceVariableNames: 'labelFrame labelText isLabelComplemented savedSubViews minimumSize maximumSize collapsedViewport expandedViewport labelBits windowBits bitsValid updatablePanes '
	classVariableNames: 'CacheBits LabelStyle '
	poolDictionaries: ''
	category: 'Interface-Support'!

!Browser methodsFor: 'initialize-release' stamp: 'sw 10/29/1999 21:41'!
openEditString: aString
	"Create a pluggable version of all the views for a Browser, including views and controllers."
	| systemCategoryListView classListView 
	messageCategoryListView messageListView browserCodeView topView switchView |

	World ifNotNil: [^ self openAsMorphEditing: aString].
	"Sensor leftShiftDown ifTrue: [^ self openAsMorphEditing: aString].
		uncomment-out for testing morphic browser embedded in mvc project"

	topView _ StandardSystemView new model: self.
	topView borderWidth: 1. "label and minSize taken care of by caller"

	systemCategoryListView _ PluggableListView on: self
		list: #systemCategoryList
		selected: #systemCategoryListIndex
		changeSelected: #systemCategoryListIndex:
		menu: #systemCategoryMenu:
		keystroke: #systemCatListKey:from:.
	systemCategoryListView window: (0 @ 0 extent: 50 @ 70).
	topView addSubView: systemCategoryListView.

	classListView _ PluggableListView on: self
		list: #classList
		selected: #classListIndex
		changeSelected: #classListIndex:
		menu: #classListMenu:
		keystroke: #classListKey:from:.
	classListView window: (0 @ 0 extent: 50 @ 62).
	topView addSubView: classListView toRightOf: systemCategoryListView.

	switchView _ self buildInstanceClassSwitchView.
	switchView borderWidth: 1.
	topView addSubView: switchView below: classListView.

	messageCategoryListView _ PluggableListView on: self
		list: #messageCategoryList
		selected: #messageCategoryListIndex
		changeSelected: #messageCategoryListIndex:
		menu: #messageCategoryMenu:.
	messageCategoryListView window: (0 @ 0 extent: 50 @ 70).
	topView addSubView: messageCategoryListView toRightOf: classListView.

	messageListView _ PluggableListView on: self
		list: #messageList
		selected: #messageListIndex
		changeSelected: #messageListIndex:
		menu: #messageListMenu:shifted:
		keystroke: #messageListKey:from:.
	messageListView window: (0 @ 0 extent: 50 @ 70).
	messageListView menuTitleSelector: #messageListSelectorTitle.
	topView addSubView: messageListView toRightOf: messageCategoryListView.

	browserCodeView _ PluggableTextView on: self 
			text: #contents accept: #contents:notifying:
			readSelection: #contentsSelection menu: #codePaneMenu:shifted:.
	browserCodeView window: (0@0 extent: 200@110).
	topView addSubView: browserCodeView below: systemCategoryListView.
	aString ifNotNil: [browserCodeView editString: aString.
			browserCodeView hasUnacceptedEdits: true].
	topView setUpdatablePanesFrom: #(systemCategoryList classList messageCategoryList messageList).

	^ topView
! !

!Browser methodsFor: 'initialize-release' stamp: 'sw 10/29/1999 20:31'!
openMessageCatEditString: aString
	"Create a pluggable version of the views for a Browser that just shows one message category."
	| messageCategoryListView messageListView browserCodeView topView |

	World ifNotNil: [^ self openAsMorphMsgCatEditing: aString].

	topView _ (StandardSystemView new) model: self.
	topView borderWidth: 1.
		"label and minSize taken care of by caller"

	messageCategoryListView _ PluggableListView on: self
		list: #messageCatListSingleton
		selected: #indexIsOne 
		changeSelected: #indexIsOne:
		menu: #messageCategoryMenu:.
	messageCategoryListView window: (0 @ 0 extent: 200 @ 12).
	topView addSubView: messageCategoryListView.

	messageListView _ PluggableListView on: self
		list: #messageList
		selected: #messageListIndex
		changeSelected: #messageListIndex:
		menu: #messageListMenu:shifted:
		keystroke: #messageListKey:from:.
	messageListView menuTitleSelector: #messageListSelectorTitle.
	messageListView window: (0 @ 0 extent: 200 @ 70).
	topView addSubView: messageListView below: messageCategoryListView.

	browserCodeView _ PluggableTextView on: self 
			text: #contents accept: #contents:notifying:
			readSelection: #contentsSelection menu: #codePaneMenu:shifted:.
	browserCodeView window: (0@0 extent: 200@(200-12-70)).
	topView addSubView: browserCodeView below: messageListView.
	aString ifNotNil: [browserCodeView editString: aString.
			browserCodeView hasUnacceptedEdits: true].
	topView setUpdatablePanesFrom: #(messageCatListSingleton messageList).
	^ topView
! !

!Browser methodsFor: 'initialize-release' stamp: 'sw 10/29/1999 20:30'!
openOnClassWithEditString: aString
	"Create a pluggable version of all the views for a Browser, including views and controllers."
	| classListView messageCategoryListView messageListView browserCodeView topView switchView |

	World ifNotNil: [^ self openAsMorphClassEditing: aString].

	topView _ (StandardSystemView new) model: self.
	topView borderWidth: 1.
		"label and minSize taken care of by caller"

	classListView _ PluggableListView on: self
		list: #classListSingleton
		selected: #indexIsOne 
		changeSelected: #indexIsOne:
		menu: #classListMenu:
		keystroke: #classListKey:from:.
	classListView window: (0 @ 0 extent: 100 @ 12).
	topView addSubView: classListView.

	messageCategoryListView _ PluggableListView on: self
		list: #messageCategoryList
		selected: #messageCategoryListIndex
		changeSelected: #messageCategoryListIndex:
		menu: #messageCategoryMenu:.
	messageCategoryListView window: (0 @ 0 extent: 100 @ 70).
	topView addSubView: messageCategoryListView below: classListView.

	messageListView _ PluggableListView on: self
		list: #messageList
		selected: #messageListIndex
		changeSelected: #messageListIndex:
		menu: #messageListMenu:shifted:
		keystroke: #messageListKey:from:.
	messageListView menuTitleSelector: #messageListSelectorTitle.
	messageListView window: (0 @ 0 extent: 100 @ 70).
	topView addSubView: messageListView toRightOf: messageCategoryListView.

	switchView _ self buildInstanceClassSwitchView.
	switchView borderWidth: 1.
	switchView 
		window: switchView window 
		viewport: (classListView viewport topRight 
					corner: messageListView viewport topRight).
	topView addSubView: switchView toRightOf: classListView.

	browserCodeView _ PluggableTextView on: self 
			text: #contents accept: #contents:notifying:
			readSelection: #contentsSelection menu: #codePaneMenu:shifted:.
	browserCodeView window: (0@0 extent: 200@(200-12-70)).
	topView addSubView: browserCodeView below: messageCategoryListView.
	aString ifNotNil: [browserCodeView editString: aString.
			browserCodeView hasUnacceptedEdits: true].

	topView setUpdatablePanesFrom: #(messageCategoryList messageList).
	^ topView
! !

!Browser methodsFor: 'initialize-release' stamp: 'sw 10/29/1999 20:34'!
openSystemCatEditString: aString
	"Create a pluggable version of all the views for a Browser, including views and controllers.  The top list view is of the currently selected system class category--a single item list."
	| systemCategoryListView classListView messageCategoryListView messageListView browserCodeView topView switchView |

	World ifNotNil: [^ self openAsMorphSysCatEditing: aString].

	topView _ (StandardSystemView new) model: self.
	topView borderWidth: 1.
		"label and minSize taken care of by caller"

	systemCategoryListView _ PluggableListView on: self
		list: #systemCategorySingleton
		selected: #indexIsOne 
		changeSelected: #indexIsOne:
		menu: #systemCategoryMenu:
		keystroke: #systemCatListKey:from:.
	systemCategoryListView window: (0 @ 0 extent: 200 @ 12).
	topView addSubView: systemCategoryListView.

	classListView _ PluggableListView on: self
		list: #classList
		selected: #classListIndex
		changeSelected: #classListIndex:
		menu: #classListMenu:
		keystroke: #classListKey:from:.
	classListView window: (0 @ 0 extent: 67 @ 62).
	topView addSubView: classListView below: systemCategoryListView.

	messageCategoryListView _ PluggableListView on: self
		list: #messageCategoryList
		selected: #messageCategoryListIndex
		changeSelected: #messageCategoryListIndex:
		menu: #messageCategoryMenu:.
	messageCategoryListView window: (0 @ 0 extent: 66 @ 70).
	topView addSubView: messageCategoryListView toRightOf: classListView.

	switchView _ self buildInstanceClassSwitchView.
	switchView 
		window: switchView window 
		viewport: (classListView viewport bottomLeft 
					corner: messageCategoryListView viewport bottomLeft).
	switchView borderWidth: 1.
	topView addSubView: switchView below: classListView.

	messageListView _ PluggableListView on: self
		list: #messageList
		selected: #messageListIndex
		changeSelected: #messageListIndex:
		menu: #messageListMenu:shifted:
		keystroke: #messageListKey:from:.
	messageListView menuTitleSelector: #messageListSelectorTitle.
	messageListView window: (0 @ 0 extent: 67 @ 70).
	topView addSubView: messageListView toRightOf: messageCategoryListView.

	browserCodeView _ PluggableTextView on: self 
			text: #contents accept: #contents:notifying:
			readSelection: #contentsSelection menu: #codePaneMenu:shifted:.
	browserCodeView window: (0@0 extent: 200@(110-12)).
	topView addSubView: browserCodeView below: switchView.
	aString ifNotNil: [browserCodeView editString: aString.
			browserCodeView hasUnacceptedEdits: true].
	topView setUpdatablePanesFrom: #(classList messageCategoryList messageList).
	^ topView
! !



!Inspector class methodsFor: 'instance creation' stamp: 'sw 10/29/1999 20:36'!
openOn: anObject withEvalPane: withEval withLabel: label valueViewClass: valueViewClass
	| topView inspector listView valueView evalView |
	World ifNotNil:
		[^ self openAsMorphOn: anObject withEvalPane: withEval
			withLabel: label valueViewClass: valueViewClass].
	inspector _ self inspect: anObject.
	topView _ StandardSystemView new model: inspector.
	topView borderWidth: 1.

	listView _ PluggableListView on: inspector
		list: #fieldList
		selected: #selectionIndex
		changeSelected: #toggleIndex:
		menu: #fieldListMenu:
		keystroke: #inspectorKey:from:.
	(inspector isMemberOf: DictionaryInspector)
		ifTrue: [listView menu: #dictionaryMenu:].
	listView window: (0 @ 0 extent: 40 @ 40).
	topView addSubView: listView.

	valueView _ valueViewClass new.
		"PluggableTextView or PluggableFormView"
	(valueView respondsTo: #getText) ifTrue: [
		valueView on: inspector 
			text: #contents accept: #accept:
			readSelection: #contentsSelection menu: #codePaneMenu:shifted:].
	(valueViewClass inheritsFrom: FormView) ifTrue: [
		valueView model: inspector].
	valueView window: (0 @ 0 extent: 75 @ 40).
	topView addSubView: valueView toRightOf: listView.
	
	withEval ifTrue:
		[evalView _ PluggableTextView new on: inspector 
			text: #trash accept: #trash:
			readSelection: #contentsSelection menu: #codePaneMenu:shifted:.
		evalView window: (0 @ 0 extent: 115 @ 20).
		evalView askBeforeDiscardingEdits: false.
		topView addSubView: evalView below: listView].
	topView label: label.
	topView minimumSize: 180 @ 120.
	topView setUpdatablePanesFrom: #(fieldList).
	topView controller open! !


!MessageSet class methodsFor: 'instance creation' stamp: 'sw 10/29/1999 20:18'!
open: aMessageSet name: aString 
	"Create a standard system view for the messageSet, aMessageSet, whose label is aString."
	| topView aListView aBrowserCodeView aTextView |

	World ifNotNil: [^ self openAsMorph: aMessageSet name: aString].

	topView _ (StandardSystemView new) model: aMessageSet.
	topView label: aString.
	topView minimumSize: 180 @ 120.
	topView borderWidth: 1.

	aListView _ PluggableListView on: aMessageSet
		list: #messageList
		selected: #messageListIndex
		changeSelected: #messageListIndex:
		menu: #messageListMenu:shifted:
		keystroke: #messageListKey:from:.
	aListView  menuTitleSelector: #messageListSelectorTitle.
	aListView window: (0 @ 0 extent: 180 @ 100).
	topView addSubView: aListView.

	Preferences useAnnotationPanes ifTrue:
			[aTextView _ PluggableTextView on: aMessageSet 
			text: #annotation accept: nil
			readSelection: nil menu: nil.
			aTextView window: (0 @ 0 extent: 180 @ 24).
			topView addSubView: aTextView below: aListView.
			aTextView askBeforeDiscardingEdits: false].

	aBrowserCodeView _ PluggableTextView on: aMessageSet 
			text: #contents accept: #contents:notifying:
			readSelection: #contentsSelection menu: #codePaneMenu:shifted:.
	aBrowserCodeView window: (0 @ 0 extent: 180 @ 300).
	topView addSubView: aBrowserCodeView below: (aTextView ifNil: [aListView]).
	topView setUpdatablePanesFrom: #(messageList).
	topView controller open! !


!Paragraph methodsFor: 'accessing' stamp: 'sw 10/29/1999 18:11'!
stringAtLineNumber: aNumber
	(aNumber > lastLine or: [aNumber < 1]) ifTrue: [^ nil].
	^ (text string copyFrom: (lines at: aNumber) first to: (lines at: aNumber) last) copyWithout: Character cr! !


!PluggableListView methodsFor: 'initialization' stamp: 'sw 10/29/1999 20:07'!
list: arrayOfStrings
	"Set the receivers items to be the given list of strings
	The instance variable 'items' holds the original list. The instance variable 'list' is a paragraph constructed from this list."

	((items == arrayOfStrings) "fastest" or: [items = arrayOfStrings]) ifTrue: [^ self].
	items _ arrayOfStrings.
	isEmpty _ arrayOfStrings isEmpty.

	"add top and bottom delimiters"
	list _ ListParagraph
		withArray:
			(Array streamContents: [:s |
				s nextPut: topDelimiter.
				arrayOfStrings do: [:item | item == nil ifFalse: [s nextPut: item]].
				s nextPut: bottomDelimiter])
		 style: textStyle.

	selection _ self getCurrentSelectionIndex.
	self positionList.! !

!PluggableListView methodsFor: 'updating' stamp: 'sw 10/31/1999 00:04'!
verifyContents
	| newItems existingSelection anIndex |
	"Called on window reactivation to react to possible structural changes.  Update contents if necessary."

	newItems _ self getList.
	((items == newItems) "fastest" or: [items = newItems]) ifTrue: [^ self].
	self flash.  "list has changed beneath us; could get annoying, but hell"
	existingSelection _ list stringAtLineNumber: (selection + 1).  "account for cursed ------ row"
	self list: newItems.
	(newItems size > 0 and: [newItems first isKindOf: Symbol]) ifTrue:
		[existingSelection _ existingSelection asSymbol].
	(anIndex _ newItems indexOf: existingSelection ifAbsent: [nil])
		ifNotNil:
			[model noteSelectionIndex: anIndex for: getListSelector.
			self update: getSelectionSelector.
			self topView displayEmphasized]
		ifNil:
			[self changeModelSelection: 0]
! !

!PluggableListView methodsFor: 'object fileIn' stamp: 'sw 10/29/1999 20:25'!
convertmcsstvwdibbiblstbitggsggka0: varDict mcsstvwdibbiblstbitggsggkai0: smartRefStrm
	"These variables are automatically stored into the new instance ('getListSelector' 'getSelectionSelector' 'setSelectionSelector' 'getMenuSelector' 'getMenuTitleSelector' 'keystrokeActionSelector' 'autoDeselect' ).
	This method is for additional changes. Use statements like (foo _ varDict at: 'foo')."

	"New variables: ('items' )  If a non-nil value is needed, please assign it."
! !


!PluggableTextController methodsFor: 'as yet unclassified' stamp: 'sw 10/29/1999 21:08'!
accept 
	view hasUnacceptedEdits ifFalse: [^ view flash].
	view hasEditingConflicts ifTrue:
		[(self confirm: 'Caution!! This method has been changed elsewhere
since you started editing it here.  Accept anyway?') ifFalse: [^ self flash]].

	(view setText: paragraph text from: self) ifTrue:
		[initialText _ paragraph text copy.
		view ifNotNil: [view hasUnacceptedEdits: false]]    .
! !


!PluggableTextView methodsFor: 'initialization' stamp: 'sw 10/29/1999 21:02'!
initialize 
	super initialize.
	hasEditingConflicts _ false! !

!PluggableTextView methodsFor: 'updating' stamp: 'sw 10/29/1999 21:03'!
hasEditingConflicts
	"Return true if a conflicting edit to the same code (typically) is known to have occurred after the current contents started getting edited"

	^ hasEditingConflicts == true! !

!PluggableTextView methodsFor: 'updating' stamp: 'sw 10/29/1999 21:04'!
hasEditingConflicts: aBoolean
	hasEditingConflicts _ aBoolean! !

!PluggableTextView methodsFor: 'updating' stamp: 'sw 10/29/1999 21:04'!
hasUnacceptedEdits: aBoolean
	super hasUnacceptedEdits: aBoolean.
	aBoolean ifFalse: [hasEditingConflicts _ false]! !

!PluggableTextView methodsFor: 'updating' stamp: 'sw 10/29/1999 21:15'!
update: aSymbol
	"Refer to the comment in View|update:. Do nothing if the given symbol does not match any action. "

	aSymbol == #wantToChange ifTrue:
			[self canDiscardEdits ifFalse: [self promptForCancel].  ^ self].
	aSymbol == #flash ifTrue: [^ controller flash].
	aSymbol == getTextSelector ifTrue: [^ self updateDisplayContents].
	aSymbol == getSelectionSelector ifTrue: [^ self setSelection: self getSelection].
	aSymbol == #clearUserEdits ifTrue: [^ self hasUnacceptedEdits: false].
	(aSymbol == #autoSelect and: [getSelectionSelector ~~ nil]) ifTrue:
			[^ controller setSearch: model autoSelectString;
					againOrSame: true].
	aSymbol == #appendEntry ifTrue:
			[^ controller doOccluded: [controller appendEntry]].
	aSymbol == #clearText ifTrue:
			[^ controller doOccluded:
				[controller changeText: Text new]].
	aSymbol == #codeChangedElsewhere ifTrue:
			[^ self hasEditingConflicts: true]

! !

!PluggableTextView methodsFor: 'object fileIn' stamp: 'sw 10/29/1999 21:05'!
convertmcsstvwdibbibdhagsgg0: varDict mcsstvwdibbibdhagsggh0: smartRefStrm
	"These variables are automatically stored into the new instance ('getTextSelector' 'setTextSelector' 'getSelectionSelector' 'getMenuSelector' ).
	This method is for additional changes. Use statements like (foo _ varDict at: 'foo')."

	"New variables: ('hasEditingConflicts' )  If a non-nil value is needed, please assign it."
	hasEditingConflicts _ false
! !


!StandardSystemView methodsFor: 'initialize-release' stamp: 'sw 10/29/1999 12:58'!
initialize 
	"Refer to the comment in View|initialize."
	super initialize.
	labelFrame _ Quadrangle new.
	labelFrame region: (Rectangle origin: 0 @ 0 extent: 50 @ self labelHeight).
	labelFrame borderWidthLeft: 2 right: 2 top: 2 bottom: 2.
	self label: nil.
	isLabelComplemented _ false.
	minimumSize _ 50 @ 50.
	maximumSize _ Display extent.
	collapsedViewport _ nil.
	expandedViewport _ nil.
	bitsValid _ false.
	updatablePanes _ #()! !

!StandardSystemView methodsFor: 'updating' stamp: 'sw 10/29/1999 12:57'!
setUpdatablePanesFrom: getSelectors
	| aList aPane |
	"Set my updatablePanes inst var to the list of panes which are list panes with the given get-list selectors.  Order is important here!!  Note that the method is robust in the face of panes not found, but a warning is printed in the transcript in each such case"

	aList _ OrderedCollection new.
	getSelectors do:
		[:sel | aPane _ self subViewSatisfying:
				[:pane | (pane isKindOf: PluggableListView) and: [pane getListSelector == sel]].
			aPane
				ifNotNil:
					[aList add: aPane]
				ifNil:
					[Transcript cr; show: 'Warning: view ', sel, ' not found.']].
	updatablePanes _ aList asArray! !

!StandardSystemView methodsFor: 'updating' stamp: 'sw 10/29/1999 21:20'!
updatablePanes
	"Answer the list of panes, in order, which might be sent the #verifyContents message upon window activation or expansion."
	^ updatablePanes ifNil: [updatablePanes _ #()]! !

!StandardSystemView methodsFor: 'object fileIn' stamp: 'sw 10/29/1999 20:28'!
convertmcsstvwdibbibllismmcelwb0: varDict mcsstvwdibbibllismmcelwbu0: smartRefStrm
	"These variables are automatically stored into the new instance ('labelFrame' 'labelText' 'isLabelComplemented' 'savedSubViews' 'minimumSize' 'maximumSize' 'collapsedViewport' 'expandedViewport' 'labelBits' 'windowBits' 'bitsValid' ).
	This method is for additional changes. Use statements like (foo _ varDict at: 'foo')."

	"New variables: ('updatablePanes' )  If a non-nil value is needed, please assign it."
	updatablePanes _ #()
! !


Inspector removeSelector: #updateListsAndCodeIn:!
PluggableListView removeSelector: #selectionIndex:!
