'From Squeak2.7 of 5 January 2000 [latest update: #1799] on 28 January 2000 at 10:37:36 am'!
"Change Set:		haloRework-sw
Date:			28 January 2000
Author:			Scott Wallace

A substantial reworking of morphic halos.

*   A variety of changes to address the problem of getting the halo for the right object.  Successive cmd-clicks now march the haloee inward one level per click, but always skipping unlikely layers, and never crossing a window boundary.  Successive cmd-shift-clicks start at the innermost  morph and work their way outward, hitting every layer. 

*	Actual halo placements are now parameterized, so that there is a straightforward way that individual users can rearrange the locations and indeed the presence/absense of their halos.

*	Four alternative halo schemes are offered, including, as the new default, graphical designs courtesy of Bert Freudenberg and David Smith, and with code contributions from Bert.

*	For SketchMorphs, there is now a 'forward direction' arrow available which allows setting of the forward direction and also of the center-of-rotation.

*  Adds an alternative 'simple' form of halos for youngest users.

*  A reworking of the preferences involving halos.


"!

Object subclass: #HaloSpec
	instanceVariableNames: 'addHandleSelector horizontalPlacement verticalPlacement color iconSymbol '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Widgets'!
Morph subclass: #HaloMorph
	instanceVariableNames: 'target innerTarget positionOffset angleOffset minExtent growingOrRotating directionArrowAnchor haloBox simpleMode '
	classVariableNames: 'HandleSize '
	poolDictionaries: ''
	category: 'Morphic-Widgets'!

!Color methodsFor: 'conversions' stamp: 'bf 10/13/1999 14:22'!
makeForegroundColor
        "Make a foreground color contrasting with me"
        ^self luminance >= "Color red luminance" 0.299
                ifTrue: [Color black]
                ifFalse: [Color white]! !


!HaloSpec methodsFor: 'as yet unclassified' stamp: 'sw 1/25/2000 19:54'!
addHandleSelector
	^ addHandleSelector! !

!HaloSpec methodsFor: 'as yet unclassified' stamp: 'sw 1/25/2000 18:41'!
color
	^ color! !

!HaloSpec methodsFor: 'as yet unclassified' stamp: 'sw 1/25/2000 18:41'!
horizontalPlacement
	^ horizontalPlacement! !

!HaloSpec methodsFor: 'as yet unclassified' stamp: 'sw 1/25/2000 19:54'!
horizontalPlacement: hp verticalPlacement: vp color: col iconSymbol: is addHandleSelector: sel
	horizontalPlacement _ hp.
	verticalPlacement _ vp.
	color_ col.
	iconSymbol _ is asSymbol.
	addHandleSelector _ sel! !

!HaloSpec methodsFor: 'as yet unclassified' stamp: 'sw 1/25/2000 18:41'!
iconSymbol
	^ iconSymbol! !

!HaloSpec methodsFor: 'as yet unclassified' stamp: 'sw 1/25/2000 18:41'!
verticalPlacement
	^ verticalPlacement! !


!Morph methodsFor: 'accessing' stamp: 'sw 1/27/2000 19:22'!
balloonHelpTextForHandle: aHandle
	|  itsSelector |
	itsSelector _ aHandle eventHandler firstMouseSelector.
	#(	(addFullHandles							'More halo handles')
		(addSimpleHandles						'Fewer halo handles')
		(chooseEmphasisOrAlignment				'Emphasis & alignment')
		(chooseFont								'Change font')
		(chooseStyle								'Change style')
		(dismiss									'Remove')
		(doDebug:with:							'Debug')
		(doDirection:with:						'Choose forward direction')
		(doDup:with:							'Duplicate')
		(doMenu:with:							'Menu')
		(doGrab:with:							'Pick up')
		(doRecolor:with:							'Change color')
		(editDrawing							'Repaint')
		(maybeDoDup:with:						'Duplicate')
		(makeNascentScript						'Make a scratch script')
		(makeNewDrawingWithin				'Paint new object')
		(mouseDownInDimissHandle:with:			'Move to trash')
		(mouseDownOnHelpHandle:				'Help')
		(openViewerForArgument				'Open a Viewer for me')
		(paintBackground						'Paint background')
		(prepareToTrackCenterOfRotation:with:	'Set center of rotation')
		(startDrag:with:							'Move')
		(startGrow:with:							'Change size') 
		(startRot:with:							'Rotate')
		(startScale:with:							'Change scale') 
		(tearOffTile								'Make a tile representing this object')
		(trackCenterOfRotation:with:				'Set center of rotation')) 


	do:
		[:pair | itsSelector == pair first ifTrue: [^ pair last]].

	^ 'unknown halo handle'! !

!Morph methodsFor: 'structure' stamp: 'sw 12/29/1999 12:27'!
hasInOwnerChain: aMorph
	"If aMorph is somewhere in the receiver's owner chain, respond true"
	self eachStepInOwnerChainDo:
		[:anOwner | anOwner == aMorph ifTrue: [^ true]].
	^ false! !

!Morph methodsFor: 'submorphs-accessing' stamp: 'sw 10/26/1999 23:42'!
submorphThat: block1 ifNone: block2
	^ submorphs detect: [:m | (block1 value: m) == true] ifNone: [block2 value]
	! !

!Morph methodsFor: 'geometry eToy' stamp: 'sw 1/17/2000 20:52'!
cartesianXY
	"Answer the receiver's x-y cartesian coordinates"
	^ self x @ self y
! !

!Morph methodsFor: 'geometry eToy' stamp: 'sw 1/17/2000 20:55'!
cartesianXY: coords
	^ self x: coords x y: coords y
! !

!Morph methodsFor: 'geometry eToy' stamp: 'sw 1/17/2000 20:04'!
x: xCoord y: yCoord
	| aWorld xyOffset delta aPlayfield |
	(aWorld _ self world) ifNil: [^ self position: xCoord @ yCoord].
	xyOffset _ self topLeft - self referencePosition.
	delta _ (aPlayfield _ self referencePlayfield)
		ifNil:
			[xCoord @ (aWorld bottom - yCoord)]
		ifNotNil:
			[aPlayfield cartesianOrigin + (xCoord @ (yCoord negated))].
	self position: (xyOffset + delta)
! !

!Morph methodsFor: 'menus' stamp: 'sw 1/18/2000 00:03'!
addPaintingItemsTo: aMenu hand: aHandMorph
	| subMenu movies |
	subMenu _ MenuMorph new defaultTarget: self.

	subMenu add: 'repaint' action: #editDrawing.
	self couldSetRotationCenterFromHalo ifTrue:
		[subMenu add: 'set rotation center' action: #setRotationCenter].
	subMenu add: 'reset forward-direction' action: #resetForwardDirection.
	subMenu add: 'set rotation style' action: #setRotationStyle.
	subMenu add: 'erase pixels of color' action: #erasePixelsOfColor:.
	subMenu add: 'recolor of pixels of color' action: #recolorPixelsOfColor:.
	movies _
		(self world rootMorphsAt: aHandMorph targetOffset)
			select: [:m | (m isKindOf: MovieMorph) or:
						[m isKindOf: SketchMorph]].
	(movies size > 1) ifTrue:
		[subMenu add: 'insert into movie' action: #insertIntoMovie:].
	aMenu add: 'painting...' subMenu: subMenu! !

!Morph methodsFor: 'menus' stamp: 'sw 10/29/1999 15:34'!
makeNascentScript
	^ self notYetImplemented! !

!Morph methodsFor: 'halos and balloon help' stamp: 'sw 1/26/2000 16:33'!
addHandlesTo: aHaloMorph box: box
	aHaloMorph haloBox: box.
	Preferences haloSpecifications do:
		[:aSpec | 
			aHaloMorph perform: aSpec addHandleSelector with: aSpec].
	aHaloMorph innerTarget addOptionalHandlesTo: aHaloMorph box: box! !

!Morph methodsFor: 'halos and balloon help' stamp: 'sw 12/21/1999 17:52'!
addSimpleHandlesTo: aHaloMorph box: aBox
	^ aHaloMorph addSimpleHandlesTo: aHaloMorph box: aBox! !

!Morph methodsFor: 'halos and balloon help' stamp: 'sw 1/26/2000 19:37'!
addWorldHandlesTo: aHaloMorph box: box
	aHaloMorph haloBox: box.
	Preferences haloSpecificationsForWorld do:
		[:aSpec | 
			aHaloMorph perform: aSpec addHandleSelector with: aSpec].
	aHaloMorph innerTarget addOptionalHandlesTo: aHaloMorph box: box! !

!Morph methodsFor: 'halos and balloon help' stamp: 'sw 1/11/2000 18:24'!
defersHaloOnClickTo: aSubMorph
	"If a cmd-click on aSubMorph would make it a preferred recipient of the halo, answer true"
	"May want to add a way (via a property) for morphs to assert true here -- this would let certain kinds of morphs that are unusually reluctant to take the halo on initial click"

	^ false
	! !

!Morph methodsFor: 'halos and balloon help' stamp: 'sw 12/30/1999 19:51'!
seeksOutHalo
	"Answer whether the receiver is an eager recipient of the halo"
	^ true! !

!Morph methodsFor: 'halos and balloon help' stamp: 'sw 10/29/1999 17:38'!
setCenteredBalloonText: aString
	self setBalloonText: aString.
	self setProperty: #helpAtCenter toValue: true! !

!Morph methodsFor: 'halos and balloon help' stamp: 'sw 1/27/2000 15:33'!
wantsHalo
	| topOwner |
	^ (topOwner _ self topRendererOrSelf owner) ~~ nil and:
		[topOwner wantsHaloFor: self]! !

!Morph methodsFor: 'halos and balloon help' stamp: 'sw 1/25/2000 17:43'!
wantsHaloFromClick
	^ true! !

!Morph methodsFor: 'visual properties' stamp: 'sw 1/27/2000 19:18'!
canSetColor
	"Answer true iff the receiver can meaningfully have its color changed"
	^ true! !


!BookMorph methodsFor: 'other' stamp: 'sw 1/11/2000 13:07'!
defersHaloOnClickTo: aSubMorph
	"If a cmd-click on aSubMorph would make it a preferred recipient of the halo, answer true"
	^ currentPage notNil and:
		[aSubMorph hasInOwnerChain: currentPage]
	! !

!BookMorph methodsFor: 'other' stamp: 'sw 12/30/1999 19:51'!
seeksOutHalo
	"Answer whether the receiver is an eager recipient of the halo"
	^ false! !


!DropShadowMorph methodsFor: 'geometry' stamp: 'sw 12/22/1999 18:40'!
wantsHaloFromClick
	^ false! !


!FlapTab methodsFor: 'show & hide' stamp: 'sw 12/29/1999 12:41'!
hideFlapUnlessBearingHalo
	self hasHalo ifFalse: [self hideFlapUnlessOverReferent]! !

!FlapTab methodsFor: 'show & hide' stamp: 'sw 6/21/1999 13:07'!
hideFlapUnlessOverReferent
	| aWorld |
	(referent isInWorld and: [referent bounds containsPoint: self world activeHand lastEvent cursorPoint])
		ifFalse:
			[aWorld _ self world.
			self referent delete.
			aWorld removeAccommodationForFlap: self.
			flapShowing _ false.
			self isInWorld ifFalse:
				[self inboard ifTrue: [aWorld addMorphFront: self]].
			self adjustPositionAfterHidingFlap]! !

!FlapTab methodsFor: 'show & hide' stamp: 'sw 12/29/1999 15:30'!
succeededInRevealing: aPlayer
	(super succeededInRevealing: aPlayer) ifTrue: [^ true].
	self flapShowing ifTrue: [^ false].
	(referent succeededInRevealing: aPlayer)
		ifTrue:
			[self showFlap.
			aPlayer costume addHalo.
			^ true].
	^ false! !


!HaloMorph methodsFor: 'initialization' stamp: 'sw 1/28/2000 09:57'!
initialize

	super initialize.
	self color: (Color r: 0.6 g: 0.8 b: 1.0).
	growingOrRotating _ false.
	simpleMode _ Preferences  simpleHalosInForce
! !

!HaloMorph methodsFor: 'accessing' stamp: 'sw 1/26/2000 15:36'!
haloBox: aBox
	haloBox _ aBox! !

!HaloMorph methodsFor: 'private' stamp: 'sw 1/28/2000 09:44'!
addCircleHandles
	| box |
	simpleMode _ false.
	target isWorldMorph ifTrue: [^ self addHandlesForWorldHalos].

	self removeAllMorphs.  "remove old handles, if any"
	self bounds: target renderedMorph fullBoundsInWorld.  "update my size"
	box _ self basicBox.

	target addHandlesTo: self box: box.
	innerTarget addOptionalHandlesTo: self box: box.

	self addName.
	growingOrRotating _ false.
	self layoutChanged.
	self changed.
! !

!HaloMorph methodsFor: 'private' stamp: 'sw 1/27/2000 17:36'!
addDirectionHandles

	| centerOfRotationHandle |
	((innerTarget isKindOf: SketchMorph) and: [innerTarget rotationStyle == #normal]) ifTrue:

		[self addDirectionShaft.
		innerTarget couldSetRotationCenterFromHalo ifTrue:

			[centerOfRotationHandle _ self addGraphicalHandle: #RotationCenter at: target referencePosition on: #mouseDown send: #prepareToTrackCenterOfRotation:with: to: self.

			centerOfRotationHandle on: #mouseStillDown send: #trackCenterOfRotation:with: to: self.
			centerOfRotationHandle on: #mouseUp send: #setCenterOfRotation:with: to: self]]
! !

!HaloMorph methodsFor: 'private' stamp: 'sw 1/27/2000 18:42'!
addDirectionShaft

	| directionHandle shaft info |
	directionArrowAnchor _ target referencePositionInWorld.

	self addMorphFront: (shaft _ PolygonMorph newSticky).
	shaft makeOpen; borderWidth: 5; borderColor: Color orange.
	shaft setCenteredBalloonText: 'Forward direction'.
	info _ self positionDirectionShaft: shaft.

	directionHandle _ self addGraphicalHandle: #Direction at: info first  on: #mouseDown send: #doDirection:with: to: self.
	self correctlyRotateDirectionArrow: directionHandle forDegrees: target player getHeading.

	directionHandle center: info first.
	directionHandle on: #mouseStillDown send: #trackDirectionArrow:with: to: self.
	directionHandle on: #mouseUp send: #setDirection:with: to: self.
	directionHandle setProperty: #helpAtCenter toValue: true.

	self completeDisplayFor: directionHandle centeringTipAt: (self directionArrowTipCenterFor: directionHandle).
! !

!HaloMorph methodsFor: 'private' stamp: 'sw 10/29/1999 15:31'!
addFullHandles
	"Later, obey a preference to choose between circle-iconic and solid-circles"
	self addCircleHandles! !

!HaloMorph methodsFor: 'private' stamp: 'sw 10/6/1999 20:12'!
addGraphicalHandle: formKey at: aPoint on: eventName send: selector to: recipient
	"Add the supplied form as a graphical handle centered at the given point, and set it up to respond to the given event by sending the given selector to the given recipient.  Return the handle."
	| handle |
	handle _ self addGraphicalHandleFrom: formKey at: aPoint.
	handle on: eventName send: selector to: recipient.
	handle setBalloonText: (target balloonHelpTextForHandle: handle).
	^ handle
! !

!HaloMorph methodsFor: 'private' stamp: 'sw 10/6/1999 20:29'!
addGraphicalHandleFrom: formKey at: aPoint
	"Add the supplied form as a graphical handle centered at the given point.  Return the handle."
	| handle aForm |
	aForm _ (ScriptingSystem formAtKey: formKey) ifNil: [ScriptingSystem formAtKey: #SolidMenu].
	handle _ ImageMorph new image: aForm; bounds: (Rectangle center: aPoint extent: aForm extent).
	self addMorph: handle.
	handle on: #mouseUp send: #endInteraction to: self.
	^ handle
! !

!HaloMorph methodsFor: 'private' stamp: 'sw 1/27/2000 16:30'!
addHandle: handleSpec on: eventName send: selector to: recipient
	"Add a handle within the halo box as per the haloSpec, and set it up to respond to the given event by sending the given selector to the given recipient.  Return the handle."
	| handle aPoint iconName colorToUse |
	aPoint _ self positionIn: haloBox horizontalPlacement: handleSpec horizontalPlacement verticalPlacement: handleSpec verticalPlacement.
	handle _ EllipseMorph
		newBounds: (Rectangle center: aPoint extent: HandleSize asPoint)
		color: (colorToUse _ Color colorFrom: handleSpec color).
	self addMorph: handle.
	(iconName _ handleSpec iconSymbol) ifNotNil:
		[ | form |
		form _ ScriptingSystem formAtKey: iconName.
		form ifNotNil:
			[handle addMorphCentered: (ImageMorph new
				image: form; 
				color: colorToUse makeForegroundColor;
				lock)]].
	handle on: #mouseUp send: #endInteraction to: self.
	handle on: eventName send: selector to: recipient.
	handle setBalloonText: (target balloonHelpTextForHandle: handle).
	^ handle
! !

!HaloMorph methodsFor: 'private' stamp: 'sw 1/27/2000 16:29'!
addHandleAt: aPoint color: aColor icon: iconName on: eventName send: selector to: recipient
	"Add a handle centered at the given point with the given color, and set it up to respond to the given event by sending the given selector to the given recipient.  Return the handle."
	| handle |
	handle _ EllipseMorph
		newBounds: (Rectangle center: aPoint extent: self handleSize asPoint)
		color: aColor.
	self addMorph: handle.
	iconName ifNotNil:
		[ | form |
		form _ ScriptingSystem formAtKey: iconName.
		form ifNotNil:
			[handle addMorphCentered: (ImageMorph new
				image: form; 
				color: aColor makeForegroundColor;
				lock)]].
	handle on: #mouseUp send: #endInteraction to: self.
	handle on: eventName send: selector to: recipient.
	handle setBalloonText: (target balloonHelpTextForHandle: handle).
	^ handle
! !

!HaloMorph methodsFor: 'private' stamp: 'sw 1/28/2000 09:57'!
addHandles
	simpleMode == true
		ifTrue:
			[self addSimpleHandles]
		ifFalse:
			[self addCircleHandles]
! !

!HaloMorph methodsFor: 'private' stamp: 'sw 1/26/2000 19:39'!
addHandlesForWorldHalos
	| box |
	self removeAllMorphs.  "remove old handles, if any"
	self bounds: target bounds.
	box _ self world bounds insetBy: 9.
	target addWorldHandlesTo: self box: box.

	self addNameBeneath: (box insetBy: (0@0 corner: 0@10)) string: innerTarget externalName.
	growingOrRotating _ false.
	self layoutChanged.
	self changed.
! !

!HaloMorph methodsFor: 'private' stamp: 'sw 12/30/1999 19:43'!
addNameBeneath: outerRectangle string: aString
	"Add a name display centered beneath the bottom of the outer rectangle. Return the handle."

	| nameMorph namePosition |
	nameMorph _ NameStringInHalo contents: aString.
	nameMorph color: Color magenta.
	nameMorph useStringFormat; target: innerTarget; putSelector: #renameTo:.
	namePosition _ outerRectangle bottomCenter -
		((nameMorph width // 2) @ (self handleSize negated // 2 - 1)).
	nameMorph position: (namePosition min: self world viewBox bottomRight - nameMorph extent y + 2).
	nameMorph balloonTextSelector: #objectNameInHalo.
	self addMorph: nameMorph.
	^ nameMorph! !

!HaloMorph methodsFor: 'private' stamp: 'sw 12/21/1999 17:52'!
addSimpleHandles
	target isWorldMorph ifTrue: [^ self addHandlesForWorldHalos].
	self removeAllMorphs.  "remove old handles, if any"
	self bounds: target renderedMorph fullBoundsInWorld.  "update my size"
	self innerTarget addSimpleHandlesTo: self box: self basicBoxForSimpleHalos

! !

!HaloMorph methodsFor: 'private' stamp: 'sw 10/28/1999 15:39'!
addSimpleHandlesForWorldHalos
	"Nothing special at present here -- just use the regular handles.  Cannot rotate or resize world"

	self addHandlesForWorldHalos
! !

!HaloMorph methodsFor: 'private' stamp: 'sw 1/28/2000 09:42'!
addSimpleHandlesTo: aHaloMorph box: aBox
	| aHandle |
	simpleMode _ true.

	target isWorldMorph ifTrue: [^ self addSimpleHandlesForWorldHalos].

	self removeAllMorphs.  "remove old handles, if any"
	
	self bounds: target renderedMorph fullBoundsInWorld.  "update my size"
	
	self addHandleAt: (((aBox topLeft + aBox leftCenter) // 2) + self simpleFudgeOffset) color: Color paleBuff icon: 'Halo-MoreHandles'
		on: #mouseDown send: #addFullHandles to: self.

	aHandle _ self addGraphicalHandle: #Rotate at: aBox bottomLeft on: #mouseDown send: #startRot:with: to: self.
	aHandle on: #mouseStillDown send: #doRot:with: to: self.

	target isFlexMorph
		ifTrue: [(self addGraphicalHandle: #Scale at: aBox bottomRight  on: #mouseDown send: #startScale:with: to: self)
				on: #mouseStillDown send: #doScale:with: to: self]
		ifFalse: [(self addGraphicalHandle: #Scale at: aBox bottomRight on: #mouseDown send: #startGrow:with: to: self)
				on: #mouseStillDown send: #doGrow:with: to: self].

	(innerTarget isMemberOf: SketchMorph) ifTrue:  "isMemberOf: used advisedly here"
		[self addSimpleSketchMorphHandlesInBox: aBox].

	growingOrRotating _ false.
	self layoutChanged.
	self changed.
! !

!HaloMorph methodsFor: 'private' stamp: 'sw 1/27/2000 17:37'!
addSimpleSketchMorphHandlesInBox: box

	self addGraphicalHandle: #PaintTab at: box bottomCenter on: #mouseDown send: #editDrawing to: self innerTarget.

	self addDirectionHandles! !

!HaloMorph methodsFor: 'private' stamp: 'sw 12/21/1999 22:10'!
basicBox
	| aBox minSide anExtent |
	minSide _ 4 * self handleSize.
	anExtent _ ((self width + self handleSize + 8) max: minSide) @
				((self height + self handleSize + 8) max: minSide).
	aBox _ Rectangle center: self center extent: anExtent.
	^ self world
		ifNil:
			[aBox]
		ifNotNil:
			[aBox intersect: (self world viewBox insetBy: 8@8)]
! !

!HaloMorph methodsFor: 'private' stamp: 'sw 10/28/1999 15:49'!
basicBoxForSimpleHalos

	^ (target topRendererOrSelf fullBoundsInWorld expandBy: self handleAllowanceForIconicHalos)
			intersect: (self world bounds insetBy: 8@8)
! !

!HaloMorph methodsFor: 'private' stamp: 'sw 10/28/1999 15:15'!
completeDisplayFor: directionHandle centeringTipAt: aPosition

	| aShaft  |
	self correctlyRotateDirectionArrow: directionHandle forDegrees: 
			(directionArrowAnchor bearingToPoint: aPosition) .
	directionHandle position: (aPosition - (directionHandle extent // 2)).

	aShaft _ self submorphThat:
		[:aSubMorph | aSubMorph isKindOf: PolygonMorph] ifNone: [PolygonMorph new color: Color orange; borderColor: Color orange; borderWidth: 3].
	aShaft setVertices: (Array with: aPosition with: directionArrowAnchor).
	self addMorph: aShaft.
	self layoutChanged! !

!HaloMorph methodsFor: 'private' stamp: 'sw 10/25/1999 17:10'!
correctlyRotateDirectionArrow: aHandle forDegrees: degrees
	aHandle image: ((ScriptingSystem formAtKey: #Direction) rotateBy: degrees)
! !

!HaloMorph methodsFor: 'private' stamp: 'sw 12/27/1999 16:50'!
directionArrowLength
	^ 20! !

!HaloMorph methodsFor: 'private' stamp: 'sw 10/28/1999 15:50'!
directionArrowTipCenterFor: directionArrow
	| alphaRadians arrowVector result |
	alphaRadians _ target player getHeading degreesToRadians.
	arrowVector _ self directionArrowLength * (alphaRadians sin  @ alphaRadians cos negated).
	result _ (directionArrowAnchor + arrowVector - (0 @ 0)) rounded.
	^ result
! !

!HaloMorph methodsFor: 'private' stamp: 'sw 10/28/1999 21:28'!
doDirection: anEvent with: directionHandle
	self removeAllHandlesBut: directionHandle! !

!HaloMorph methodsFor: 'private' stamp: 'sw 9/1/1999 15:23'!
doRecolor: evt with: menuHandle
	innerTarget changeColor
! !

!HaloMorph methodsFor: 'private' stamp: 'sw 1/27/2000 18:34'!
doRot: evt with: rotHandle
	"Update the rotation of my target if it is rotatable."

	| degrees |
	degrees _ (evt cursorPoint - (target pointInWorld: target referencePosition)) degrees.
	degrees _ degrees - angleOffset degrees.
	degrees _ degrees detentBy: 10.0 atMultiplesOf: 90.0 snap: false.
	degrees = 0.0
		ifTrue: [rotHandle color: Color lightBlue]
		ifFalse: [rotHandle color: Color blue].
	rotHandle submorphsDo:
		[:m | m color: rotHandle color makeForegroundColor].
	((innerTarget isKindOf: SketchMorph) and: [innerTarget rotationStyle == #normal]) ifTrue:
		[self removeAllHandlesBut: rotHandle.
		self addDirectionShaft].

	target rotationDegrees: degrees.

	rotHandle position: evt cursorPoint - (rotHandle extent // 2).
	self layoutChanged! !

!HaloMorph methodsFor: 'private' stamp: 'sw 1/27/2000 18:42'!
handleAllowanceForIconicHalos
	^ 12! !

!HaloMorph methodsFor: 'private' stamp: 'sw 12/21/1999 15:19'!
handleSize
	^ HandleSize! !

!HaloMorph methodsFor: 'private' stamp: 'sw 11/24/1999 18:04'!
imageMorphFrom: formKey
	"Add the supplied form as a graphical handle centered at the given point.  Return the handle."
	| aForm |
	aForm _ (ScriptingSystem formAtKey: formKey) ifNil: [ScriptingSystem formAtKey: #SolidMenu].
	^ ImageMorph new image: aForm; extent: aForm extent; yourself
! !

!HaloMorph methodsFor: 'private' stamp: 'sw 1/25/2000 17:38'!
positionDirectionShaft: aPolygon
	"Position the polygon, and return an array holding the coordinates of the tip and the heading in radians."
	| alphaRadians arrowVector tipLocation |
	"Pretty crude and slow approach at present, but a stake in the ground"
	alphaRadians _ target assuredPlayer getHeading degreesToRadians.
	arrowVector _ self directionArrowLength * (alphaRadians sin  @ alphaRadians cos negated).
	aPolygon setVertices: 
		(Array with: directionArrowAnchor
			with: (tipLocation _ directionArrowAnchor + arrowVector)).
	^ Array with: tipLocation with: alphaRadians
! !

!HaloMorph methodsFor: 'private' stamp: 'sw 10/28/1999 22:24'!
prepareToTrackCenterOfRotation: anEvent with: rotationHandle

	self removeAllHandlesBut: rotationHandle
! !

!HaloMorph methodsFor: 'private' stamp: 'sw 1/25/2000 17:40'!
setCenterOfRotation: evt with: rotationHandle
	self flag: #noteToAndreas.
		"Here's where access to the feature is sealed off in cases where it doesn't work right"

	innerTarget couldSetRotationCenterFromHalo
		ifFalse:
			[self endInteraction.
			^ self inform: 'Sorry, at present you can
only set the center of rotation
when the object is has a
forward-direction of 0.
(because of an intractable bug!!)
Sorry!!!!'].
	innerTarget setRotationCenterFromGlobalPosition: (Sensor cursorPoint - self world viewBox origin).
	self endInteraction
! !

!HaloMorph methodsFor: 'private' stamp: 'sw 1/17/2000 20:55'!
setDirection: anEvent with: directionHandle
	"The user has let up after having dragged the direction arrow; now set the forward direction of the actual SketchMorph accordingly"
	| alphaRadians alphaDegrees targetPlayer delta targetXY |
	targetXY _ target cartesianXY.
	targetPlayer _ target player.
	delta _ innerTarget referencePositionInWorld - directionHandle center.
	alphaRadians _ delta y = 0
		ifTrue:
			[delta x > 0 ifTrue: [3 * Float halfPi] ifFalse: [Float halfPi]]
		ifFalse:
			[delta y > 0
				ifTrue:
					[(delta x negated / delta y) arcTan]
				ifFalse:
					[Float pi - (delta x / delta y) arcTan]].
	alphaDegrees _ alphaRadians radiansToDegrees asSmallPositiveDegrees.
	innerTarget setupAngle: (innerTarget setupAngle - (targetPlayer getHeading - alphaDegrees)) asSmallPositiveDegrees.

	(target isKindOf: TransformationMorph) ifTrue: [target removeFlexShell].
	targetPlayer setHeading: alphaDegrees.
	targetPlayer costume cartesianXY: targetXY.
	self endInteraction! !

!HaloMorph methodsFor: 'private' stamp: 'sw 1/27/2000 18:43'!
simpleFudgeOffset
	"account for the difference in basicBoxes between regular and simple handles"

	^ 0@0
! !

!HaloMorph methodsFor: 'private' stamp: 'di 10/2/1998 14:03'!
startRot: evt with: rotHandle
	"Initialize rotation of my target if it is rotatable."

	target isFlexMorph ifFalse: [target addFlexShell].
	growingOrRotating _ true.
	self removeAllHandlesBut: rotHandle.  "remove all other handles"
	angleOffset _ evt cursorPoint - (target pointInWorld: target referencePosition).
	angleOffset _ Point
			r: angleOffset r
			degrees: angleOffset degrees - target rotationDegrees.
! !

!HaloMorph methodsFor: 'private' stamp: 'sw 12/30/1999 11:35'!
trackCenterOfRotation: anEvent with: rotationCenterHandle
	rotationCenterHandle center: anEvent cursorPoint
! !

!HaloMorph methodsFor: 'private' stamp: 'sw 10/27/1999 15:15'!
trackDirectionArrow: anEvent with: directionHandle
	self completeDisplayFor: directionHandle centeringTipAt: anEvent cursorPoint! !

!HaloMorph methodsFor: 'copying' stamp: 'sw 1/28/2000 09:43'!
veryDeepInner: deepCopier
	"Copy all of my instance variables.  Some need to be not copied at all, but shared.  	Warning!!!!  Every instance variable defined in this class must be handled.  We must also implement veryDeepFixupWith:.  See DeepCopier class comment."

	super veryDeepInner: deepCopier.
	"target _ target.		Weakly copied"
	"innerTarget _ innerTarget.		Weakly copied"
	positionOffset _ positionOffset veryDeepCopyWith: deepCopier.
	angleOffset _ angleOffset veryDeepCopyWith: deepCopier.
	minExtent _ minExtent veryDeepCopyWith: deepCopier.
	growingOrRotating _ growingOrRotating veryDeepCopyWith: deepCopier.
	directionArrowAnchor _ directionArrowAnchor.
	simpleMode _ simpleMode.
	haloBox _ haloBox! !

!HaloMorph methodsFor: 'handles' stamp: 'sw 1/26/2000 15:51'!
addDebugHandle: handleSpec
	Preferences debugHaloHandle ifTrue:
		[self addHandle: handleSpec
			on: #mouseDown send: #doDebug:with: to: self]
! !

!HaloMorph methodsFor: 'handles' stamp: 'sw 1/26/2000 15:52'!
addDismissHandle: handleSpec
	| dismissHandle |
	dismissHandle _ self addHandle: handleSpec
		on: #mouseDown send: #mouseDownInDimissHandle:with: to: self.
	dismissHandle on: #mouseUp send: #maybeDismiss:with: to: self.
	dismissHandle on: #mouseStillDown send: #setDismissColor:with: to: self.
! !

!HaloMorph methodsFor: 'handles' stamp: 'sw 1/26/2000 16:13'!
addDragHandle: haloSpec
	(self addHandle: haloSpec on: #mouseDown send: #startDrag:with: to: self)
		on: #mouseStillDown send: #doDrag:with: to: self


! !

!HaloMorph methodsFor: 'handles' stamp: 'sw 1/26/2000 16:15'!
addDupHandle: haloSpec
	self addHandle: haloSpec on: #mouseDown send: #doDup:with: to: self

! !

!HaloMorph methodsFor: 'handles' stamp: 'sw 1/28/2000 09:59'!
addFewerHandlesHandle: haloSpec
	self addHandle: haloSpec on: #mouseDown send: #addSimpleHandles to: self
! !

!HaloMorph methodsFor: 'handles' stamp: 'sw 1/27/2000 16:56'!
addFontEmphHandle: haloSpec
	(innerTarget isKindOf: TextMorph) ifTrue:
		[self addHandle: haloSpec
				on: #mouseDown send: #chooseEmphasisOrAlignment to: innerTarget]
! !

!HaloMorph methodsFor: 'handles' stamp: 'sw 1/27/2000 16:53'!
addFontSizeHandle: haloSpec
	(innerTarget isKindOf: TextMorph) ifTrue:
		[self addHandle: haloSpec
				on: #mouseDown send: #chooseFont to: innerTarget]
! !

!HaloMorph methodsFor: 'handles' stamp: 'sw 1/27/2000 16:55'!
addFontStyleHandle: haloSpec
	(innerTarget isKindOf: TextMorph) ifTrue:
		[self addHandle: haloSpec
				on: #mouseDown send: #chooseStyle to: innerTarget]
! !

!HaloMorph methodsFor: 'handles' stamp: 'sw 1/26/2000 16:11'!
addGrabHandle: haloSpec
	self addHandle: haloSpec on: #mouseDown send: #doGrab:with: to: self

! !

!HaloMorph methodsFor: 'handles' stamp: 'sw 1/26/2000 16:22'!
addGrowHandle: haloSpec
	target isFlexMorph ifFalse: 
		[(self addHandle: haloSpec
				on: #mouseDown send: #startGrow:with: to: self)
				on: #mouseStillDown send: #doGrow:with: to: self].
	"This or addScaleHandle:, but not both, will prevail at any one time"
! !

!HaloMorph methodsFor: 'handles' stamp: 'sw 1/26/2000 16:16'!
addHelpHandle: haloSpec
	target balloonText ifNotNil:
		[(self addHandle: haloSpec on: #mouseDown send: #mouseDownOnHelpHandle: to: innerTarget)
			on: #mouseUp send: #deleteBalloon to: innerTarget]
! !

!HaloMorph methodsFor: 'handles' stamp: 'sw 1/26/2000 16:05'!
addMenuHandle: haloSpec
	self addHandle: haloSpec on: #mouseDown send: #doMenu:with: to: self! !

!HaloMorph methodsFor: 'handles' stamp: 'sw 1/27/2000 16:23'!
addPaintBgdHandle: haloSpec
	(innerTarget isKindOf: PasteUpMorph) ifTrue:
		[self addHandle: haloSpec
				on: #mouseDown send: #paintBackground to: innerTarget].
! !

!HaloMorph methodsFor: 'handles' stamp: 'sw 1/27/2000 19:20'!
addRecolorHandle: haloSpec
	innerTarget canSetColor ifTrue:
		[self addHandle: haloSpec on: #mouseUp send: #doRecolor:with:  to: self]


! !

!HaloMorph methodsFor: 'handles' stamp: 'sw 1/27/2000 16:49'!
addRepaintHandle: haloSpec
	(innerTarget isKindOf: SketchMorph) ifTrue:
		[self addHandle: haloSpec
				on: #mouseDown send: #editDrawing to: innerTarget]
! !

!HaloMorph methodsFor: 'handles' stamp: 'sw 1/26/2000 16:00'!
addRotateHandle: haloSpec
	(self addHandle: haloSpec on: #mouseDown send: #startRot:with: to: self)
		on: #mouseStillDown send: #doRot:with: to: self

! !

!HaloMorph methodsFor: 'handles' stamp: 'sw 1/26/2000 16:23'!
addScaleHandle: haloSpec
	target isFlexMorph ifTrue: 
		[(self addHandle: haloSpec
				on: #mouseDown send: #startScale:with: to: self)
				on: #mouseStillDown send: #doScale:with: to: self].
	"This or addGrowHandle:, but not both, will prevail at any one time"
! !

!HaloMorph methodsFor: 'handles' stamp: 'sw 1/26/2000 16:26'!
addScriptHandle: haloSpec
	(Preferences valueOfFlag: #nascentScriptHaloHandle) ifTrue:
		[self addHandle: haloSpec
				on: #mouseDown send: #makeNascentScript to: innerTarget].
! !

!HaloMorph methodsFor: 'handles' stamp: 'sw 1/26/2000 16:07'!
addTileHandle: haloSpec
	self addHandle: haloSpec on: #mouseDown send: #tearOffTile to: innerTarget
! !

!HaloMorph methodsFor: 'handles' stamp: 'sw 1/26/2000 16:09'!
addViewHandle: haloSpec
	self addHandle: haloSpec
		on: #mouseDown send: #openViewerForArgument to: innerTarget


! !

!HaloMorph methodsFor: 'handles' stamp: 'sw 12/21/1999 18:22'!
positionIn: aBox horizontalPlacement: horiz verticalPlacement: vert
	| xCoord yCoord |

	horiz == #left
		ifTrue:	[xCoord _ aBox left].
	horiz == #leftCenter
		ifTrue:	[xCoord _ aBox left + (aBox width // 4)].
	horiz == #center
		ifTrue:	[xCoord _ (aBox left + aBox right) // 2].
	horiz == #rightCenter
		ifTrue:	[xCoord _ aBox left + ((3 * aBox width) // 4)].
	horiz == #right
		ifTrue:	[xCoord _ aBox right].

	vert == #top
		ifTrue:	[yCoord _ aBox top].
	vert == #topCenter
		ifTrue:	[yCoord _ aBox top + (aBox height // 4)].
	vert == #center
		ifTrue:	[yCoord _ (aBox top + aBox bottom) // 2].
	vert == #bottomCenter
		ifTrue:	[yCoord _ aBox top + ((3 * aBox height) // 4)].
	vert == #bottom
		ifTrue:	[yCoord _ aBox bottom].

	^ xCoord @ yCoord! !

!HaloMorph methodsFor: 'object fileIn' stamp: 'sw 1/28/2000 10:05'!
convertbosfcetipamg0: varDict bosfcetipamgdhs0: smartRefStrm
	"These variables are automatically stored into the new instance ('target' 'innerTarget' 'positionOffset' 'angleOffset' 'minExtent' 'growingOrRotating' ).
	This method is for additional changes. Use statements like (foo _ varDict at: 'foo')."

	"New variables: ('directionArrowAnchor' 'haloBox' 'simpleMode' )  If a non-nil value is needed, please assign it."
	simpleMode _ false
! !


!HaloMorph class methodsFor: 'as yet unclassified' stamp: 'sw 12/21/1999 15:19'!
initialize
	"HaloMorph initialize"
	HandleSize _ 16! !


!HandMorph methodsFor: 'event handling' stamp: 'sw 1/27/2000 14:54'!
handleMouseOver: evt
	| mList allMouseOvers leftMorphs enteredMorphs now t oldHalo balloonHelpEnabled |
	owner ifNil: [^ self].
	balloonHelpEnabled _ Preferences balloonHelpEnabled.

	"Start with a list consisting of the topmost unlocked morph in the
	innermost frame (pasteUp), and all of its containers in that frame."
	mList _ self mouseOverList: evt.

	now _ Time millisecondClockValue.

	"Make a list of all potential mouse-overs..."
	allMouseOvers _ mList select:
		[:m | m wantsHalo or: [(balloonHelpEnabled and: [m wantsBalloon])  "To start a timer"
			or: [m handlesMouseOver: (evt transformedBy: (m transformFrom: self))]  "To send mouseEnter:"]].
	leftMorphs _ mouseOverMorphs select: [:m | (allMouseOvers includes: m) not].
	enteredMorphs _ allMouseOvers select: [:m | (mouseOverMorphs includes: m) not].

	"Notify and remove any mouse-overs that have just been left..."
	leftMorphs do: [:m |
		mouseOverMorphs remove: m.
		m wantsBalloon ifTrue: [m deleteBalloon].
		m mouseLeave: (evt transformedBy: (m transformFrom: self)).
		mouseOverTimes removeKey: m ifAbsent: [] ].

	"Add any new mouse-overs and send mouseEnter: and/or start timers..."
	enteredMorphs do: [:m |
		mouseOverMorphs add: m.
		dragOverMorphs remove: m ifAbsent: [].  "Cant be in two places at once"
		(m handlesMouseOver: evt) ifTrue:
			[m mouseEnter: (evt transformedBy: (m transformFrom: self))].
		(m wantsHalo or: [m wantsBalloon]) ifTrue:
			[mouseOverTimes at: m put: now]].

	mouseOverTimes keys do:
		[:m | "Check pending timers for lingering"
		t _ mouseOverTimes at: m.
		(now < t "rollover" or: [now > (t+800)]) ifTrue:
			["Yes we have lingered for 0.8 seconds..."
			mouseOverTimes removeKey: m.
			m owner ifNotNil:  "Not deleted during linger (--it happens ;--)"
				[m wantsHalo
					ifTrue: [oldHalo _ m world haloMorphOrNil.
							(oldHalo == nil or: [oldHalo target ~~ m])
								ifTrue: ["Put up halo for m"
										self popUpHalo: evt.
										(balloonHelpEnabled and: [m wantsBalloon]) ifTrue:
											["...and reschedule balloon after longer linger"
											mouseOverTimes at: m put: now]]
								ifFalse: ["Halo for m is already up, so show balloon"
										(balloonHelpEnabled and: [m wantsBalloon])
											ifTrue: [m showBalloon: m balloonText]]]
					ifFalse:
						[(balloonHelpEnabled and: [m wantsBalloon])
							ifTrue: [m showBalloon: m balloonText]]]]]! !

!HandMorph methodsFor: 'special gestures' stamp: 'sw 12/30/1999 19:48'!
specialDrag: evt
	"Special drag (cmd-mouse on the Macintosh) allows a morph to be dragged without grabbing it and thus without removing it from its owner or changing its z-order." 
	| halo itsOwner |
	self position ~= evt cursorPoint
		ifTrue: [self position: evt cursorPoint].
	mouseDownMorph
		ifNil:    ["Waiting for more than 5 pixels move to start drag"
				(self position dist: targetOffset) > 5
					ifTrue: [(halo _ self world haloMorphOrNil) ifNil: [^ self].
							mouseDownMorph _ halo target.
							targetOffset _ targetOffset - mouseDownMorph positionInWorld.
							halo removeAllHandlesBut: nil]]
		ifNotNil: [mouseDownMorph isWorldMorph ifFalse:
					[mouseDownMorph setConstrainedPositionFrom:
						(mouseDownMorph pointFromWorld: self position - targetOffset)].

	 mouseDownMorph ifNotNil:
		[((itsOwner _ mouseDownMorph topRendererOrSelf owner) notNil and:
			[itsOwner automaticViewing]) ifTrue:
				[mouseDownMorph openViewerForArgument]]]! !

!HandMorph methodsFor: 'special gestures' stamp: 'sw 12/22/1999 18:18'!
specialGesture: evt
	"Special gestures (cmd-mouse on the Macintosh) allow a mouse-sensitive morph to be moved or bring up a halo for the morph."
	"Summary:
		Cmd-click			pop up halo
		Cmd-drag			reposition morph"

	Preferences cmdGesturesEnabled ifFalse: [^ self].

	self newMouseFocus: nil.

	"if carrying morphs, just drop them"
	self hasSubmorphs ifTrue: [^ self dropMorphsEvent: evt].

	targetOffset _ menuTargetOffset _ self position.
	argument _ self argumentOrNil.
	evt shiftPressed
		ifFalse:	[self popUpHaloFromClick: evt]
		ifTrue:	[self popUpHaloFromShiftClick: evt]
! !

!HandMorph methodsFor: 'halos' stamp: 'sw 12/30/1999 17:39'!
popUpHaloFromClick: evt
	"Pop up a halo on a suitable morph below the hand.
	If there are multiple possible targets, and one of them already has a halo, then
	choose the next inner target.  That is, unless we are already at the bottom, in which case
	go topmost again."

	| oldTargets targets anIndex |
	oldTargets _ OrderedCollection new.
	self world haloMorphs do:
		[:h | oldTargets addLast: h target. h delete].

	targetOffset _ self position.
	(argument _ self argumentOrNil) ifNil: [^ owner "the world" addHalo: evt].
	argument submorphCount = 0 ifTrue: [^ argument wantsHaloFromClick ifTrue: [argument addHalo: evt "sole target"]].

	"Multiple possible targets, choose the outermost suitable one first, but if one already
		has a halo, then choose the next farther in."
	targets _ argument unlockedMorphsAt: targetOffset.
	targets _ targets reversed select: [:aMorph | aMorph wantsHaloFromClick].

	targets size = 0 ifTrue: [^ argument wantsHaloFromClick
			ifTrue: [argument addHalo: evt "sole target"]
			ifFalse: ["no halo recipient"]].
	targets size = 1 ifTrue: [^ targets first addHalo: evt "sole target"].
	anIndex _ targets findFirst: [:t | oldTargets includes: t].
	anIndex = 0 ifTrue:
		[^ self popUpNewHaloFromClick: evt targets: targets].

	anIndex < targets size ifTrue:
			[^ (targets at: anIndex + 1) addHalo: evt from: (targets at: anIndex) "next inner target"].
	^ targets first addHalo: evt "All the way our already; back to deepest"! !

!HandMorph methodsFor: 'halos' stamp: 'sw 12/22/1999 18:23'!
popUpHaloFromShiftClick: evt
	| oldTargets targets anIndex |
	"Given that the shift key is down, pop up a halo on an appropriate morph.  Go to the deepest morph (locked or not), unless there is an existing halo, in which case go out one level"
	oldTargets _ OrderedCollection new.
	self world haloMorphs do:
		[:h | oldTargets addLast: h target. h delete].

	targetOffset _ self position.
	(argument _ self argumentOrNil) ifNil: [^ owner "the world" addHalo: evt].
	argument submorphCount = 0 ifTrue: [^ argument addHalo: evt "sole target"].

	"Multiple possible targets, choose the deepest first, but
	if one already has a halo, then choose the next farther out."
	targets _ argument morphsAt: targetOffset.
	targets size = 0 ifTrue: [^ argument addHalo: evt "sole target"].
	targets size = 1 ifTrue: [^ targets first addHalo: evt "sole target"].
	anIndex _ targets findFirst: [:t | oldTargets includes: t].
	anIndex = 0 ifTrue: [^ targets first addHalo: evt "deepest target"].
	anIndex < targets size ifTrue:
		[^ (targets at: anIndex + 1) addHalo: evt from: (targets at: anIndex) "next outer target"].
	^ targets first addHalo: evt "All the way out already; back to deepest"! !

!HandMorph methodsFor: 'halos' stamp: 'sw 1/25/2000 16:57'!
popUpNewHaloFromClick: evt targets: targets
	| outer possible haloRecipient |
	"Pop up a halo for the most opportune morph, given that this is not a progressive halo transfer.  evt is the precipitating mouse event, and targets is the list of potential targets under the mouse"
	possible _ targets detect: [:aMorph |
			 (aMorph isKindOf: PasteUpMorph) not and: [(aMorph isKindOf: BookMorph) not]]
		ifNone: [targets last].
	
	outer _ possible owner ifNil: [targets first].
	haloRecipient _ targets reversed detect:
		[:aMorph | aMorph == outer or: [aMorph seeksOutHalo and: [outer defersHaloOnClickTo: aMorph]]] ifNone: [outer].
	haloRecipient _ targets detect:
			[:aMorph | (aMorph defersHaloOnClickTo: haloRecipient) not]
		ifNone: [haloRecipient].
	haloRecipient addHalo: evt
! !


!ImageMorph methodsFor: 'accessing' stamp: 'bf 10/13/1999 14:09'!
color: aColor
        super color: aColor.
        (image depth == 1 and: [aColor isColor]) ifTrue: [
                image colors: {Color transparent. aColor}.
                self changed]! !


!MatrixTransformMorph methodsFor: 'accessing' stamp: 'sw 1/27/2000 15:42'!
addOptionalHandlesTo: aHalo box: box
	aHalo addHandleAt: self referencePosition color: Color lightGray icon: nil on: #mouseStillDown send: #changeRotationCenter:with: to: self! !


!Number methodsFor: 'converting' stamp: 'sw 10/7/1999 12:24'!
asSmallPositiveDegrees
	"Return the receiver normalized to lie within the range (0, 360)"

	| result |
	result _ self.
	[result < 0] whileTrue: [result _ result + 360].
	^ result \\ 360

"#(-500 -300 -150 -5 0 5 150 300 500 1200) collect: [:n | n asSmallPositiveDegrees]"! !


!Float class methodsFor: 'constants' stamp: 'sw 10/8/1999 22:59'!
halfPi
	^ Halfpi! !


!PasteUpMorph methodsFor: 'menu & halo' stamp: 'sw 1/10/2000 16:44'!
defersHaloOnClickTo: aSubMorph
	"If a cmd-click on aSubMorph would make it a preferred recipient of the halo, answer true"
	^ true
	! !

!PasteUpMorph methodsFor: 'menu & halo' stamp: 'sw 12/30/1999 19:51'!
seeksOutHalo
	"Answer whether the receiver is an eager recipient of the halo"
	^ false! !

!PasteUpMorph methodsFor: 'menu & halo' stamp: 'sw 1/27/2000 15:32'!
wantsHaloFor: aSubMorph
	"Answer whether the receiver wishes for a mouse-over halo to be produced for aSubMorph"

	^ wantsMouseOverHalos == true and:
		 [self visible and:
			[isPartsBin ~~ true and:
				[openToDragNDrop ~~ false and:
					[self isWorldMorph not or: [aSubMorph renderedMorph isLikelyRecipientForMouseOverHalos]]]]]

	"The odd logic at the end of the above says...

		*  If we're an interior playfield, then if we're set up for mouseover halos, show em.
		*  If we're a World that's set up for mouseover halos, only show 'em if the putative
				recipient is a SketchMorph.

	This (old) logic was put in to suit a particular need in early e-toy days and seems rather strange now!!"! !

!PasteUpMorph methodsFor: 'menu & halo' stamp: 'sw 1/25/2000 17:44'!
wantsHaloFromClick
	^ (owner isKindOf: SystemWindow) not! !

!PasteUpMorph methodsFor: 'options' stamp: 'sw 1/27/2000 14:51'!
toggleMouseOverHalos
	wantsMouseOverHalos _ self wantsMouseOverHalos not! !


!Preferences class methodsFor: 'initialization' stamp: 'sw 11/26/1999 18:23'!
absorbAdditions
	"Preferences absorbAdditions"
	self initializeAddedPreferences.
	self initializeHelpMessages.! !

!Preferences class methodsFor: 'parameters' stamp: 'sw 1/27/2000 23:02'!
parameterAt: aKey
	^ Parameters at: aKey ifAbsent: [nil]! !

!Preferences class methodsFor: 'help' stamp: 'sw 1/27/2000 17:11'!
helpMsgsGThroughP
		^ #(

(ignoreStyleIfOnlyBold
	'If true, then any method submission in which the only style change is for bolding will be treated as a method with no style specifications')

(inboardScrollbars
	'If true, then ScrollPane will place scrollbars inside on the right and will not hide them on exit')

(logDebuggerStackToFile
	'If true, whenever you fall into a debugger a summary of its stack will be written to a file named
''SqueakDebug.log''')

(menuColorFromWorld
	'Governs whether the colors used in morphic menus should be derived from the color of the world background.')

(mvcProjectsAllowed
	'If true, the open... menu will offer you the chance to open an mvc project.')

(noviceMode 
	'If true, certain novice-mode accommodations are made.')

(oneViewerFlapAtATime
	'If true, opening up one viewer flap will close all other such flaps.')

(optionalButtons
	'If true, then optional buttons will be used in certain standard tools, including browsers, message lists, fileLists, changeLists, and debuggers')

(personalizedWorldMenu
	'If true, then a right-click (Mac option-click) on the morphic desktop will bring up the customizable "personalized" menu; if false, then it will bring up the standard world menu.')

(preserveTrash
	'Whether morphs dismissed via halo or dragged into the Trash should be preserved in the TrashCan for possible future retrieval.  If false, they are not preserved.')

(printAlternateSyntax
	'If true, then
prettyPrint using experimental syntax.
Otherwise use normal ST-80 syntax.')

(projectsSentToDisk
	'If true, entering a new project swaps it in and swaps out other projects as appropriate. Projects are swapped in and out as ImageSegments, stored as files on disk in an image segment folder associated with the current image.')

(projectZoom
	'If true, then show a zoom effect when entering or leaving projects.  This can be costly of memory (at least an extra screen buffer) so dont use it in low space situations.  But it is cool.')

(promptForUpdateServer
	'If false, the prompt for server choice when updating code from the server is suppressed.  Set this to false to leave the server choice unchanged from update to update.')

			) 
! !

!Preferences class methodsFor: 'help' stamp: 'sw 1/28/2000 10:00'!
helpMsgsQThroughZ

	^ #(	
(reverseWindowStagger
	'If true, a reverse-stagger strategy  is used for determining where newly launched windows will be placed; if false, a direct- stagger strategy is used.')

(roundedMenuCorners
	'Whether morphic menus should have rounded corners')

(roundedWindowCorners
	'Governs whether morphic system windows should have rounded corners')

(scrollBarsNarrow
		'If true, morphic scrollbars will be narrow.')
(scrollBarsOnRight
		'If true, morphic scrollbars in subsequently opened windows will appear on the right side of their pane.')
(scrollBarsWithoutMenuButton
		'If true, morphic scrollbars in subsequently opened windows will not include a menu button.')

(showPlayerSource
	'If true, then all Player methods with fewer than 2 arguments are included in Viewers, whether or not they are intended for end-user use.  This can be dangerous')

(showScriptSource
	'If true, then the actual Smalltalk source code for methods is shown in the detail panes for scripts in a viewer; if false, then a help message for scripts is shown instead.')

(smartUpdating
	'If true, then morphic tools such as browsers and inspectors will keep their contents up to date automatically, so that if something changes anywhere, the change will be reflected everywhere.')

(soundQuickStart
	'If true, attempt to start playing sounds using optional "quick start"')

(soundsEnabled
	'If false, all sound playing is disabled')

(systemWindowEmbedOK
	'Determines whether, in Morphic, when a SystemWindow is dropped onto a willing receptor it should be deposited into that receptor.')

(timeStampsInMenuTitles
	'If true, then the author''s timestamp is displayed as the menu title of any message list; if false, no author''s timestamps are shown')

(thoroughSenders
	'If true, then ''senders'' browsers will dive inside structured literals in their search')

(twentyFourHourFileStamps
	'If #changeSetVersionNumbers is false, this preference determines whether the date/time suffix used with changeset fileouts is based on a 24-hr clock or a 12-hr clock.')

(uniformWindowColors
	'If true, then all standard windows are given the same color rather than their customized window-type-specific colors')

(unlimitedPaintArea
	'If true, the painting area for a new drawing will not be limited in size; if false, a reasonable
limit will be applied, in an attempt to hold down memory and time price.')

(updateRemoveSequenceNum
	'If true, then remove the leading sequence number from the filename before automatically saving a local copy of any update loaded.')

(updateSavesFile
	'If true, then when an update is loaded from the server, a copy of it will automatically be saved on a local file as well.')

(useDetailPanesInViewers
	'If true, then Viewers will have an extra "" control at the left of each row, the hitting of which toggles the appearance of a textual detail pane.')

(useGlobalFlaps
	'If true, then flaps are shown along the edges of Morphic projects.')

(viewersInFlaps
	'If true, viewers are projected into flaps along the right edge of the screen')

(warnIfNoChangesFile
	'If true, then you will be warned, whenever you start up, if no changes file
can be found')

(warnIfNoSourcesFile 
	'If true, then you will be warned, whenever you start up, if no sources file can be found')


			) 
! !

!Preferences class methodsFor: 'initial values' stamp: 'sw 1/27/2000 23:28'!
initialValuesAToM
	"CategoryInfo _ nil"
	"Preferences openFactoredPanel"
	^#(
		(annotationPanes					false	(browsing))
		(autoAccessors						false	(general))
		(automaticViewerPlacement			true	(scripting))
		(balloonHelpEnabled					true	(morphic))
		(browserShowsPackagePane			false	(browsing))
		(browseWithPrettyPrint				false	(browsing))
		(caseSensitiveFinds					false	(general))
		(cautionBeforeClosing				false	(windows))
		(changeSetVersionNumbers			true	(fileout))
		(checkForSlips						true	(fileout))
		(clickOnLabelToEdit					true	(windows))
		(cmdDotEnabled						true	(debug))
		(colorWhenPrettyPrinting			false	(browsing))
		(compressFlashImages				false	(media))
		(confirmFirstUseOfStyle				true	(browsing))
		(conversionMethodsAtFileOut			false	(fileout))
		(debugHaloHandle					true	(debug halos))
		(diffsInChangeList					true	(browsing))
		(extractFlashInHighQuality			true	(media))
		(extractFlashInHighestQuality		false	(media))
		(fastDragWindowForMorphic			false	(windows))
		(fenceEnabled						true	(scripting))
		(ignoreStyleIfOnlyBold				true	(browsing))
		(inboardScrollbars					false	(scrolling))
		(logDebuggerStackToFile				true	(debug))
		(menuColorFromWorld				false	(menus))
		(mvcProjectsAllowed					false	(general))
)
! !

!Preferences class methodsFor: 'initial values' stamp: 'sw 1/28/2000 10:00'!
initialValuesNToZ
	"Another lot of initial values for prefs.  Simply placing methods of this sort in the 'initial values' category will assure that the initial values provided are ascribed to the preference when prefs are initialized"

	^ #(	
		(noviceMode							false	(general))
		(oneViewerFlapAtATime				true	(scripting))
		(optionalButtons						false	(general))
		(personalizedWorldMenu				true	(menus))
		(preserveTrash						true	(morphic))
		(printAlternateSyntax				false	(browsing))
		(projectsSentToDisk					false	(general))
		(projectZoom							false	(general))
		(promptForUpdateServer				true	(updates))
		(reverseWindowStagger				true	(windows))
		(roundedMenuCorners				true	(menus))
		(roundedWindowCorners				false	(windows))
		(scrollBarsNarrow					false	(scrolling))
		(scrollBarsOnRight					false	(scrolling))
		(scrollBarsWithoutMenuButton		false	(menus scrolling))
		(smartUpdating						true	(browsing))
		(soundsEnabled						false	(media))
		(soundQuickStart					false	(media))
		(systemWindowEmbedOK				false	(windows))
		(thoroughSenders					true	(general))
		(timeStampsInMenuTitles				false	(menus))
		(twentyFourHourFileStamps			true	(fileout)) 
		(unlimitedPaintArea					false	(morphic))
		(updateSavesFile						false	(updates))
		(useGlobalFlaps						true	(morphic))
		(viewersInFlaps						true	(scripting))
		(warnIfNoChangesFile				true	(general))
		(warnIfNoSourcesFile				true	(general))

)
	"Preferences resetCategoryInfo"


! !

!Preferences class methodsFor: 'factored pref panel' stamp: 'sw 1/27/2000 23:47'!
addHaloControlsTo: controlPage
	| aButton |
	controlPage addTransparentSpacerOfSize: (0 @ 4).
	controlPage addMorphBack: self haloThemeRadioButtons.
	controlPage addTransparentSpacerOfSize: (0 @ 4).
	aButton _ SimpleButtonMorph new target: self; color: Color transparent; actionSelector: #editCustomHalos; label: 'Edit custom halos'.
	controlPage addMorphBack: aButton.
	aButton setBalloonText: 'Click here to edit the method that defines the custom halos'.
			! !

!Preferences class methodsFor: 'factored pref panel' stamp: 'sw 1/27/2000 23:37'!
openFactoredPanelWithWidth: aWidth
	"Preferences openFactoredPanelWithWidth: 325"
	| tabbedPalette controlPage window playfield aColor aFont  maxEntriesPerCategory tabsMorph |
	aFont _ StrikeFont familyName: 'NewYork' size: 19.
	aColor _ Color r: 0.645 g: 1.0 b: 1.0.
	tabbedPalette _ TabbedPalette newSticky.
	(tabsMorph _ tabbedPalette tabsMorph) color: aColor darker; highlightColor: Color red regularColor: Color brown darker darker.
	maxEntriesPerCategory _ 0.
	"tabbedPalette addTabFor: self helpPaneForFactoredPanel font: aFont.  LATER!!"
	self factoredCategories do:
		[:aCat |
			controlPage _ AlignmentMorph newColumn beSticky color: aColor.
			controlPage borderColor: aColor; inset: 4.
			aCat second do:
				[:aPrefSymbol |
					controlPage addMorphBack:
						(Preferences buttonRepresenting: aPrefSymbol wording: aPrefSymbol color: nil)].
			controlPage setNameTo: aCat first asString.
			aCat first == #halos ifTrue:
				[self addHaloControlsTo: controlPage].
			tabbedPalette addTabFor: controlPage font: aFont.
			maxEntriesPerCategory _ maxEntriesPerCategory max: aCat second size].
	tabbedPalette selectTabNamed: 'general'.
	tabsMorph rowsNoWiderThan: aWidth.
	playfield _ PasteUpMorph newSticky extent: (aWidth @ (25 + tabsMorph height + (20 * maxEntriesPerCategory))).
	playfield color: aColor.
	playfield addMorphBack: tabbedPalette.
	Smalltalk isMorphic
		ifTrue:
			[window _ (SystemWindow labelled: 'Preferences') model: nil.
			window bounds: ((100@100- ((0@window labelHeight) + window borderWidth))
								extent: (playfield extent + window borderWidth)).
			window addMorph: playfield frame: (0@0 extent: 1@1).
			window updatePaneColors.
			window position: 200 @ 20.
			World addMorph: window.
			World startSteppingSubmorphsOf: window.
			window activate]
		ifFalse:
			[(window _ MVCWiWPasteUpMorph newWorldForProject: nil) addMorph: playfield.
			window startSteppingSubmorphsOf: playfield.
			MorphWorldView openOn: window  label: 'Preferences' extent: window fullBounds extent]

! !

!Preferences class methodsFor: 'halos' stamp: 'sw 1/28/2000 09:47'!
classicHaloSpecs
	"Non-iconic halos with traditional placements"

	"Preferences installClassicHaloSpecs"
	"Preferences resetHaloSpecifications"  "  <-  will result in the standard default halos being reinstalled"
	"NB: listed below in clockwise order"

		^ #(
	"  	selector				horiz		vert			color info						icon key
		---------				------		-----------		-------------------------------		---------------"
	(addMenuHandle:		left			top				(red)							none)
	(addDismissHandle:		leftCenter	top				(red		muchLighter)			'Halo-Dismiss')
	(addGrabHandle:			center		top				(black)							none)
	(addDragHandle:			rightCenter	top				(brown)							none)
	(addDupHandle:			right		top				(green)							none)	
	(addDebugHandle:		right		topCenter		(blue	veryMuchLighter)		none)
	(addPaintBgdHandle:		right		center			(lightGray)						none)
	(addRepaintHandle:		right		center			(lightGray)						none)
	(addGrowHandle:		right		bottom			(yellow)						none)
	(addScaleHandle:		right		bottom			(lightOrange)					none)
	(addFontEmphHandle:	rightCenter	bottom			(lightBrown darker)				none)
	(addFontStyleHandle:		center		bottom			(lightRed)						none)
	(addFontSizeHandle:		leftCenter	bottom			(lightGreen)						none)
	(addRotateHandle:		left			bottom			(blue)							none))

! !

!Preferences class methodsFor: 'halos' stamp: 'sw 1/27/2000 23:07'!
classicHalosInForce
	^ (self parameterAt: #HaloTheme) == #classicHaloSpecs! !

!Preferences class methodsFor: 'halos' stamp: 'sw 1/28/2000 09:47'!
customHaloSpecs
	"Intended for you to modify to suit your personal preference.  What is implemented in the default here is just a skeleton; in comment at the bottom of this method are some useful lines you may wish to paste in to the main body here, possibly modifying positions, colors, etc..
	Note that in this example, we include:
			Dismiss handle, at top-left
			Menu handle, at top-right
			Resize handle, at bottom-right
			Rotate handle, at bottom-left
			Drag handle, at top-center
			Recolor handle, at left-center.  (this one is NOT part of the standard formulary --
											it is included here to illustrate how to
 											add non-standard halos)
			Note that the optional handles for specialized morphs, such as Sketch, Text, PasteUp, are also included"

	^ #(
	(addDismissHandle:		left			top				(red		muchLighter)			'Halo-Dismiss')
	(addMenuHandle:		right		top				(red)							'Halo-Menu')
	(addDragHandle:			center	top					(brown)							'Halo-Drag')
	(addGrowHandle:		right		bottom			(yellow)						'Halo-Scale')
	(addScaleHandle:		right		bottom			(lightOrange)					'Halo-Scale')

	(addRecolorHandle:		left			center			(green muchLighter lighter)		'Halo-Recolor')

	(addPaintBgdHandle:		right		center			(lightGray)						'Halo-Paint')
	(addRepaintHandle:		right		center			(lightGray)						'Halo-Paint')
	(addFontSizeHandle:		leftCenter	bottom			(lightGreen)						'Halo-FontSize')
	(addFontStyleHandle:		center		bottom			(lightRed)						'Halo-FontStyle')
	(addFontEmphHandle:	rightCenter	bottom			(lightBrown darker)				'Halo-FontEmph')
	(addRotateHandle:		left			bottom			(blue)							'Halo-Rot')

	(addDebugHandle:		right		topCenter		(blue	veryMuchLighter)		'Halo-Debug')


			)

	"  Other useful handles...

  		selector				horiz		vert			color info						icon key
		---------				------		-----------		-------------------------------		---------------

	(addTileHandle:			left			bottomCenter	(lightBrown)					'Halo-Tile')
	(addViewHandle:			left			center			(cyan)							'Halo-View')
	(addGrabHandle:			center		top				(black)							'Halo-Grab')
	(addDragHandle:			rightCenter	top				(brown)							'Halo-Drag')
	(addDupHandle:			right		top				(green)							'Halo-Dup')	
	(addHelpHandle:			center		bottom			(lightBlue)						'Halo-Help')
	(addFewerHandlesHandle:	left		topCenter		(paleBuff)						'Halo-FewerHandles')
	(addPaintBgdHandle:		right		center			(lightGray)						'Halo-Paint')
	(addRepaintHandle:		right		center			(lightGray)						'Halo-Paint')
	"
! !

!Preferences class methodsFor: 'halos' stamp: 'sw 1/27/2000 23:08'!
customHalosInForce
	^ (self parameterAt: #HaloTheme) == #customHaloSpecs! !

!Preferences class methodsFor: 'halos' stamp: 'sw 1/27/2000 23:43'!
editCustomHalos

	Browser openMessageBrowserForClass: Preferences class
		selector: #customHaloSpecs editString: nil! !

!Preferences class methodsFor: 'halos' stamp: 'sw 1/28/2000 10:35'!
haloSpecifications
	"Answer a list of HaloSpecs that describe which halos are to be used, what they should look like, and where they should be situated"
	"Preferences resetHaloSpecifications"

	^ Parameters at: #HaloSpecs ifAbsent:
			[self installHaloTheme: #iconicHaloSpecifications]

	"Preferences haloSpecifications"! !

!Preferences class methodsFor: 'halos' stamp: 'sw 1/26/2000 19:35'!
haloSpecificationsForWorld
	| desired |
	"Answer a list of HaloSpecs that describe which halos are to be used on a world halo, what they should look like, and where they should be situated"
	"Preferences resetHaloSpecifications"

	desired _ #(addDebugHandle: addMenuHandle: addTileHandle: addViewHandle: addHelpHandle: addScriptHandle:).
	^ self haloSpecifications select:
		[:spec | desired includes: spec addHandleSelector]! !

!Preferences class methodsFor: 'halos' stamp: 'sw 1/27/2000 22:52'!
haloTheme
	^ Parameters at: #HaloTheme ifAbsent: [Parameters at: #HaloTheme put: #iconic]! !

!Preferences class methodsFor: 'halos' stamp: 'sw 1/28/2000 09:50'!
haloThemeRadioButtons
	| buttonColumn aRow aRadioButton aStringMorph |
	buttonColumn _ AlignmentMorph newColumn beTransparent.
	#(	(iconicHaloSpecifications iconic iconicHalosInForce	'circular halos with icons inside')
		(classicHaloSpecs	classic	classicHalosInForce		'plain circular halos')
		(simpleFullHaloSpecifications		simple	simpleHalosInForce	'fewer, larger halos')
		(customHaloSpecs	custom	customHalosInForce		'customizable halos')) do:

		[:quad |
			aRow _ AlignmentMorph newRow beTransparent.
			aRow addMorph: (aRadioButton _ UpdatingThreePhaseButtonMorph radioButton).
			aRadioButton target: Preferences.
			aRadioButton setBalloonText: quad fourth.
			aRadioButton actionSelector: #installHaloTheme:.
			aRadioButton getSelector: quad third.
			aRadioButton arguments: (Array with: quad first).
			aRow addTransparentSpacerOfSize: (4 @ 0).
			aRow addMorphBack: (aStringMorph _ StringMorph contents: quad second asString).
			aStringMorph setBalloonText: quad fourth.
			buttonColumn addMorphBack: aRow].
	^ buttonColumn

	"self currentHand attachMorph: Preferences haloThemeRadioButtons"! !

!Preferences class methodsFor: 'halos' stamp: 'sw 1/28/2000 09:58'!
iconicHaloSpecifications

	"Preferences resetHaloSpecifications"

	^ #(
	"  	selector				horiz		vert			color info						icon key
		---------				------		-----------		-------------------------------		---------------"
	(addDebugHandle:		right		topCenter		(blue	veryMuchLighter)		'Halo-Debug')
	(addDismissHandle:		left			top				(red		muchLighter)			'Halo-Dismiss')
	(addRotateHandle:		left			bottom			(blue)							'Halo-Rot')
	(addMenuHandle:		leftCenter	top				(red)							'Halo-Menu')
	(addTileHandle:			left			bottomCenter	(lightBrown)					'Halo-Tile')
	(addViewHandle:			left			center			(cyan)							'Halo-View')
	(addGrabHandle:			center		top				(black)							'Halo-Grab')
	(addDragHandle:			rightCenter	top				(brown)							'Halo-Drag')
	(addDupHandle:			right		top				(green)							'Halo-Dup')	
	(addHelpHandle:			center		bottom			(lightBlue)						'Halo-Help')
	(addGrowHandle:		right		bottom			(yellow)						'Halo-Scale')
	(addScaleHandle:		right		bottom			(lightOrange)					'Halo-Scale')
	(addScriptHandle:		right		bottomCenter	(green muchLighter)			'Halo-Script')
	(addPaintBgdHandle:		right		center			(lightGray)						'Halo-Paint')
	(addRepaintHandle:		right		center			(lightGray)						'Halo-Paint')
	(addFontSizeHandle:		leftCenter	bottom			(lightGreen)						'Halo-FontSize')
	(addFontStyleHandle:		center		bottom			(lightRed)						'Halo-FontStyle')
	(addFontEmphHandle:	rightCenter	bottom			(lightBrown darker)				'Halo-FontEmph')
		) ! !

!Preferences class methodsFor: 'halos' stamp: 'sw 1/27/2000 23:25'!
iconicHalosInForce
	^ (self parameterAt: #HaloTheme) == #iconicHaloSpecifications! !

!Preferences class methodsFor: 'halos' stamp: 'sw 1/28/2000 10:35'!
installClassicHaloSpecs
	"Install an alternative set of halos,  rather more based on the old placements, and without icons, , and lacking the scripting-relating handles.."
	"Preferences installClassicHaloSpecs"
	"Preferences resetHaloSpecifications"  "  <-  will result in the standard default halos being reinstalled"
	self installHaloTheme: #classicHaloSpecs! !

!Preferences class methodsFor: 'halos' stamp: 'sw 1/28/2000 10:36'!
installCustomHaloSpecs
	"Install an alternative set of halos, as customized by the user"
	"Preferences installCustomHaloSpecs"
	self installHaloTheme: #customHaloSpecs! !

!Preferences class methodsFor: 'halos' stamp: 'sw 1/27/2000 16:45'!
installHaloSpecsFromArray: anArray

	| aColor |
	^ Parameters at: #HaloSpecs put: 
		(anArray collect:
			[:quin |
				aColor _ Color.
				quin fourth do: [:sel | aColor _ aColor perform: sel].
				HaloSpec new 
					horizontalPlacement: quin second
					verticalPlacement: quin third 
					color: aColor
					iconSymbol: quin fifth
					addHandleSelector: quin first])! !

!Preferences class methodsFor: 'halos' stamp: 'sw 1/27/2000 23:15'!
installHaloTheme: themeSymbol
	self installHaloSpecsFromArray: (self perform: themeSymbol).
	self setParameter: #HaloTheme to: themeSymbol
	! !

!Preferences class methodsFor: 'halos' stamp: 'sw 1/28/2000 10:36'!
installIconicHaloSpecs
	"Install an alternative set of halos,  rather more based on the old placements, and without icons, , and lacking the scripting-relating handles.."
	"Preferences installIconicHaloSpecs"
	self installHaloTheme: #iconicHaloSpecifications! !

!Preferences class methodsFor: 'halos' stamp: 'sw 1/28/2000 10:36'!
installSimpleHaloSpecs
	"Preferences installSimpleHaloSpecs"
	self installHaloTheme: #simpleFullHaloSpecifications! !

!Preferences class methodsFor: 'halos' stamp: 'sw 1/25/2000 20:10'!
resetHaloSpecifications
	"Preferences resetHaloSpecifications"

	^ Parameters removeKey: #HaloSpecs ifAbsent: []! !

!Preferences class methodsFor: 'halos' stamp: 'sw 1/28/2000 09:48'!
simpleFullHaloSpecifications
	"This method gives the specs for the 'full' handles variant when simple halos are in effect"

	"Preferences resetHaloSpecifications"

	^ #(
	"  	selector				horiz		vert			color info						icon key
		---------				------		-----------		-------------------------------		---------------"
	(addDebugHandle:		right		topCenter		(blue	veryMuchLighter)		'Halo-Debug')
	(addDismissHandle:		left			top				(red		muchLighter)			'Halo-Dismiss')
	(addRotateHandle:		left			bottom			(blue)							'Halo-Rot')
	(addMenuHandle:		leftCenter	top				(red)							'Halo-Menu')
	(addTileHandle:			left			bottomCenter	(lightBrown)					'Halo-Tile')
	(addViewHandle:			left			center			(cyan)							'Halo-View')
	(addGrabHandle:			center		top				(black)							'Halo-Grab')
	(addDragHandle:			rightCenter	top				(brown)							'Halo-Drag')
	(addDupHandle:			right		top				(green)							'Halo-Dup')	
	(addHelpHandle:			center		bottom			(lightBlue)						'Halo-Help')
	(addGrowHandle:		right		bottom			(yellow)						'Halo-Scale')
	(addScaleHandle:		right		bottom			(lightOrange)					'Halo-Scale')
	(addFewerHandlesHandle:	left		topCenter		(paleBuff)						'Halo-FewerHandles')
	(addScriptHandle:		right		bottomCenter	(green muchLighter)			'Halo-Script')
	(addPaintBgdHandle:		right		center			(lightGray)						'Halo-Paint')
	(addRepaintHandle:		right		center			(lightGray)						'Halo-Paint')
	(addFontSizeHandle:		leftCenter	bottom			(lightGreen)						'Halo-FontSize')
	(addFontStyleHandle:		center		bottom			(lightRed)						'Halo-FontStyle')
	(addFontEmphHandle:	rightCenter	bottom			(lightBrown darker)				'Halo-FontEmph')
		) ! !

!Preferences class methodsFor: 'halos' stamp: 'sw 1/28/2000 09:50'!
simpleHalosInForce
	^ (self parameterAt: #HaloTheme) == #simpleFullHaloSpecifications! !


!SketchMorph methodsFor: 'menu' stamp: 'sw 1/18/2000 00:31'!
resetForwardDirection
	| existingSetup |
	existingSetup _ self setupAngle.
	self setupAngle: 0.
	self topRendererOrSelf player turn: existingSetup negated.
	self layoutChanged.
	self changed! !

!SketchMorph methodsFor: 'menu' stamp: 'sw 1/25/2000 17:38'!
setRotationCenterFromGlobalPosition: aPosition
	| localPoint newCenter |
	self flag: #noteToAndreas.  
		"This is the place that does the real work of setting a new rotation center after the user has indicated one by manipulating the halo handle.  At prresent, it will not actually be reachable when setupAngle is other than 0, because it doesn't work right"

	scalePoint _ 1.0@1.0.
	self rotationDegrees: 0.
	localPoint _ self transformFromWorld globalPointToLocal: aPosition.
	newCenter _ localPoint - bounds origin.
	self rotationCenter: newCenter - offsetWhenRotated.
	self referencePositionInWorld: aPosition.
	self layoutChanged
! !

!SketchMorph methodsFor: 'other' stamp: 'sw 1/27/2000 17:39'!
addOptionalHandlesTo: aHalo box: box
	aHalo addDirectionHandles! !

!SketchMorph methodsFor: 'other' stamp: 'sw 1/27/2000 19:19'!
canSetColor
	"Answer true iff the receiver can meaningfully have its color changed"
	^ false! !

!SketchMorph methodsFor: 'other' stamp: 'sw 1/25/2000 17:36'!
couldSetRotationCenterFromHalo
	self flag: #noteToAndreas.  
	"Make this simply ^ true to allow the rotation center always to be set..."
	
	^ self setupAngle = 0! !


!StandardScriptingSystem methodsFor: 'form dictionary' stamp: 'sw 10/6/1999 20:56'!
convertAllKeysToSymbols
	| newDict |
	"ScriptingSystem convertAllKeysToSymbols"
	newDict _ IdentityDictionary new.
	FormDictionary associationsDo:
		[:assoc |
			newDict at: assoc key asSymbol put: assoc value].
	FormDictionary _ newDict

"(FormDictionary keys asArray collect: [:k | k class name]) asBag sortedElements"! !

!StandardScriptingSystem methodsFor: 'form dictionary' stamp: 'sw 10/6/1999 20:57'!
formAtKey: aKey
	"ScriptingSystem saveForm: (TileMorph downPicture) atKey: 'downArrow'"
	^ FormDictionary at: aKey asSymbol ifAbsent: [nil]! !

!StandardScriptingSystem methodsFor: 'form dictionary' stamp: 'sw 10/6/1999 20:57'!
saveForm: aForm atKey: aKey
	FormDictionary at: aKey asSymbol put: aForm! !


!SystemWindow methodsFor: 'events' stamp: 'sw 12/22/1999 18:31'!
wantsHalo
	^ false! !

!SystemWindow methodsFor: 'events' stamp: 'sw 12/22/1999 18:41'!
wantsHaloFromClick
	^ false! !


!TTSampleFontMorph methodsFor: 'accessing' stamp: 'sw 1/27/2000 15:43'!
addOptionalHandlesTo: aHalo box: box
	aHalo addHandleAt: box center color: Color magenta icon: nil on: #mouseDown send: #createSample to: self.! !


!TabbedPalette methodsFor: 'parts & controls tabs' stamp: 'sw 1/27/2000 13:29'!
addControlsTab
	| controlPage |
	controlPage _ AlignmentMorph newColumn beSticky color: Color white.

	controlPage addMorphBack:
		(Preferences buttonRepresenting: #balloonHelpEnabled wording: 'Balloon Help' color: nil).

	controlPage addMorphBack:
		(Preferences buttonRepresenting: #fenceEnabled wording: 'Fence Enabled' color: nil).

	controlPage addMorphBack:
		(Preferences buttonRepresenting: #soundsEnabled wording: 'Sound Enabled' color: nil).

	controlPage setNameTo: 'controls'.
	self addTabForBook: controlPage  withBalloonText:
'controls to turn sound,
balloon help, etc., on and off'! !

!TabbedPalette methodsFor: 'user-interface' stamp: 'sw 1/11/2000 18:08'!
defersHaloOnClickTo: aSubMorph
	"If a cmd-click on aSubMorph would make it a preferred recipient of the halo, answer true"

	^ currentPage notNil and:
		[(aSubMorph hasInOwnerChain: currentPage)
			and: [currentPage defersHaloOnClickTo: aSubMorph]]
	! !


!TransformMorph methodsFor: 'geometry' stamp: 'sw 12/29/1999 15:51'!
wantsHaloFromClick
	^ false! !


!WonderlandWrapperMorph methodsFor: 'handles' stamp: 'sw 12/21/1999 16:36'!
addSimpleHandlesTo: aHaloMorph box: aBox
	self flag: #noteToAndreas. 
		 "May want to reimplement this for wonderland morphs.  For the moment, this basically disallows simple handles in the wonderland case."
	^ aHaloMorph addCircleHandles! !


Morph removeSelector: #addFontHandlesTo:box:!
Morph removeSelector: #definesOwnHaloHandles!
Morph removeSelector: #findSubmorphThat:ifAbsent:!
Morph removeSelector: #wantsHaloFromClickFor:!
HaloMorph removeSelector: #addMenuHandleInBox:!
HaloMorph removeSelector: #addTileHandleInBox:!
HaloMorph removeSelector: #addMoreHandlesHandle:!
HaloMorph removeSelector: #addDirectionShaftInBox:!
HaloMorph removeSelector: #addHandleAt:color:on:send:to:!
HaloMorph removeSelector: #addGrabHandleInBox:!
HaloMorph removeSelector: #addDirectionHandlesInBox:!
HaloMorph removeSelector: #addHandleInBox:horizontalPlacement:verticalPlacement:color:icon:on:send:to:!
HaloMorph removeSelector: #addDebugHandleInBox:!
HaloMorph removeSelector: #removeAllHandlesBut:and:!
HaloMorph removeSelector: #addDismissHandleInBox:!
HaloMorph removeSelector: #addFewerHandlesHandleInBox:!
HaloMorph removeSelector: #addHandleInBox:fromSpec:on:send:to:!
HaloMorph removeSelector: #directionArrowGuideBox!
HaloMorph removeSelector: #addRotateHandleInBox:!
HaloMorph removeSelector: #addHelpHandleInBox:!
HaloMorph removeSelector: #addDupHandleInBox:!
HaloMorph removeSelector: #addSketchMorphHandlesInBox:!
HaloMorph removeSelector: #addHandlesTo:box:!
HaloMorph removeSelector: #addDragHandleInBox:!
HaloMorph removeSelector: #addNascentScriptHandleInBox:!
HaloMorph removeSelector: #addGrowHandleInBox:!
HaloMorph removeSelector: #addHandleInBox:horizontalPlacement:verticalPlacement:color:icon:!
HaloMorph removeSelector: #addViewHandleInBox:!
HaloMorph removeSelector: #addDirectionHandle!
HaloMorph initialize!
PasteUpMorph removeSelector: #wantsHaloFromClickFor:!
PasteUpMorph removeSelector: #addOptionalHandlesTo:box:!
Preferences class removeSelector: #installHaloScheme:!
Preferences class removeSelector: #initialHaloSpecifications!
Preferences class removeSelector: #mouseOverHalosEnabled!
Preferences class removeSelector: #simpleHalos!
Preferences class removeSelector: #installMinimalHaloSpecs!
Preferences class removeSelector: #iconicHalosIInForce!
Preferences class removeSelector: #instalHaloScheme:!
Preferences class removeSelector: #haloType!
Preferences class removeSelector: #iconicHalos!
TextMorph removeSelector: #addOptionalHandlesTo:box:!
WonderlandWrapperMorph removeSelector: #definesOwnHaloHandles!
WonderlandWrapperMorph removeSelector: #addHandlesTo:box:!
"Postscript:
Initialize halo icons in the standard form dictionary"
ScriptingSystem mergeGraphicsFrom: (Dictionary new

	add: ('Halo-Debug' -> (Form extent: 16@16 depth: 1
        fromArray: #( 0 0 0 0 0 266338304 103809024 103809024 103809024 103809024 266338304 0 0 0 0 0)
        offset: 0@0));

	add: ('Halo-Tile' -> (Form extent: 16@16 depth: 1
        fromArray: #( 0 0 0 0 0 536346624 536346624 404226048 404226048 536346624 536346624 0 0 0 0 0)
        offset: 0@0)); add: ('Halo-Scale' -> (Form extent: 16@16 depth: 1
        fromArray: #( 0 0 0 0 265289728 139460608 139460608 139460608 139460608 265289728 1048576 267386880 0 0 0 0)
        offset: 0@0)); add: ('Halo-Menu' -> (Form extent: 16@16 depth: 1
        fromArray: #( 0 0 0 267386880 267386880 267386880 135266304 267386880 135266304 267386880 135266304 267386880 0 0 0 0)
        offset: 0@0)); add: ('Halo-Grab' -> (Form extent: 16@16 depth: 1
        fromArray: #( 0 25165824 25165824 37748736 69206016 135266304 268959744 669253632 338165760 204472320 69206016 69206016 132120576 0 0 0)
        offset: 0@0)); add: ('Halo-Drag' -> (Form extent: 16@16 depth: 1
        fromArray: #( 0 0 0 473432064 268959744 401080320 69206016 69206016 69206016 69206016 401080320 268959744 473432064 0 0 0)
        offset: 0@0)); add: ('Halo-Rot' -> (Form extent: 16@16 depth: 1
        fromArray: #( 0 0 25165824 33554432 0 132120576 69730304 606339072 606339072 337641472 132120576 0 4194304 25165824 0 0)
        offset: 0@0)); add: ('Halo-View' -> (Form extent: 16@16 depth: 1
        fromArray: #( 0 0 0 0 132120576 486014976 770965504 1341259776 669253632 467140608 132120576 0 0 0 0 0)
        offset: 0@0)); add: ('Halo-Dup' -> (Form extent: 16@16 depth: 1
        fromArray: #( 0 0 0 0 528482304 276824064 284688384 277348352 285736960 520617984 17301504 33030144 0 0 0 0)
        offset: 0@0)); add: ('Halo-Dismiss' -> (Form extent: 16@16 depth: 1
        fromArray: #( 0 0 0 0 204472320 242221056 132120576 62914560 62914560 132120576 242221056 204472320 0 0 0 0)
        offset: 0@0)); yourself).
ScriptingSystem saveForm: (Form extent: 24@22 depth: 32
	fromArray: #( 0 8 8 8 8 8 8 8 8 8 8 8 8 8 8 8 8 8 8 8 8 8 8 8 8 524395 1048782 1048782 1048782 1048782 1048782 1048782 1048782 1048782 1048782 1048782 1048782 1048782 1048782 1048782 1048782 1048782 1048782 1048782 1048782 1048782 1048782 8 8 524395 1048782 1048782 1048782 1048782 1048782 1048782 1048782 1048782 1048782 1048782 1048782 1048782 1048782 1048782 1048782 1048782 1048782 1048782 1048782 1048782 1048782 8 8 262201 524395 524395 524395 524395 524395 524395 524395 524395 524395 524395 524395 524395 524395 524395 524395 524395 524395 524395 524395 1048782 1048782 8 0 0 0 0 8 1048782 1048782 1048782 1048782 524395 8 0 0 0 0 0 0 0 0 0 8 1048782 1048782 8 0 0 0 0 8 1048782 1048782 1048782 1048782 1048782 8 0 0 0 0 0 0 0 0 0 8 1048782 1048782 8 0 0 0 0 8 524395 1048782 1048782 1048782 1048782 524395 0 0 0 0 0 0 0 0 0 8 1048782 1048782 8 0 0 0 0 0 262201 1048782 1048782 1048782 1048782 1048782 262201 0 0 0 0 0 0 0 0 8 1048782 1048782 8 0 0 0 0 0 8 786588 1048782 1048782 1048782 1048782 1048782 262201 0 0 0 0 0 0 0 8 1048782 1048782 8 0 0 0 0 0 0 8 1048782 1048782 1048782 1048782 1048782 1048782 262201 8 0 0 0 0 0 8 1048782 1048782 8 0 0 0 0 0 0 0 262201 1048782 1048782 1048782 1048782 1048782 1048782 786588 8 8 0 0 0 8 1048782 1048782 8 0 0 0 0 0 0 0 0 262201 1048782 1048782 1048782 1048782 1048782 1048782 1048782 1048782 524395 8 8 8 1048782 1048782 8 0 0 0 0 0 0 0 0 0 8 786588 1048782 1048782 1048782 1048782 1048782 1048782 1048782 1048782 1048782 8 1048782 1048782 8 0 0 0 0 0 0 0 0 0 0 8 262201 786588 1048782 1048782 1048782 1048782 1048782 1048782 1048782 524395 1048782 1048782 8 0 0 0 0 0 0 0 0 0 0 0 0 8 262201 1048782 1048782 1048782 1048782 1048782 1048782 524395 1048782 1048782 8 0 0 0 0 0 0 0 0 0 0 0 0 0 0 8 262201 524395 524395 524395 8 8 1048782 1048782 8 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 8 8 0 0 8 1048782 1048782 8 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 8 1048782 1048782 8 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 8 1048782 1048782 8 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 8 1048782 1048782 8 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 8 1048782 1048782 8 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 8 524395 524395 8)
	offset: 0@0) atKey: #Rotate.

ScriptingSystem saveForm:  (Form extent: 19@18 depth: 32
	fromArray: #( 0 0 0 0 0 0 0 0 15178752 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 15178752 15178752 15178752 15178752 0 0 0 0 0 0 0 0 0 0 0 0 0 15178752 15178752 15178752 15178752 15178752 15178752 15178752 0 0 0 0 0 0 0 0 0 0 0 15178752 15178752 15178752 15178752 15178752 15178752 15178752 15178752 15178752 0 0 0 0 0 0 0 0 0 15178752 15178752 15178752 15178752 15178752 15178752 15178752 15178752 15178752 15178752 15178752 15178752 0 0 0 0 0 0 15178752 15178752 15178752 15178752 15178752 15178752 15178752 15178752 15178752 15178752 15178752 15178752 15178752 15178752 0 0 0 0 15178752 15178752 15178752 15178752 15178752 0 15178752 15178752 15178752 15178752 15178752 15178752 15178752 15178752 15178752 15178752 0 0 15178752 15178752 15178752 15178752 15178752 0 0 15178752 15178752 15178752 15178752 0 0 15178752 15178752 15178752 15178752 15178752 15178752 15178752 15178752 15178752 15178752 0 0 0 15178752 15178752 15178752 15178752 0 0 0 15178752 15178752 15178752 15178752 15178752 15178752 15178752 15178752 0 0 0 0 15178752 15178752 15178752 15178752 0 0 0 0 15178752 15178752 15178752 15178752 0 0 0 0 0 0 0 15178752 15178752 15178752 15178752 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 15178752 15178752 15178752 15178752 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 15178752 15178752 15178752 15178752 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 15178752 15178752 15178752 15178752 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 15178752 15178752 15178752 15178752 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 15178752 15178752 15178752 15178752 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 15178752 15178752 15178752 15178752 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 15178752 15178752 15178752 15178752 0 0 0 0 0 0 0 0)
	offset: 0@0) atKey: #Direction.

ScriptingSystem saveForm: (Form extent: 22@21 depth: 32
	fromArray: #( 1 1 1 1 1 1 1 1 1 1 1 1 1 0 0 0 0 0 0 0 0 0 1 7564032 15193600 15193600 15193600 15193600 15193600 15193600 15193600 15193600 15193600 7564032 1 0 0 0 0 0 0 0 0 0 1 7564032 15193600 7564036 7564036 7564036 7564036 7564036 7564036 7564036 7564036 7564032 1 0 0 0 0 0 0 0 0 0 1 7564032 15193600 15193600 15193600 15193600 15193600 15193600 15193600 15193600 15193600 7564032 1 0 0 0 0 0 0 0 0 0 1 7564032 15193600 7564036 3749126 7564036 3749126 8 3749126 7564036 11378690 7564032 1 0 0 0 0 0 0 0 0 0 1 7564032 15193600 15193600 15193600 15193600 15193600 15193600 15193600 15193600 15193600 7564032 1 0 0 0 0 0 0 0 0 0 1 7564032 15193600 15193600 15193600 15193600 15193600 7564032 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 7564032 15193600 7564036 7564036 7564036 7564036 3749122 8354560 16774912 16774912 16774912 16774912 16774912 16774912 16774912 16774912 16774912 16774912 16774912 16774912 1 1 7564032 15193600 15193600 15193600 15193600 15193600 7564032 8354560 16774912 16774912 16774912 16774912 16774912 16774912 16774912 16774912 16774912 16774912 16774912 16774912 1 1 7564032 15193600 15193600 15193600 15193600 15193600 7564032 8354560 16774912 8 8 8 8 8 8 4144390 8354564 8354564 12564738 16774912 1 1 1 1 1 1 1 1 1 8354560 16774912 16774912 16774912 16774912 16774912 16774912 16774912 12564738 8354564 8354564 12564738 16774912 1 0 0 0 0 0 0 0 1 8354560 16774912 16774912 16774912 16774912 16774912 16774912 16774912 16774912 16774912 16774912 16774912 16774912 1 0 0 0 0 0 0 0 1 8354560 16774912 16774912 16774912 8354564 16774912 16774912 16774912 16774912 16774912 16774912 16774912 16774912 1 0 0 0 0 0 0 0 1 8354560 16774912 8354564 8 4144390 8 8 8 4144390 4144390 8 4144390 16774912 1 0 0 0 0 0 0 0 1 8354560 16774912 16774912 16774912 16774912 16774912 16774912 16774912 12564738 12564738 16774912 16774912 16774912 1 0 0 0 0 0 0 0 1 8354560 16774912 16774912 16774912 16774912 16774912 16774912 16774912 16774912 16774912 16774912 16774912 16774912 1 0 0 0 0 0 0 0 1 8354560 16774912 16774912 16774912 16774912 8354564 16774912 16774912 16774912 12564738 16774912 16774912 16774912 1 0 0 0 0 0 0 0 1 8354560 16774912 8354564 8 8 4144390 8 8 8 4144390 16774912 16774912 16774912 1 0 0 0 0 0 0 0 1 8354560 16774912 16774912 16774912 16774912 16774912 12564738 16774912 16774912 16774912 16774912 16774912 16774912 1 0 0 0 0 0 0 0 1 8354560 16774912 16774912 16774912 16774912 16774912 16774912 16774912 16774912 16774912 16774912 16774912 16774912 1 0 0 0 0 0 0 0 0 1 1 1 1 1 1 1 1 1 1 1 1 1 1)
	offset: 0@0) atKey: #Scale.

ScriptingSystem saveForm: (Form extent: 18@18 depth: 16
	fromArray: #( 0 0 0 199232480 199232480 199232480 0 0 0 0 0 199232480 199232480 199232480 199232480 199232480 0 0 0 199232480 199232480 199232480 199232480 199232480 199232480 199232480 0 0 199232480 199232480 199232480 199232480 199232480 199232480 199232480 0 3040 199232480 199232480 199232480 199232480 199232480 199232480 199232480 199229440 3040 199232480 199232480 199261190 2080799750 2080771040 199232480 199232480 199229440 199232480 199232480 199232480 2080799750 2080799750 2080799750 199232480 199232480 199232480 199232480 199232480 199261190 2080799750 2080799750 2080799750 2080771040 199232480 199232480 199232480 199232480 199261190 2080799750 2080799750 2080799750 2080771040 199232480 199232480 199232480 199232480 199261190 2080799750 2080799750 2080799750 2080771040 199232480 199232480 199232480 199232480 199261190 2080799750 2080799750 2080799750 2080771040 199232480 199232480 199232480 199232480 199232480 2080799750 2080799750 2080799750 199232480 199232480 199232480 3040 199232480 199232480 199261190 2080799750 2080771040 199232480 199232480 199229440 3040 199232480 199232480 199232480 199232480 199232480 199232480 199232480 199229440 0 199232480 199232480 199232480 199232480 199232480 199232480 199232480 0 0 199232480 199232480 199232480 199232480 199232480 199232480 199232480 0 0 0 199232480 199232480 199232480 199232480 199232480 0 0 0 0 0 199232480 199232480 199232480 0 0 0)
	offset: 0@0) atKey: #RotationCenter.

ScriptingSystem mergeGraphicsFrom:  (Dictionary new
	add: ('Halo-Paint' -> (Form extent: 16@16 depth: 1
	fromArray: #( 0 0 0 402653184 503316480 192937984 213909504 73400320 103809024 51904512 25690112 14155776 7340032 0 0 0) offset: 0@0)); 

	add: ('Halo-FontStyle' -> (Form extent: 16@16 depth: 1
	fromArray: #( 0 0 0 0 527958016 155189248 138412032 171966464 242221056 171966464 138412032 138412032 473956352 0 0 0) offset: 0@0)); 

	add: ('Halo-FontSize' -> (Form extent: 16@16 depth: 1
	fromArray: #( 0 0 0 15728640 8388608 8388608 8388608 243269632 148897792 142606336 209715200 142606336 142606336 0 0 0) offset: 0@0));

	add: ('Halo-FontEmph' -> (Form extent: 16@16 depth: 1
	fromArray: #( 0 0 0 0 532414464 530579456 404750336 406847488 511180800 507510784 411041792 411041792 411041792 0 0 0) offset: 0@0));

	add: ('Halo-Debug' -> (Form extent: 16@16 depth: 1
	fromArray: #( 0 0 0 50331648 25165824 12582912 281018368 415236096 264241152 132120576 7340032 3670016 1572864 0 0 0) offset: 0@0));

	add: ('Halo-Help' -> (Form extent: 16@16 depth: 1
	fromArray: #( 0 0 62914560 132120576 204472320 204472320 3145728 6291456 12582912 25165824 25165824 0 25165824 25165824 0 0) offset: 0@0));

	yourself).
Preferences deletePreference: #mouseOverHalosEnabled.
Preferences deletePreference: #iconicHalos.
Preferences deletePreference: #simpleHalos.
Preferences absorbAdditions.
Preferences installHaloTheme: #iconicHaloSpecifications.
Utilities replaceToolsFlap.
ScriptingSystem resetStandardPartsBin.!

