'From Squeak2.8alpha of 13 January 2000 [latest update: #1844] on 7 February 2000 at 1:42:24 am'!
"Change Set:		recentLogFile-sw
Date:			9 February 2000
Author:			Scott Wallace

Adds to the 'changes' branch of the screen/world menus a command allowing recent entries of the system log to be logged to a file, onto which a window is then opened.  This combines the fucnctionality of the 'Smalltalk recover: xxx' and the 'ChangeList browseRecentLog' features.

Some minor adjustments in wordings in the changes menu

Also (unrelated) -- temporarily removed a prematurely-published method in Preferences."!


!ChangeList methodsFor: 'viewing access' stamp: 'sw 2/7/2000 01:32'!
diffedVersionContents
	| thisText |
	(listIndex = 0 or: [changeList size < listIndex])
		ifTrue: [^ ''].
	thisText _ (changeList at: listIndex) text.
	^ listIndex == changeList size
		ifTrue:
			[thisText]
		ifFalse:
			[TextDiffBuilder buildDisplayPatchFrom: (changeList at: (listIndex + 1)) text to: thisText]! !


!ChangeList class methodsFor: 'public access' stamp: 'sw 2/3/2000 16:16'!
getRecentLocatorWithPrompt: aPrompt
	"Prompt with a menu of how far back to go.  Return nil if user backs out.  Otherwise return the number of characters back from the end of the .changes file the user wishes to include"
	 "ChangeList getRecentPosition"
	| end changesFile banners positions pos chunk i |
	changesFile _ (SourceFiles at: 2) readOnlyCopy.
	banners _ OrderedCollection new.
	positions _ OrderedCollection new.
	end _ changesFile size.
	pos _ Smalltalk lastQuitLogPosition.
	[pos = 0 or: [banners size > 20]] whileFalse:
		[changesFile position: pos.
		chunk _ changesFile nextChunk.
		i _ chunk indexOfSubCollection: 'priorSource: ' startingAt: 1.
		i > 0 ifTrue: [positions addLast: pos.
					banners addLast: (chunk copyFrom: 5 to: i-2).
					pos _ Number readFrom: (chunk copyFrom: i+13 to: chunk size)]
			ifFalse: [pos _ 0]].
	changesFile close.
	pos _ (SelectionMenu labelList: banners selections: positions)
				startUpWithCaption: aPrompt.
	pos == nil ifTrue: [^ nil].
	^ end - pos! !


!HandMorph methodsFor: 'world menu' stamp: 'sw 2/7/2000 01:17'!
changesMenu
	"Build the changes menu for the world."
	| menu |
	menu _ (MenuMorph entitled: 'changes...') defaultTarget: self.
	menu addStayUpItem.
	menu add: 'file out current change set' target: Utilities action: #fileOutChanges.
	menu balloonTextForLastItem: 'Write the current change set out to a file whose name reflects the change set name and the current date & time.'.

	menu add: 'create new change set...' target: ChangeSorter action: #newChangeSet.
	menu balloonTextForLastItem: 'Create a new change set and make it the current one.'.

	menu add: 'methods in current change set' action: #browseChangedMessages.
	menu balloonTextForLastItem: 'Open a message-list browser showing all methods in the current change set'.

	menu add: 'check change set for slips' target: Smalltalk changes action: #lookForSlips.
	menu balloonTextForLastItem: 'Check the current change set for halts, references to the Transcript, etc., and if any such thing is found, open up a message-list browser detailing all possible slips.'.


	menu addLine.
	menu add: 'simple change sorter' selector: #openChangeSorter: argument: 1.
	menu balloonTextForLastItem: 'Open a 3-paned changed-set viewing tool'.

	menu add: 'dual change sorter' selector: #openChangeSorter: argument: 2.
	menu balloonTextForLastItem: 'Open a change sorter that shows you two change sets at a time, making it easy to copy and move methods and classes between them.'.

	menu addLine.
	menu add: 'recently submitted methods' action: #openRecentChanges.
	menu balloonTextForLastItem: 'Open a message-list browser that shows the most recent methods that have been submitted.  If you submit changes within that browser, it will keep up-to-date, always showing the most recent submissions.'.

	menu add: 'recently logged changes...' 
		action: #openChangesLog.
	menu balloonTextForLastItem: 'Open a change-list browser on the latter part of the changes log.'.

	menu add: 'recent log file...'
		action: #fileForRecentLog.
	menu balloonTextForLastItem: 'Create a file holding the logged changes (going as far back as you wish), and open a window on that file.'.

	menu addLine.
	menu add: 'save world as morph file' action: #saveWorldInFile.
	menu balloonTextForLastItem: 'Save a file that, when reloaded, reconstitutes the current World.'.

	menu addLine.
	menu add: 'isolate methods of this project' action: #beIsolated.
	menu balloonTextForLastItem: 'Make this project and its subprojects be isolated from the rest of the system.  Changes to methods here will be revoked when you leave this project.'.
	menu add: 'assert in all projects' action: #assert.
	menu balloonTextForLastItem: 'The changes made in this isolated project will be installed in all projects.'.

	^ menu! !


!HandMorph methodsFor: 'world menu commands' stamp: 'sw 2/3/2000 16:22'!
fileForRecentLog
	Smalltalk writeRecentToFile! !


!ScreenController methodsFor: 'menu messages' stamp: 'sw 2/3/2000 16:23'!
fileForRecentLog
	Smalltalk writeRecentToFile! !

!ScreenController methodsFor: 'nested menus' stamp: 'sw 2/7/2000 01:15'!
changesMenu
	"Answer a menu for changes-related items"
	^ SelectionMenu labelList:
		#(	'keep this menu up'

			'simple change sorter'
			'dual change sorter'

			'file out current change set'
			'create new change set...'
			'methods in current change set'
			'check change set for slips'

			'recently submitted methods'
			'recently logged changes...'
			'recent log file...'
			)
		lines: #(1 3 7)
		selections: #(durableChangesMenu
openSimpleChangeSorter openChangeManager
fileOutChanges newChangeSet browseChangedMessages lookForSlips
browseRecentSubmissions browseRecentLog fileForRecentLog)
"
ScreenController new changesMenu startUp
"! !

!ScreenController methodsFor: 'nested menus' stamp: 'sw 2/7/2000 00:51'!
openMenu
	^ SelectionMenu labelList:
		#(	'keep this menu up'

			'browser'
			'package browser'
			'method finder'
			'workspace'
			'file list'
			'file...'
			'transcript'
			'morphic world'

			'simple change sorter'
			'chang'

			'mvc project'
			'morphic project'
			'construction project'
			)
		lines: #(1 9 11)
		selections: #(durableOpenMenu
openBrowser openPackageBrowser openSelectorBrowser openWorkspace openFileList openFile openTranscript openMorphicWorld
openSimpleChangeSorter openChangeManager
openProject  openMorphicProject  openConstructionProject )
"
ScreenController  new openMenu startUp
"! !


!SystemDictionary methodsFor: 'sources, change log' stamp: 'sw 2/3/2000 15:59'!
recover: nCharacters
	"Schedule an editable text view on the last n characters of changes."
	self writeRecentCharacters: nCharacters toFileNamed: 'st80.recent'! !

!SystemDictionary methodsFor: 'sources, change log' stamp: 'sw 2/3/2000 15:58'!
writeRecentCharacters: nCharacters toFileNamed: aFilename
	"Schedule an editable text view on the last n characters of changes."
	| changes |
	changes _ SourceFiles at: 2.
	changes setToEnd; skip: nCharacters negated.
	(FileStream newFileNamed: aFilename) nextPutAll: (changes next: nCharacters); close; open; edit! !

!SystemDictionary methodsFor: 'sources, change log' stamp: 'sw 2/3/2000 16:17'!
writeRecentToFile
	| numChars aDirectory aFileName |
	"Smalltalk writeRecentToFile"
	aDirectory _ FileDirectory default.
	aFileName _ Utilities keyLike: 'squeak-recent.01' withTrailing: '.log' satisfying:
		[:aKey | (aDirectory includesKey: aKey) not].
	numChars _ ChangeList getRecentLocatorWithPrompt: 'copy logged source as far back as...'.
	numChars ifNotNil:
		[Smalltalk writeRecentCharacters: numChars toFileNamed: aFileName]! !


ChangeList class removeSelector: #getRecentPositionWithPrompt:!
Preferences class removeSelector: #helpPaneForFactoredPanel!
"Postscript:"
Utilities replaceMenuFlap.!

