'From Squeak2.8alpha of 13 January 2000 [latest update: #1919] on 8 March 2000 at 3:35:01 pm'!
"Change Set:		msgSetParse-sw
Date:			1 March 2000
Author:			Scott Wallace

Makes MessageSet.parse:toClassAndSelector: tolerent of missing classes.   If the class indicated by the input string is not found in the image, then the csBlock is evaluated with nil for class and selector.  This fixes a bug that could crop up during auto-updating of browsers, in cases where the class of a method seen in one window has been removed from the system by a gesture in some different window."!


!MessageSet methodsFor: 'contents' stamp: 'sw 3/1/2000 10:57'!
selectedMessage
	"Answer the source method for the currently selected message."
	| source |
	self setClassAndSelectorIn: [:class :selector | 
		class ifNil: [^ 'Class vanished'].
		source _ class sourceMethodAt: selector ifAbsent:
			[currentCompiledMethod _ nil.
			^ 'Missing'].
		currentCompiledMethod _ class compiledMethodAt: selector ifAbsent: [nil].
		Preferences browseWithPrettyPrint ifTrue:
			[source _ class compilerClass new
				format: source in: class notifying: nil decorated: Preferences colorWhenPrettyPrinting].
		self showDiffs ifTrue:
			[source _ self diffFromPriorSourceFor: source].
		^ source asText makeSelectorBoldIn: class]! !


!MessageSet class methodsFor: 'instance creation' stamp: 'sw 3/1/2000 10:59'!
parse: messageString toClassAndSelector: csBlock
	"Decode strings of the form <className> [class] <selectorName>."
	| tuple cl |
	tuple _ messageString findTokens: ' .'.
	cl _ Smalltalk atOrBelow: tuple first asSymbol ifAbsent: [^ csBlock value: nil value: nil].
	(tuple size = 2 or: [tuple size > 2 and: [(tuple at: 2) ~= 'class']])
		ifTrue: [^ csBlock value: cl value: (tuple at: 2) asSymbol]
		ifFalse: [^ csBlock value: cl class value: (tuple at: 3) asSymbol]! !


