'From Squeak2.8alpha of 4 February 2000 [latest update: #1919] on 15 March 2000 at 10:58:07 pm'!
"Change Set:		13InspectorEnh-svp
Date:			14 March 2000
Author:			Stephen Pair

This is a simple little change set that will display an error
message (in red) in the contents pane of an inspector in the 
event that there was a problem in printing the selected object
(the current behavior pops open a debugger, which can be
frustrating at times)."!


!Inspector methodsFor: 'accessing' stamp: 'svp 3/14/2000 21:57'!
modelWakeUpIn: aWindow
	| newText |
	self updateListsAndCodeIn: aWindow.
	newText _ self contentsIsString
		ifTrue: [newText _ self selection]
		ifFalse: ["keep it short to reduce time to compute it"
			self selectionPrintString ].
	newText = contents ifFalse:
		[contents _ newText.
		self changed: #contents]! !

!Inspector methodsFor: 'accessing' stamp: 'svp 3/14/2000 21:57'!
stepAt: millisecondClockValue in: aWindow
	| newText |

	(Preferences smartUpdating and: [(millisecondClockValue - self timeOfLastListUpdate) > 8000]) "Not more often than once every 8 seconds"
		ifTrue:
			[self updateListsAndCodeIn: aWindow.
			timeOfLastListUpdate _ millisecondClockValue].

	newText _ self contentsIsString
		ifTrue: [newText _ self selection]
		ifFalse: ["keep it short to reduce time to compute it"
			self selectionPrintString ].
	newText = contents ifFalse:
		[contents _ newText.
		self changed: #contents]! !

!Inspector methodsFor: 'accessing' stamp: 'svp 3/14/2000 21:56'!
update
	"Reshow contents, assuming selected value may have changed."

	selectionIndex = 0
		ifFalse:
			[contents _ self selectionPrintString.
			self changed: #selection.
			self changed: #selectionIndex]! !

!Inspector methodsFor: 'selecting' stamp: 'svp 3/14/2000 22:13'!
selectionPrintString

	| text nm |
	^ [self selection printStringLimitedTo: 5000]
		on: Error
		do:
			[nm _ (self selectionIndex < 3)
				ifTrue: ['self']
				ifFalse: [self selectedSlotName].
			text _ ('<error in printString: evaluate "' , nm , ' printString" to debug>') asText.
		text addAttribute: TextColor red from: 1 to: text size.
		text]! !

!Inspector methodsFor: 'selecting' stamp: 'svp 3/14/2000 22:00'!
toggleIndex: anInteger
	"The receiver has a list of variables of its inspected object. One of these 
	is selected. If anInteger is the index of this variable, then deselect it. 
	Otherwise, make the variable whose index is anInteger be the selected 
	item."

	selectionIndex = anInteger
		ifTrue: 
			["same index, turn off selection"
			selectionIndex _ 0.
			contents _ '']
		ifFalse:
			["different index, new selection"
			selectionIndex _ anInteger.
			self contentsIsString
				ifTrue: [contents _ self selection]
				ifFalse: [contents _ self selectionPrintString]].
	self changed: #selection.
	self changed: #contents.
	self changed: #selectionIndex.! !


