'From Squeak2.8alpha of 4 February 2000 [latest update: #1919] on 15 March 2000 at 10:58:09 pm'!
"Change Set:		14LabelDraggin-sma
Date:			15 March 2000
Author:			Stefan Matthias Aust

Leandro Caniglia suggested a fix to disable the #relabel function, that is you can normally drag a window if you click on the window's label.  This was already implemented for Morphic by Scott Wallace, so I took the opportunity and implemented the same for MVC.

Use 'Preferences clickOnLabelToEdit' to toggle the behavior.  If you shift-click, you still get the old (relabel) behavior."!


!StandardSystemController methodsFor: 'control defaults' stamp: 'sma 3/15/2000 22:19'!
redButtonActivity
	"If cursor is in label of a window when red button is pushed,
	check for closeBox or growBox, else drag the window frame
	or edit the label."

	| box p |
	p _ sensor cursorPoint.
	self labelHasCursor ifFalse: [super redButtonActivity. ^ self].
	((box _ view closeBoxFrame) containsPoint: p)
		ifTrue:
			[Utilities
				awaitMouseUpIn: box
				repeating: []
				ifSucceed: [self close. ^ self].
			^ self].
	((box _ view growBoxFrame) containsPoint: p)
		ifTrue:
			[Utilities
				awaitMouseUpIn: box
				repeating: []
				ifSucceed:
					[Sensor controlKeyPressed ifTrue: [^ self expand; fullScreen].
					^ view isCollapsed
						ifTrue: [self expand]
						ifFalse: [self collapse]].
			^ self].
	(((box _ view labelTextRegion expandBy: 1) containsPoint: p)
			and: [Preferences clickOnLabelToEdit or: [sensor leftShiftDown]])
		ifTrue:
			[Utilities
				awaitMouseUpIn: box
				repeating: []
				ifSucceed: [^ self label].
			^ self].
	self move! !


