'From Squeak2.8alpha of 12 January 2000 [latest update: #1991] on 10 April 2000 at 4:12:16 pm'!
"Change Set:		ExpandTweak
Date:			10 April 2000
Author:			Dan Ingalls

A fix to SystemWindow expand that restores ownership to the submorphs before attempting to resize.

Also a tweak that includes the debug menu in the controlMenu for all morphs.
"!


!Morph methodsFor: 'menus' stamp: 'di 4/5/2000 23:39'!
addCustomMenuItems: aCustomMenu hand: aHandMorph
	"Add morph-specific items to the given menu which was invoked by the given hand."

	aCustomMenu add: 'add drop-shadow' action: #addDropShadow.
	(self isKindOf: SystemWindow)
		ifFalse: [aCustomMenu add: 'put in a window' action: #embedInWindow].
	aCustomMenu addUpdating: #stickinessString target: self action: #toggleStickiness.
	aCustomMenu add: 'adhere to edge...' action: #adhereToEdge.
	Preferences noviceMode ifFalse:
		[self addDebuggingItemsTo: aCustomMenu hand: aHandMorph].
! !


!SystemWindow methodsFor: 'resize/collapse' stamp: 'di 4/10/2000 15:56'!
collapseOrExpand

	isCollapsed
	ifTrue:
		["Expand -- restore panes to morphics structure"
		isCollapsed _ false.
		collapsedFrame _ self getBoundsWithFlex.  "First save latest collapsedFrame"
		paneMorphs reverseDo: [:m | self addMorph: m].
		self world startSteppingSubmorphsOf: self.
		self setBoundsWithFlex: fullFrame.
		self activate "-- mainly for findWindow"]
	ifFalse:
		["Collapse -- remove panes from morphics structure"
		isCollapsed _ true.
		fullFrame _ self getBoundsWithFlex.  "First save latest fullFrame"
		paneMorphs do: [:m | m delete; releaseCachedState].
		model modelSleep.
		collapsedFrame ifNil:
			[collapsedFrame _ (RealEstateAgent assignCollapsePointFor: self)
						 extent: (label width + self labelWidgetAllowance) @ (self labelHeight + 2)].
		self setBoundsWithFlex: collapsedFrame].
	self layoutChanged! !

