'From Squeak2.8alpha of 16 February 2000 [latest update: #2050] on 27 April 2000 at 7:30:05 pm'!
"Change Set:		TurtlePen-ar
Date:			27 April 2000
Author:			Andreas Raab

Fixes a problem with a nil turtle pen when a PasteUp was saved with its pen down. The PasteUp did rely on turtleTrailsForm isNil = turtlePen isNil which was broken by the #prepareToBeSaved. The fix simply removes the initial assumption and restores the turtle pen if needed."!


!PasteUpMorph methodsFor: 'pen' stamp: 'ar 4/27/2000 19:26'!
createOrResizeTrailsForm
	"If necessary, create a new turtleTrailsForm or resize the existing one to fill my bounds. On return, turtleTrailsForm exists and is the correct size."
	| newForm |
	turtleTrailsForm ifNil: [
		"create new turtleTrailsForm if needed"
		turtleTrailsForm _ Form extent: self extent depth: 8.
		turtlePen _ Pen newOnForm: turtleTrailsForm.
		^ self].

	turtleTrailsForm extent = self extent ifFalse: [
		"resize turtleTrailsForm if my size has changed"
		newForm _ Form extent: self extent depth: 8.
		newForm copy: self bounds from: turtleTrailsForm
					to: 0@0 rule: Form paint.
		turtleTrailsForm _ newForm.
		turtlePen _ Pen newOnForm: turtleTrailsForm].
	"In case turtleTrailsForm is not nil but pen is"
	turtlePen ifNil:[turtlePen _ Pen newOnForm: turtleTrailsForm].! !

