'From Squeak2.8alpha of 13 January 2000 [latest update: #2067] on 6 May 2000 at 2:33:16 am'!
"Change Set:		misc-sw
Date:			6 May 2000
Author:			Scott Wallace

A variety of little changes.
	Fixes bug in Utilities.reportSenderCountsFor:, a method with no senders but which can be usefully invoked in doIts.
	The tabs area of a tabbed palette will no longer repel morphs that you drop over it.
	Fixes misleading variable-name declarations in Point.setX:setY:.
	Bulletproof PluggableButtonController against cases where its view some has become nil when controlTerminate is called.
	PaintInvokingMorph comes armed with balloon help"!


!IndexTabs methodsFor: 'layout' stamp: 'sw 4/27/2000 13:30'!
repelsMorph: aMorph event: evt
	^ false! !


!PaintInvokingMorph class methodsFor: 'as yet unclassified' stamp: 'sw 5/6/2000 02:28'!
authoringPrototype
	^ self new image: (ScriptingSystem formAtKey: 'Painting'); markAsPartsDonor; setBalloonText: 'drop this into any playfield or book page to make a new painting there'; yourself! !


!PluggableButtonController methodsFor: 'basic control sequence' stamp: 'sw 5/6/2000 01:36'!
controlTerminate 
	"Reverse the feedback displayed by controlInitialize, if any. Perform the button action if necessary."

	view ifNotNil:
		[view triggerOnMouseDown ifFalse:
			[view toggleMouseOverFeedback.
			self viewHasCursor ifTrue: [view performAction]]]
! !


!Point methodsFor: 'private' stamp: 'sw 3/21/2000 13:24'!
setX: xValue setY: yValue

	x _ xValue.
	y _ yValue! !


!TabbedPalette methodsFor: 'user-interface' stamp: 'sw 4/27/2000 13:27'!
repelsMorph: aMorph event: ev
	true ifTrue: [^ super repelsMorph: aMorph event: ev].

	self visible ifFalse: [^ false].
	^ openToDragNDrop not! !


!Utilities class methodsFor: 'investigations' stamp: 'sw 3/27/2000 15:34'!
reportSenderCountsFor: selectorList
	"Produce a report on the number of senders of each of the selectors in the list.  1/27/96 sw"

	| total report thisSize |
	total _ 0.
	report _ '
'.
	selectorList do:
		[:selector | thisSize _ (Smalltalk allCallsOn: selector) size.
		report _ report, thisSize printString, String tab, selector printString, String cr.
		total _ total + thisSize].
	report _ report, '--- ------------------
'.
	report _ report, total printString, String tab, 'TOTAL
'.
	^ report! !

