'From Squeak2.8alpha of 4 February 2000 [latest update: #2052] on 6 May 2000 at 12:33:22 pm'!
"Change Set:		TTF2Strike
Date:			8 November 1999
Author:			Hans-Martin Mosner & Rob Vens

This small set of methods add the facility to translate TTF fonts into antialiased StrikeFonts.
There are a number of glitches:
1. I don't know exactly how to translate from point sizes to TrueType's scaling units. From experimentation, scaling points by 1/2000 seems to do the trick. YMMV.
2. The generated fonts are FormSetFonts where the glyphs were antialiased against a white background. This means that text written with it can't be colored, and that the edges look strange against darker backgrounds.
3. Glyphs which overshoot their bounding box are clipped. That's just how StrikeFonts work. I did not want to meddle with the whole mechanisms of text display.

Hans-Martin"!


!StrikeFont methodsFor: 'accessing' stamp: 'sma 5/5/2000 14:21'!
pointSize: anInteger
	pointSize _ anInteger! !


!TTFontDescription methodsFor: 'converting' stamp: 'sma 5/5/2000 13:46'!
asStrikeFontScale: scale
	"Generate a StrikeFont (actually a FormSetFont) for this TTF font at a given scale."

	| forms |
	forms _ (0 to: 255) collect:
		[:i |
		(self at: i)
			asFormWithScale: scale
			ascender: ascender
			descender: descender].
	^ FormSetFont new
		fromFormArray: forms
		asciiStart: 0
		ascent: (ascender * scale) rounded! !


!TTFontReader class methodsFor: 'instance creation' stamp: 'sma 5/5/2000 14:22'!
installTTF: ttfFileName asTextStyle: textStyleName sizes: sizeArray
	"TTFontReader
		installTTF: 'F:\fonts\amazon__.TTF' 
		asTextStyle: #Amazon
		sizes: #(24 60)"

	| ttf fontArray |
	ttf _ self parseFileNamed: ttfFileName.
	fontArray _ sizeArray collect:
		[:each |
		(ttf asStrikeFontScale: each / ttf unitsPerEm)
			name: textStyleName;
			pointSize: each].
	TextConstants at: textStyleName asSymbol put: (TextStyle fontArray: fontArray)! !


!TTGlyph methodsFor: 'converting' stamp: 'sma 5/5/2000 13:48'!
asFormWithScale: scale ascender: ascender descender: descender
	^ self
		asFormWithScale: scale
		ascender: ascender
		descender: descender
		fgColor: Color black
		bgColor: Color white! !

!TTGlyph methodsFor: 'converting' stamp: 'sma 5/5/2000 13:47'!
asFormWithScale: scale ascender: ascender descender: descender fgColor: fgColor bgColor: bgColor
	| form canvas |
	form _ Form extent: (advanceWidth @ (ascender - descender) * scale) rounded depth: 8.
	form fillColor: bgColor.
	canvas _ BalloonCanvas on: form.
	canvas aaLevel: 4.
	canvas transformBy: (MatrixTransform2x3 withScale: scale asPoint * (1 @ -1)).
	canvas transformBy: (MatrixTransform2x3 withOffset: 0 @ ascender negated).
	canvas
		drawGeneralBezierShape: self contours
		color: fgColor 
		borderWidth: 0 
		borderColor: fgColor.
	form replaceColor: bgColor withColor: Color transparent.
	^ form! !

