'From Squeak2.8alpha of 4 February 2000 [latest update: #2158] on 20 May 2000 at 12:26:54 pm'!
"Change Set:		069EOS-hh
Date:			18 May 2000
Author:			Helge Horch
Requires:		Squeak 2.8a

Modifies ReadStream>>next to signal an Error (EndOfStream) on attempts to read
at or beyond the end of the stream.  Thanks to Bob Arning (who is silently credited
in the stamps <g>), existing applications relying on seeing nils should not be
affected.
"!

Error subclass: #EndOfStream
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'System-Exceptions Extensions'!

!EndOfStream commentStamp: '<historical>' prior: 0!
Signalled when ReadStream>>next encounters a premature end.!

!EndOfStream methodsFor: 'description' stamp: 'hh 5/17/2000 00:30'!
isResumable
	"EndOfStream is resumable, so ReadStream>>next can answer"

	^ true! !

!EndOfStream methodsFor: 'exceptionDescription' stamp: 'RAA 5/17/2000 03:10'!
defaultAction
	"Answer ReadStream>>next default reply."

	^ nil! !


!ReadStream methodsFor: 'accessing' stamp: 'RAA 5/17/2000 00:21'!
next
	"Primitive. Answer the next object in the Stream represented by the
	receiver. Fail if the collection of this stream is not an Array or a String.
	Fail if the stream is positioned at its end, or if the position is out of
	bounds in the collection. Optional. See Object documentation
	whatIsAPrimitive."

	<primitive: 65>
	^ position >= readLimit
		ifTrue: [EndOfStream signal]
		ifFalse: [collection at: (position _ position + 1)]! !

