'From Squeak2.8alpha of 4 February 2000 [latest update: #2158] on 20 May 2000 at 6:41:13 pm'!
"Change Set:		FileListEnh-ccn
Date:			16 May 2000
Author:			Chris Norton & Stefan Matthias Aust

Filing in compressed files results in an error.  So if the user chooses to file in a file with a questionable suffix, I ask the user if he/she wants to inflate the compressed file.  If user says OK, then inflate the file.  If the user says No, then file in the questionable file anyhow.

sma simplified and rewrote the code, changing it so that after uncompressing the file in continues.  This makes it a really useful feature, IMHO."!


!FileList methodsFor: 'file list menu' stamp: 'sma 5/20/2000 18:30'!
fileAllIn
	"File in all of the currently selected file, if any."
	"wod 5/24/1998: open the file read only."

	| fn ff |
	listIndex = 0 ifTrue: [^ self].
	ff _ directory readOnlyFileNamed: (fn _ self uncompressedFileName).
	((self getSuffix: fn) sameAs: 'html') ifTrue: [ff _ ff asHtml].
	ff fileIn! !

!FileList methodsFor: 'file list menu' stamp: 'sma 5/20/2000 18:32'!
fileIntoNewChangeSet
	"File in all of the contents of the currently selected file,
	if any, into a new change set."

	| fn ff |
	listIndex = 0 ifTrue: [^ self].
	ff _ directory readOnlyFileNamed: (fn _ self uncompressedFileName).
	((self getSuffix: fn) sameAs: 'html') ifTrue: [ff _ ff asHtml].
	ChangeSorter newChangesFromStream: ff named: fn! !

!FileList methodsFor: 'file list menu' stamp: 'sma 5/20/2000 18:29'!
fileNameSuffix
	^ self getSuffix: self fullName! !

!FileList methodsFor: 'file list menu' stamp: 'sma 5/20/2000 18:19'!
saveGZipContents
	"Save the contents of a gzipped file"
	| zipped buffer unzipped newName |
	newName _ fileName copyUpToLast: FileDirectory extensionDelimiter.
	unzipped _ directory newFileNamed: newName.
	zipped _ GZipReadStream on: (directory readOnlyFileNamed: self fullName).
	buffer _ String new: 50000.
	'Extracting ' , self fullName
		displayProgressAt: Sensor cursorPoint
		from: 0
		to: zipped sourceStream size
		during: 
			[:bar | 
			[zipped atEnd]
				whileFalse: 
					[bar value: zipped sourceStream position.
					unzipped nextPutAll: (zipped nextInto: buffer)].
			zipped close.
			unzipped close].
	self updateFileList.
	^ newName! !

!FileList methodsFor: 'private' stamp: 'sma 5/20/2000 18:29'!
getSuffix: aString
	| i |
	i _ aString findLast: [:each | $. = each].
	^ i = 0
		ifTrue: ['']
		ifFalse: [aString copyFrom: i + 1 to: aString size]! !

!FileList methodsFor: 'private' stamp: 'sma 5/20/2000 18:31'!
uncompressedFileName
	| f |
	f _ self fullName.
	((f endsWith: '.gz') and: [self confirm: f , '
appears to be a compressed file.
Do you want to uncompress it?'])
		ifFalse: [^ f].
	^ self saveGZipContents! !

