'From Squeak2.8alpha of 13 January 2000 [latest update: #2156] on 19 May 2000 at 9:17:48 pm'!
"Change Set:		CalendarTweak
Date:			19 May 2000
Author:			Steve Elkins

These changes make it possible to start the week on Sunday instead of Monday (the default) in the MonthMorph.  To try it, open the menu and use the 'start Sunday' item at the bottom."!

Date subclass: #Week
	instanceVariableNames: ''
	classVariableNames: 'StartMonday '
	poolDictionaries: ''
	category: 'Numeric-Magnitudes'!

!MonthMorph methodsFor: 'all' stamp: 'sge 5/19/2000 20:44'!
addCustomMenuItems: aCustomMenu hand: aHandMorph
	super addCustomMenuItems: aCustomMenu hand: aHandMorph.
	aCustomMenu 
		addLine;
		addUpdating: #startMondayOrSundayString action: #toggleStartMonday
! !

!MonthMorph methodsFor: 'all' stamp: 'sge 5/19/2000 20:43'!
startMondayOrSundayString
	^ Week startMonday
		ifTrue: ['start Sunday']
		ifFalse: ['start Monday']! !

!MonthMorph methodsFor: 'all' stamp: 'sge 5/18/2000 06:00'!
toggleStartMonday
	Week toggleStartMonday.
	self initializeWeeks
! !


!Week class methodsFor: 'class variables' stamp: 'sge 5/18/2000 05:50'!
startMonday
	StartMonday ifNil: [StartMonday _ true].
	^ StartMonday! !

!Week class methodsFor: 'class variables' stamp: 'sge 5/18/2000 06:24'!
toggleStartMonday
	StartMonday _ self startMonday not! !

!Week class methodsFor: 'instance creation' stamp: 'sge 5/19/2000 21:02'!
fromDate: aDate
	| startDay |
	startDay _ aDate previous: (self startMonday 
								ifTrue: [#Monday] ifFalse: [#Sunday]).
	^ self
		newDay: startDay dayOfMonth
		month: startDay monthName
		year: startDay year! !


!WeekMorph methodsFor: 'all' stamp: 'sge 5/19/2000 21:06'!
title
	"Answer a title with the names of the days."
	| title extent days |
	title _ AlignmentMorph new
		inset: 0;
		color: Color red;
		orientation: #horizontal;
		vResizing: #shrinkWarp;
		height: 19.
		extent _ self tile extent.
	days _ Week startMonday
		ifTrue: [7 to: 1 by: -1]       "Original code, Mon-Sun."
		ifFalse: [#(6 5 4 3 2 1 7)].   "Sun-Sat."
	(days collect: [:each | Date nameOfDay: each]) do:
		[:each |
		title addMorph:
			(self tile 
				label: (each copyFrom: 1 to: 2);
				extent: extent;
				setBalloonText: each printString)].
	^ title
	! !

