'From Squeak2.8alpha of 4 February 2000 [latest update: #2210] on 1 June 2000 at 1:05:39 pm'!
"Change Set:		089X11example-bf
Date:			22 May 2000
Author:			Bert Freudenberg

[Seems like this a mainly a fix for the #(nil) first == #nil problem which is hopefully fixed soon. Then this change needs to be adapted --sma]

Makes the FFI drawing example for X use XQueryPointer (Andreas incorrectly assumed that 'there is no way to query the XServers mouse position directly'). Also fixes the ExternalStructureInspector to ignore nil fields which gave a walkback."!

ExternalStructure subclass: #X11Display
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FFI-Examples-X11'!

!ExternalStructure methodsFor: 'printing' stamp: 'bf 5/18/2000 16:26'!
longPrintOn: aStream 
	"Append to the argument, aStream, the names and values of all the record's variables."
	| fields |
	fields _ self class fields.
	(fields isEmpty or: [fields first isNil]) ifTrue: [fields _ #()]
		ifFalse: [(fields first isKindOf: Array) ifFalse: [fields _ Array with: fields]].
	fields do: [ :field |
		field first ~~ #nil ifTrue: [
			aStream nextPutAll: field first; nextPut: $:; space; tab.
			(self perform: field first) printOn: aStream.
			aStream cr]].! !


!ExternalStructureInspector methodsFor: 'accessing' stamp: 'bf 5/18/2000 16:33'!
recordFieldList
	| fields |
	fields _ object class fields.
	(fields first isKindOf: Array) ifFalse: [fields _ Array with: fields].
	^fields collect: [ :field | field first ] thenSelect: [:name | name ~~ #nil]! !


!X11Display methodsFor: 'accessing' stamp: 'bf 5/18/2000 15:10'!
queryPointer: aX11Window
	| root child rootX rootY winX winY mask |
	root _ X11Window new.
	child _ X11Window new.
	rootX _ WordArray new: 1.
	rootY _ WordArray new: 1.
	winX _ WordArray new: 1.
	winY _ WordArray new: 1.
	mask _ WordArray new: 1.
	self XQueryPointer: self window: aX11Window returnRoot: root child: child
		rootX: rootX rootY: rootY winX: winX winY: winY mask: mask.
	^{root. child. rootX first @ rootY first. winX first @ winY first. mask first}! !

!X11Display methodsFor: 'xlib calls' stamp: 'bf 5/18/2000 15:20'!
XQueryPointer: display window: w returnRoot: root child: child rootX: rootX rootY: rootY winX: winX winY: winY mask: mask 
	<cdecl: bool 'XQueryPointer' (X11Display* X11Window X11Window* X11Window* long* long* long* long* long*) module: 'X11'>
	^self externalCallFailed! !


!X11Display class methodsFor: 'examples' stamp: 'bf 5/18/2000 15:28'!
x11Draw
	"X11Display x11Draw"
	| display window gc nextPt lastPt ptr |
	display _ X11Display XOpenDisplay: nil.
	window _ display getInputFocus.
	gc _ X11GC on: window.
	gc foreground: 0.
	lastPt _ nil.
	[ptr _ display queryPointer: window.	"{root. child. root pos. win pos. mask}"
	ptr last anyMask: 256] whileFalse:[
		nextPt _ ptr fourth.
		nextPt = lastPt ifFalse:[
			lastPt ifNotNil: [
				gc drawLineFrom: lastPt to: nextPt.
				display sync].
			lastPt _ nextPt].
	].
	gc free.
	display closeDisplay.
	Display forceToScreen.! !

