'From Squeak2.8alpha of 4 February 2000 [latest update: #2210] on 5 June 2000 at 8:06:09 pm'!
"Change Set:		128HandMorph-jwh
Date:			5 June 2000
Author:			Jim Heyne

Minor efficiency improvements and simplification in HandMorph positioning. Minor, but on my machine, this code gets hit about 17 times per second.

Synchronize temporaryCursor and temporaryCursorOffset. If temporaryCursor isNil ignore temporaryCursorOffset (rather than forcing it to 0@0 and doing unnecessary arithmetic).

Also includes minor code simplification."!


!HandMorph methodsFor: 'initialization' stamp: 'jwh 6/5/2000 07:39'!
initialize
	super initialize.
	self initForEvents.
	keyboardFocus _ nil.
	mouseOverMorphs _ OrderedCollection new.
	dragOverMorphs _ OrderedCollection new.
	bounds _ 0@0 extent: Cursor normal extent.
	userInitials _ ''.
	damageRecorder _ DamageRecorder new.
	cachedCanvasHasHoles _ false.
	grid _ 4@4.
	gridOn _ false.
	remoteConnections _ OrderedCollection new.
	lastEventTransmitted _ MorphicEvent new.
	temporaryCursor _ temporaryCursorOffset _ nil
! !

!HandMorph methodsFor: 'cursor' stamp: 'jwh 6/5/2000 07:38'!
cursorBounds

	^temporaryCursor 
		ifNil: [self position extent: NormalCursor extent]
		ifNotNil: [self position + temporaryCursorOffset extent: temporaryCursor extent]! !

!HandMorph methodsFor: 'cursor' stamp: 'jwh 6/5/2000 08:48'!
showTemporaryCursor: cursorOrNil hotSpotOffset: hotSpotOffset
	"Set the temporary cursor to the given Form.
	If the argument is nil, revert to the normal hardware cursor."

	self changed.
	cursorOrNil == nil
		ifTrue: [temporaryCursor _ temporaryCursorOffset _ nil]
		ifFalse: [temporaryCursor _ cursorOrNil asCursorForm.
				temporaryCursorOffset _ temporaryCursor offset - hotSpotOffset].
	bounds _ self cursorBounds.
	self 
		userInitials: userInitials;
		layoutChanged;
		changed
! !

!HandMorph methodsFor: 'geometry' stamp: 'jwh 6/5/2000 08:11'!
position

	^temporaryCursor
		ifNil: [bounds topLeft]
		ifNotNil: [bounds topLeft - temporaryCursorOffset]! !

!HandMorph methodsFor: 'geometry' stamp: 'jwh 6/5/2000 07:52'!
position: aPoint
	"Overridden to align submorph origins to the grid if gridding is on."
	| adjustedPosition |
	adjustedPosition := aPoint.
	gridOn ifTrue: [adjustedPosition := adjustedPosition grid: grid].
	temporaryCursor ifNotNil: [adjustedPosition := adjustedPosition + temporaryCursorOffset].
	^super position: adjustedPosition
! !

