'From Squeak2.9alpha of 26 July 2000 [latest update: #2480] on 11 August 2000 at 6:28:24 pm'!
"Change Set:		hesitantWorldMenu-sw
Date:			11 August 2000
Author:			Scott Wallace

Makes it possible for gestures that begin with a mouse-down on the morphic desktop *not* to have to bring up the world menu.  The world menu is now put up only if the mouse button stays down for a reasonable time without moving too much.  

This makes it possible to 'shake off' a selection or a halo with a quick click on the desktop, without in consequence getting an annoying and unwanted menu which itself then needs to be gotten rid of.

This also makes it possible for a drag-through gesture on the desktop to be used for area-select at some future time.

Hooks are provided for future code to intercept both quick-click-on-desktop and drag-through-on-desktop.

Note that anyone who misses getting the world menu in the above two cases can quickly regain it by simply putting oneliners in the above two hooks, in each case calling #invokeMetaMenu:."!


!InputSensor methodsFor: 'mouse' stamp: 'sw 8/11/2000 18:16'!
escapeIfQuickClick: quickClickBlock ifMoved: movedBlock
	| pt |
	"The mouse just went down.  Pause briefly and then check to see whether it is still down and whether it has moved a significant amount; evaluate quickClickBlock or movedBlock as appropriate."

	pt _ self cursorPoint.
	(Delay forMilliseconds: 80) wait.
	self anyButtonPressed ifFalse: [^ quickClickBlock value].
	((self cursorPoint - pt) abs < (3@3)) ifFalse: [^ movedBlock value]! !


!PasteUpMorph methodsFor: 'world state' stamp: 'sw 8/11/2000 18:08'!
dragThroughOnDesktop: evt
	"a hook; nothing done presently"! !

!PasteUpMorph methodsFor: 'world state' stamp: 'sw 8/11/2000 18:08'!
mouseDown: evt
	"Handle a mouse down event."

	self isWorldMorph
		ifTrue:
			[evt hand newKeyboardFocus: self.
			Sensor escapeIfQuickClick: [^ self quickClickOnDesktop: evt]
				ifMoved: [^ self dragThroughOnDesktop: evt].
			evt hand invokeMetaMenu: evt]
		ifFalse:
			[^ super mouseDown: evt]! !

!PasteUpMorph methodsFor: 'world state' stamp: 'sw 8/11/2000 18:08'!
quickClickOnDesktop: evt
	"a hook; nothing done presently"! !

