'From Squeak2.9alpha of 13 June 2000 [latest update: #2440] on 30 June 2000 at 8:05:07 pm'!
"Change Set:		ChangeSet-fileOut
Date:			30 June 2000
Author:			Chris Norton

Steps to reproduce:
1.  From the 'changes...' menu, choose 'create new change set...'
2.  Name the set and Accept it.
3.  From the 'changes...' menu, choose 'file out current change set'
Result:  Notifier 'Warning: no changes to file out'

Tracing the code led me to ChangeSet.fileOut.  This method, as you might expect, files out your active changeset.  Unfortunately, if an error occurs during the filing out of the code, you end up with an open file that doesn't get closed."!


!ChangeSet methodsFor: 'fileIn/Out' stamp: 'ccn 6/30/2000 19:47'!
fileOut
	"File out the receiver, to a file whose name is a function of the change-set name and either of the date & time or chosen to have a unique numeric tag, depending on the preference 'sequentialChangeSetRevertableFileNames'"

	| file slips nameToUse |
	self checkForConversionMethods.
	nameToUse _ Preferences changeSetVersionNumbers
		ifTrue:
			[FileDirectory default nextNameFor: self name extension: 'cs']
		ifFalse:
			[(self name, FileDirectory dot, Utilities dateTimeSuffix, 
				FileDirectory dot, 'cs') asFileName].
	Cursor write showWhile:
		[[file _ FileStream newFileNamed: nameToUse.
		file header; timeStamp.
		self fileOutPreambleOn: file.
		self fileOutOn: file.
		self fileOutPostscriptOn: file.
		file trailer] ensure: [file close]].

	Preferences checkForSlips ifFalse: [^ self].

	slips _ self checkForSlips.
	(slips size > 0 and: [self confirm: 'Methods in this fileOut have halts
or references to the Transcript
or other ''slips'' in them.
Would you like to browse them?'])
		ifTrue: [Smalltalk browseMessageList: slips
							name: 'Possible slips in ', name]! !

