'From Squeak2.9alpha of 5 August 2000 [latest update: #2676] on 21 September 2000 at 11:05:17 pm'!
"Change Set:		optionCloseWindow-sw
Date:			21 September 2000
Author:			Scott Wallace

Mac-specific!!  If the mac option key is down when the user clicks the close-box of a system window, it is interpreted as a request to close all unchanged windows in the project, provided you have a preference governing this set to true.  Apologies to the community: this is a tiny piece of self-indulgence for those few mac squeakers  who value this Mac-ui feature."!


!InputSensor methodsFor: 'modifier keys' stamp: 'sw 9/21/2000 12:41'!
rawMacOptionKeyPressed
	"Answer whether the option key on the Macintosh keyboard is being held down. Macintosh specific.  Clients are discouraged from calling this directly, since it circumvents bert's attempt to eradicate option-key checks"

	^ self primMouseButtons anyMask: 32! !


!SystemWindow methodsFor: 'initialization' stamp: 'sw 9/15/2000 05:50'!
addCloseBox
	self addMorph: (closeBox _ SimpleButtonMorph new borderWidth: 0;
			label: 'X' font: Preferences standardButtonFont; color: Color transparent;
			actionSelector: #closeBoxHit; target: self; extent: 14@14)! !

!SystemWindow methodsFor: 'open/close' stamp: 'sw 9/21/2000 12:43'!
closeBoxHit
	"The user clicked on the close-box control in the window title.  For Mac users only, the Mac convention of option-click-on-close-box is obeyed if the mac option key is down."

	Preferences dismissAllOnOptionClose ifTrue:
		[Sensor rawMacOptionKeyPressed ifTrue:
			[^ self currentHand closeUnchangedWindows]].
	self delete
! !

"Postscript:"
Preferences addPreference: #dismissAllOnOptionClose category: #windows default: false balloonHelp: 'Mac-specific: if true, then a click on a morphic SystemWindow''s close-box while the mac option is held down will result in a dismissal of all unchanged windows'. !

