'From Squeak2.9alpha of 12 June 2000 [latest update: #2688] on 24 September 2000 at 1:16:16 pm'!
"Change Set:		LayoutChangedOpt
Date:			24 September 2000
Author:			Dan Ingalls

Suppresses downward propagation of ownerChanged from pasteUpMorphs (mainly worlds) except from extent:.

This prevents *lots* of needless screen recomposition (and hopefully none that is necessary ;-).
"!


!PasteUpMorph methodsFor: 'layout' stamp: 'di 9/24/2000 11:34'!
layoutChanged
	"PasteUps do not broadcast ownerChanged down to their submorphs
	when responding to (upward) layoutChanged events.  Instead, they
	do this only in the case of changing extent (qv)."

	fullBounds _ nil.
	owner ifNotNil: [owner layoutChanged].
	(self valueOfProperty: #SqueakPage) ifNotNil: [
		self setProperty: #pageDirty toValue: true].
		"I am the morph of a SqueakPage, I have changed and 
		need to be written out again"
! !

!PasteUpMorph methodsFor: 'world state' stamp: 'di 9/24/2000 11:37'!
extent: aPoint
	"While PasteUps do not broadcast ownerChanged downward in layoutChanged,
	they do so here."

	super extent: aPoint.
	worldState ifNotNil:
		[worldState viewBox ifNotNil:
			[worldState canvas: nil.
			worldState viewBox: bounds]].
	submorphs size > 0 ifTrue:
		["Let submorphs know about a change above"
		submorphs do: [:m | m ownerChanged]].
! !

