'From Squeak2.9alpha of 13 June 2000 [latest update: #2881] on 22 October 2000 at 7:42:51 pm'!
"Change Set:		GrabFix2-ar
Date:			22 October 2000
Author:			Andreas Raab

Fixes some side effects from the last CS. Now also makes sure that morphs grabbed from inner worlds come out correctly"!


!HaloMorph methodsFor: 'private' stamp: 'ar 10/22/2000 19:37'!
doDup: evt with: dupHandle
	"Ask hand to duplicate my target."

	(target isKindOf: SelectionMorph) ifTrue:
		[^ target doDup: evt fromHalo: self handle: dupHandle].
	self setTarget: (target duplicateMorph: evt).
	self removeAllHandlesBut: dupHandle.
	self step. "update position if necessary"
	(dupHandle bounds containsPoint: evt position) ifFalse:[
		target position: target position + (evt position - dupHandle bounds center)].
	evt hand addMouseListener: self. "Listen for the drop"! !

!HaloMorph methodsFor: 'private' stamp: 'ar 10/22/2000 19:38'!
doGrab: evt with: grabHandle
	"Ask hand to grab my target."

	self removeAllHandlesBut: grabHandle.  "remove all other handles"
	evt hand grabMorph: target.
	self step. "update position if necessary"
	(grabHandle bounds containsPoint: evt position) ifFalse:[
		target position: target position + (evt position - grabHandle bounds center)].
	evt hand addMouseListener: self. "Listen for the drop"! !


!HandMorph methodsFor: 'grabbing/dropping' stamp: 'ar 10/22/2000 19:30'!
grabMorph: aMorph
	"Grab the given morph (i.e., add it to this hand and remove it from its current owner) without changing its position. This is used to pick up a morph under the hand's current position, versus attachMorph: which is used to pick up a morph that may not be near this hand."
	| grabbed tfm offset tfm2 targetPoint |
	self releaseMouseFocus. "Break focus"
	grabbed _ aMorph aboutToBeGrabbedBy: self.
	grabbed ifNil:[^self].
	grabbed _ grabbed topRendererOrSelf.
	tfm _ grabbed owner ifNil:[IdentityTransform new] ifNotNil:[grabbed owner grabTransform].
	tfm2 _ grabbed owner ifNil:[IdentityTransform new] ifNotNil:[grabbed owner transformFrom: owner].
	targetPoint _ tfm2 globalPointToLocal: self position.
	offset _ targetPoint - (tfm globalPointToLocal: self position).
	grabbed _ grabbed transformedBy: tfm.
	grabbed position: grabbed position - offset asIntegerPoint.
	targetOffset _ grabbed position - self position.
	self addMorphBack: grabbed.! !


!MorphicTransform methodsFor: 'transformations' stamp: 'ar 10/22/2000 18:38'!
composedWithLocal: aTransform
	aTransform isIdentity ifTrue:[^self].
	self isIdentity ifTrue:[^aTransform].
	aTransform isMorphicTransform ifFalse:[^super composedWithLocal: aTransform].
	self isPureTranslation ifTrue:[^aTransform withOffset: aTransform offset + self offset].
	aTransform isPureTranslation ifTrue:[^self withOffset: offset - aTransform offset].
	^super composedWithLocal: aTransform.! !


!TransformationMorph methodsFor: 'dropping/grabbing' stamp: 'ar 10/22/2000 18:26'!
grabTransform
	"Return the transform for the receiver which should be applied during grabbing"
	self renderedMorph isWorldMorph 
		ifTrue:[^owner ifNil:[IdentityTransform new] ifNotNil:[owner grabTransform]].
	^owner ifNil:[self transform] ifNotNil:[owner grabTransform composedWithLocal: self transform]! !

