'From Squeak 2.2beta of Sept 11, 1998 on 21 September 1998 at 11:14:53 am'!
"Change Set:		morphiclessProofing-sw
Date:			21 September 1998
Author:			Scott Wallace

Bulletproof against consequence of the removal of Morphic from the system.

To determine if Morphic is present in the system, call:

    Smalltalk hasMorphic

To check whether Morphic is present and put up an informer and exit if not, write code of the form:

    Smalltalk verifyMorphicAvailability ifFalse: [^ self].

Various call-ins to Morphic from ScreenController & FileList code are now given the verifyMorphicAvailability test before they plunge ahead."!


!FileList methodsFor: 'file list menu' stamp: 'sw 9/21/1998 10:59'!
openMorphFromFile
	"Reconstitute a Morph from the selected file, presumed to be represent a Morph saved via the SmartRefStream mechanism, and open it in an appropriate Morphic world"
 	| aFileStream morphOrList |
	Smalltalk verifyMorphicAvailability ifFalse: [^ self].

	aFileStream _ directory oldFileNamed: self fullName.
	morphOrList _ aFileStream fileInObjectAndCode.
	World
		ifNotNil:
			[World addMorphsAndModel: morphOrList]
		ifNil:
			[(morphOrList isKindOf: Morph)
				ifFalse:
					[^ self inform: 'can only load a single morph into an mvc project via this mechanism'].
				morphOrList openInWorld]! !


!ScreenController methodsFor: 'menu messages' stamp: 'sw 9/21/1998 11:07'!
openConstructionProject
	Smalltalk verifyMorphicAvailability ifFalse: [^ self].
	ProjectView openAndEnter: Project newMorphicConstruction
! !

!ScreenController methodsFor: 'menu messages' stamp: 'sw 9/21/1998 10:58'!
openMorphicConstructionWorld 
	Smalltalk verifyMorphicAvailability ifFalse: [^ self].
	WorldMorph openWithStandardPartsBinShowing! !

!ScreenController methodsFor: 'menu messages' stamp: 'sw 9/21/1998 11:06'!
openMorphicProject
	Smalltalk verifyMorphicAvailability ifFalse: [^ self].
	ProjectView open: Project newMorphic.
! !

!ScreenController methodsFor: 'menu messages' stamp: 'sw 9/21/1998 10:58'!
openMorphicWorld 
	"Create and schedule a StringHolderView for use as a workspace."
	Smalltalk verifyMorphicAvailability ifFalse: [^ self].
	WorldMorph new open.
! !


!SystemDictionary methodsFor: 'miscellaneous' stamp: 'sw 9/21/1998 11:04'!
hasMorphic
	"Answer whether the Morphic classes are available in the system (they may have been stripped, such as by a call to Smalltalk removeMorphic"

	^ ((Smalltalk at: #WorldMorph ifAbsent: [nil]) isKindOf: Class)! !

!SystemDictionary methodsFor: 'miscellaneous' stamp: 'sw 9/21/1998 11:03'!
verifyMorphicAvailability
	"If Morphic is available, return true; if not, put up an informer and return false"
	self hasMorphic ifFalse:
		[self beep.
		self inform: 'Sorry, Morphic must
be present to use this feature'.
		^ false].
	^ true! !


!Utilities class methodsFor: 'durable menus' stamp: 'sw 9/21/1998 10:57'!
windowMenuWithLabels: labelList colorPattern: colorPattern  targets: targetList selections: selectionList title: aTitle
	| aWorld n   colorList  pos delta aButton  rightmost widthToUse |
	Smalltalk verifyMorphicAvailability ifFalse: [^ self].

	aWorld _ WorldMorph new.
	n _ labelList size.

	colorList _  (1 to: n) asArray  collect:
		[:ind | Color perform: (colorPattern at: (ind \\ colorPattern size + 1))].
			
	pos _ 4 @ 6.
	delta _ 0 @ 30.
	rightmost _ 0.

	1 to: labelList size do:
		[:index |
			aButton _ SimpleButtonMorph new.
			aButton label: (labelList at: index); 
				color: (colorList at: index); 
				target: (targetList at: index);
				actionSelector: (selectionList at: index);
				position: pos.
			rightmost _ rightmost max: aButton right.
			pos _ pos + delta.
			aWorld addMorphBack: aButton].
	widthToUse _ rightmost + 10.
	aWorld submorphs do:
		[:m | m position: (((widthToUse - m width) // 2) @ m position y)].
	aWorld setProperty: #initialExtent toValue: (widthToUse @ (aButton bottom + 10)).
	aWorld openWithTitle: aTitle! !


