'From Squeak2.9alpha of 13 June 2000 [latest update: #2915] on 12 November 2000 at 11:06:06 am'!
"Change Set:		223CEFilenameFix-je
Date:			8 November 2000
Author:			Jrn Eyrich

Ned Konz wrote:
DosFileDirectory>>fullPathFor: '\CF\Squeak\tiny.changes' returns '\C\CF\Squeak\tiny.changes'.

The problem is that the code there expects the instvar 'pathName' to be something starting with a volume letter and a colon. However, WinCE doesn't have volume letters. So FileDirectory default in this case is '\CF\Squeak'.

Either we need a separate FileDirectory subclass, or we need a conditional in there that checks to see whether there is a drive letter.

My suggested fix is attached."!


!DosFileDirectory methodsFor: 'path access' stamp: 'je 11/8/2000 20:02'!
driveName

   "return a possible drive letter and colon at the start of a Path name, empty string otherwise"

   | firstTwoChars |

   ( pathName size >= 2 ) ifTrue: [
      firstTwoChars _ (pathName copyFrom: 1 to: 2).
      (self class isDrive: firstTwoChars) ifTrue: [^firstTwoChars]
   ].
   ^''! !

!DosFileDirectory methodsFor: 'path access' stamp: 'je 11/8/2000 19:57'!
fullPathFor: path
	"Return the fully-qualified path name for the given file."
	path isEmpty ifTrue:[^pathName].
	(path at: 1) = $\ ifTrue:[
		(path size >= 2 and:[(path at: 2) = $\]) ifTrue:[^path]. "e.g., \\pipe\"
		^self driveName , path "e.g., \windows\"].
	(path size >= 2 and:[(path at: 2) = $: and:[path first isLetter]])
		ifTrue:[^path]. "e.g., c:"
	^pathName, self slash, path! !

