'From Squeak2.9alpha of 13 June 2000 [latest update: #2915] on 12 November 2000 at 4:09:02 pm'!
"Change Set:		235UrlWithPortFix-nk
Date:			9 October 2000
Author:			Ned Konz

This change set fixes handling of URL's
with ports specified, like:
	http://wherever.com:8080/x/y/z

[only added partly as hmm provided already a fix for toText --sma]
"!


!HierarchicalUrl methodsFor: 'parsing' stamp: 'nk 10/9/2000 16:07'!
privateInitializeFromText: aString relativeTo: aUrl 
	| remainder ind nextTok s |
	remainder _ aString.
	"set the scheme"
	schemeName _ aUrl schemeName.
	"a leading // means the authority is specified, meaning it is absolute"
	(remainder beginsWith: '//')
		ifTrue: [^ self privateInitializeFromText: aString].
	"otherwise, use the same authority"
	authority _ aUrl authority.
	port _ aUrl port.
	"get the query"
	ind _ remainder indexOf: $?.
	ind > 0
		ifTrue: [query _ remainder copyFrom: ind + 1 to: remainder size.
			remainder _ remainder copyFrom: 1 to: ind - 1].
	"get the path"
	remainder isEmpty
		ifTrue: [path _ aUrl path]
		ifFalse: [(remainder beginsWith: '/')
				ifTrue: [path _ OrderedCollection new]
				ifFalse: [path _ aUrl path shallowCopy.
					path size > 0
						ifTrue: [path removeLast]].
			s _ ReadStream on: remainder.
			[s peek = $/
				ifTrue: [s next].
			nextTok _ WriteStream on: String new.
			[s atEnd
				or: [s peek = $/]]
				whileFalse: [nextTok nextPut: s next].
			nextTok _ nextTok contents unescapePercents.
			nextTok = '..'
				ifTrue: [path size > 0
						ifTrue: [path removeLast]]
				ifFalse: [nextTok ~= '.'
						ifTrue: [path add: nextTok]].
			s atEnd] whileFalse.
			path isEmpty
				ifTrue: [path add: '']]! !

