'From Squeak2.9alpha of 5 August 2000 [latest update: #3220] on 4 January 2001 at 12:42:36 pm'!
"Change Set:		flapTweaks-sw
Date:			4 January 2001
Author:			Scott Wallace

Fixes the jump-to-project navigation button at the top of the Squeak flap, which got broken when the method it invoked got removed from the system a couple of months ago.
Provides balloon help for the items in the default tools flap (thanks to Joshua Channing Gargus).
Reinstates default flaps, so that the standard global flaps will reflect these changes, unless the user suppresses this by preference."!


!Utilities class methodsFor: 'flaps' stamp: 'sw 1/4/2001 09:08'!
addProjectNavigationButtonsTo: aMorph
	"Add prev, next, and go-to buttons at the top of aMorph"

	| aButton aFont |
	aButton _ SimpleButtonMorph new target: Project.
	aButton actionSelector: #returnToPreviousProject.
	aFont _ StrikeFont familyName: #ComicBold size: 24.
	aButton label: '<' font: aFont; borderWidth: 0.
	aButton firstSubmorph color: Color red lighter.
	aButton beTransparent.
	aButton position: 30 @ 12.
	aButton setBalloonText: 'previous project'.
	aMorph addMorph: aButton.

	aButton _ aButton fullCopy.
	aButton actionSelector: #advanceToNextProject.
	aButton label: '>' font: aFont; borderWidth: 0.
	aButton firstSubmorph color: Color red lighter.
	aButton position: 150 @ 14.
	aButton setBalloonText: 'next project'.
	aMorph addMorph: aButton.

	aButton _ aButton fullCopy actWhen: #buttonDown.
	aButton actionSelector: #jumpToProject; target: Project.
	aButton label: 'Go...' font: (StrikeFont familyName: #ComicBold size: 19); borderWidth: 0.
	aButton position: 78 @ 16.
	aButton firstSubmorph color: Color red lighter.
	aButton setBalloonText: 'go directly to a project'.
	aMorph addMorph: aButton! !

!Utilities class methodsFor: 'flaps' stamp: 'sw 1/4/2001 09:18'!
standardRightFlap
	"Answer a newly-created flap which adheres to the right edge of the screen and which holds prototypes of standard tools"

	|  aFlapTab aPage |
	aPage _ self newPartsFlapPage.
	aFlapTab _ FlapTab new referent: aPage beSticky.
	aFlapTab color: Color red lighter.
	aFlapTab assumeString: 'Tools' font: Preferences standardFlapFont orientation: #vertical color: Color orange lighter.
	aFlapTab edgeToAdhereTo: #right; inboard: false.
	aFlapTab setToPopOutOnDragOver: true.
	aFlapTab setToPopOutOnMouseOver: true.

	aPage extent: (90 @ self currentWorld height).
	self addSampleWindowsTo: aPage.
	aPage addMorphBack: ScriptingSystem newScriptingSpace.
	aPage addMorphBack: RecordingControlsMorph authoringPrototype.
	aPage replaceTallSubmorphsByThumbnails.

  "This hard-coded list is regrettable but expedient"
	#('System Browser' 'Package Browser' 'Workspace' 'File List' 'Dual Change Sorter' 'Single Change Sorter' 'Selector Browser' 'Assembly Area' 'Scripting Area' 'Sound Recorder') doWithIndex: 
		[:help :index |
			(aPage submorphs at: index) setBalloonText: help].

	aFlapTab position: (self currentWorld width - aFlapTab width) @ ((Display height - aFlapTab height) // 2).
	aPage beFlap: true.
	aPage color: (Color brown muchLighter alpha: 0.5).
	aPage extent: (90 @ self currentWorld height).
	
	^ aFlapTab! !

"Postscript:"
(Preferences okToReinitializeFlaps and: [Preferences useGlobalFlaps]) ifTrue: [Utilities reinstateDefaultFlaps].
!

