'From Squeak2.9alpha of 17 July 2000 [latest update: #3231] on 7 January 2001 at 12:46:45 pm'!
"Change Set:		evenCleanerBlocks
Date:			7 January 2001
Author:			Bob Arning

A bit of hackery to reduce the baggage carried along when publishing a project. It involves nil-ing the block arguments in the sortBlocks for the stepList and alarms. Otherwise, those variables might have caused some useless objects (perhaps *many* of them) to be included in the segment."!


!WorldState methodsFor: 'initialization' stamp: 'RAA 1/7/2001 12:33'!
stepListSortBlock

	| answer |

	"Please pardon the hackery below. Since the block provided by this method is retained elsewhere, it is possible that the block argument variables would retain references to objects that were no longer really needed. In one case, this feature resulted in doubling the size of a published project."

	^[ :stepMsg1 :stepMsg2 | 
		answer _ stepMsg1 scheduledTime <= stepMsg2 scheduledTime.
		stepMsg1 _ stepMsg2 _ nil.
		answer
	]! !

!WorldState methodsFor: 'alarms' stamp: 'RAA 1/7/2001 12:33'!
alarmSortBlock

	| answer |

	"Please pardon the hackery below. Since the block provided by this method is retained elsewhere, it is possible that the block argument variables would retain references to objects that were no longer really needed. In one case, this feature resulted in doubling the size of a published project."

	^[ :alarm1 :alarm2 | 
		answer _ alarm1 scheduledTime < alarm2 scheduledTime.
		alarm1 _ alarm2 _ nil.
		answer
	]! !

"Postscript:
Ensure that the step list and alarms are using cleaner blocks."

WorldState allInstancesDo: [ :each | each convertAlarms; convertStepList].
!

