'From Squeak2.9alpha of 17 July 2000 [latest update: #3241] on 9 January 2001 at 10:10:34 am'!
"Change Set:		moreFixedPanes
Date:			9 January 2001
Author:			Bob Arning

Extend fixed pane logic to MessageSet (optional buttons and annotations)"!


!MessageSet class methodsFor: 'instance creation' stamp: 'RAA 1/9/2001 10:08'!
openAsMorph: aMessageSet name: labelString inWorld: aWorld
	"Create a SystemWindow aMessageSet, with the label labelString."

	| window aListMorph aTextMorph listFraction nextOffset fixedPaneHeight |

	window _ (SystemWindow labelled: labelString) model: aMessageSet.
	listFraction _ 0.2.
	fixedPaneHeight _ 30.
	aListMorph _ PluggableListMorph on: aMessageSet list: #messageList
			selected: #messageListIndex changeSelected: #messageListIndex:
			menu: #messageListMenu:shifted:
			keystroke: #messageListKey:from:.
	aListMorph menuTitleSelector: #messageListSelectorTitle.
	window addMorph: aListMorph frame: (0@0 extent: 1@listFraction).

	nextOffset _ 0.
	Preferences useAnnotationPanes ifTrue: [
		aTextMorph _ PluggableTextMorph on: aMessageSet
					text: #annotation accept: nil
					readSelection: nil menu: nil.
		aTextMorph askBeforeDiscardingEdits: false.
		window 
			addMorph: aTextMorph
			fullFrame: (
				LayoutFrame 
					fractions: (0@listFraction corner: 1@listFraction) 
					offsets: (0@0 corner: 0@fixedPaneHeight)
			).
		nextOffset _ fixedPaneHeight
	].
	Preferences optionalButtons ifTrue: [
		window 
			addMorph: aMessageSet optionalButtonRow 
			fullFrame: (
				LayoutFrame 
					fractions: (0@listFraction corner: 1@listFraction) 
					offsets: (0@nextOffset corner: 0@(nextOffset + fixedPaneHeight))
			).
		nextOffset _ nextOffset + fixedPaneHeight
	].

	window 
		addMorph: (
			PluggableTextMorph on: aMessageSet 
				text: #contents accept: #contents:notifying:
				readSelection: #contentsSelection menu: #codePaneMenu:shifted:
		)
		fullFrame: (
			LayoutFrame 
				fractions: (0@listFraction corner: 1@1) 
				offsets: (0@nextOffset corner: 0@0)
		).

	window setUpdatablePanesFrom: #(messageList).
	window openInWorld: aWorld! !

