'From Squeak2.9alpha of 13 June 2000 [latest update: #3245] on 10 January 2001 at 2:16:51 pm'!
"Change Set:		NewEmptyScript-ar
Date:			10 January 2001
Author:			Andreas Raab

Provides a pseudo-script in the scripts category which can be used to create new scripts by dragging it out of the viewer's script category rather than going through the menu."!


!Player methodsFor: 'slots-kernel' stamp: 'ar 1/10/2001 11:52'!
categories
	"Answer a list of categories appropriate to the the receiver and its costumes"

	| aList |
	(self hasCostumeThatIsAWorld)
		ifTrue:	[^ self categoriesForWorld].

	aList _ OrderedCollection new.
	self slotNames size > 0 ifTrue:
		[aList add: #'instance variables'].
	aList addAll: costume categoriesForViewer.
	aList add: #scripts after: aList first.
	^ aList! !

!Player methodsFor: 'scripts-kernel' stamp: 'ar 1/10/2001 14:14'!
commandPhraseFor: commandSpec inViewer: aViewer
	"Translate commandSpec into a PhraseTileMorph.  Put appropriate balloon help into the phrase"

	| aRow resultType cmd names argType argTile selfTile aPhrase balloonTextSelector stat inst ut |
	names _ self class namedTileScriptSelectors.

	resultType _ (commandSpec at: 1).
	cmd _ (commandSpec at: 2).
	ut _ costume world valueOfProperty: #universalTiles ifAbsent: [false].
	ut ifTrue: [aPhrase _ (CategoryViewer new) newTilesFor: self command: commandSpec]
		ifFalse: [commandSpec size = 3
			ifTrue:
				[aPhrase _ PhraseTileMorph new setOperator: cmd
					type: resultType
					rcvrType: #player]
			ifFalse: "commandSpec size is four"
				[argType _ commandSpec at: 4.
				aPhrase _ PhraseTileMorph new setOperator: cmd
					type: resultType
					rcvrType: #player
					argType: argType.
				argTile _ self tileForArgType: argType inViewer: aViewer.
				argTile position: aPhrase lastSubmorph position.
				aPhrase lastSubmorph addMorph: argTile]].

	(self slotInfo includesKey: cmd)
		ifTrue: [balloonTextSelector _ #userSlot].

	(self belongsToUniClass and:
			[self class includesSelector: cmd])
		ifTrue: [balloonTextSelector _ #userScript].

	(ut ifTrue: [aPhrase submorphs second] ifFalse: [aPhrase operatorTile]) balloonTextSelector: 
			(balloonTextSelector ifNil: [cmd]).
	aPhrase markAsPartsDonor.
	cmd == #emptyScript ifTrue:[
		aPhrase setProperty: #newPermanentScript toValue: true.
		aPhrase setProperty: #player toValue: self].

	ut ifFalse: [
		selfTile _ aViewer tileForSelf.
		selfTile position: aPhrase firstSubmorph position.
		aPhrase firstSubmorph addMorph: selfTile].

	aRow _ ViewerRow newRow borderWidth: 0; color: aViewer color.
	aRow elementSymbol: cmd asSymbol.

	aRow addMorphBack: (ScriptingSystem tryButtonFor: aPhrase).
	aRow addMorphBack: (Morph new extent: 4@2; beTransparent).
	aRow addMorphBack: (aViewer infoButtonFor: cmd).
	aRow addMorphBack: aPhrase.
	(names includes: cmd) ifTrue:
		[aPhrase userScriptSelector: cmd.
		aPhrase beTransparent.
		aRow addMorphBack: AlignmentMorph newVariableTransparentSpacer.
		aRow addMorphBack: (stat _ (inst _ self scriptInstantiationForSelector: cmd) statusControlMorph).
		inst updateStatusMorph: stat.].

	aRow beSticky; disableDragNDrop.

	^ aRow! !

!Player methodsFor: 'scripts-kernel' stamp: 'ar 1/10/2001 12:10'!
emptyScript
	"The empty script"! !

!Player methodsFor: 'scripts-kernel' stamp: 'ar 1/10/2001 12:02'!
tileScriptCommands
	"Return a list of typed-command arrays of the form:
		#command <selector> <balloon help>"
	self flag: #deferred.  "'need way for user to save own help"
	^(Array with: {#command. #'emptyScript'. 'a new empty script'}),
		(self class namedTileScriptSelectors asSortedArray collect:
			[:sel | Array with: #command with: sel with: 'a user-written script'])! !

