'From Squeak2.9alpha of 5 August 2000 [latest update: #3291] on 19 January 2001 at 8:08:22 pm'!
"Change Set:		filterOops-sw
Date:			19 January 2001
Author:			Scott Wallace

Disallow the message-filtering of the preceding update if not in morphic
Supply some methods inadvertently omitted from preceding update."!


!StringHolder methodsFor: 'accessing' stamp: 'sw 12/1/2000 11:04'!
reformulateList
	"If the receiver has a way of reformulating its message list, here is a chance for it to do so"! !


!Browser methodsFor: 'message list' stamp: 'sw 12/1/2000 11:17'!
reformulateList
	"If the receiver has a way of reformulating its message list, here is a chance for it to do so"

	super reformulateList.
	self messageListIndex: 0! !


!MessageSet methodsFor: 'message functions' stamp: 'sw 12/11/2000 15:51'!
deleteFromMessageList: aMessage
	"Delete the given message from the receiver's message list"

	messageList _ messageList copyWithout: aMessage! !

!MessageSet methodsFor: 'message functions' stamp: 'sw 12/1/2000 11:54'!
reformulateList
	"The receiver's messageList has been changed; rebuild it"

	super reformulateList.
	self initializeMessageList: messageList.
	self changed: #messageList.
	self changed: #messageListIndex.
	self contentsChanged
! !

!MessageSet methodsFor: 'filtering' stamp: 'sw 1/19/2001 20:00'!
filterMessageList
	"Allow the user to refine the list of messages."

	| aMenu evt |
	Smalltalk isMorphic ifFalse: [^ self inform: 'sorry, morphic only at this time.'].
	messageList size <= 1 ifTrue: [^ self inform: 'this is not a propitious filtering situation'].

	"would like to get the evt coming in but thwarted by the setInvokingView: circumlocution"
	evt _ self currentWorld activeHand lastEvent.
	aMenu _ MenuMorph new defaultTarget: self.
	aMenu addTitle: 'Filter by only showing...'.
	aMenu addStayUpItem.

	aMenu addList: #(
		('messages that send...'					filterToSendersOf)
		-
		('messages in current change set'		filterToCurrentChangeSet)
		('messages not in current change set'	filterToNotCurrentChangeSet)
		('messages in any change set'			filterToAnyChangeSet)
		-
		('messages authored by me'				filterToCurrentAuthor)
		('messages not authored by me'			filterToNotCurrentAuthor)
		-
		('messages only in .changes file'		filterToMessagesInChangesFile)
		('messages with prior versions'			filterToMessagesWithPriorVersions)
			).

	aMenu popUpEvent: evt hand lastEvent in: evt hand world.! !

!StandardSystemView methodsFor: 'label access' stamp: 'sw 1/19/2001 20:13'!
setLabel: aLabel
	"For compatibility with morphic"

	self relabel: aLabel! !


