'From Squeak 2.2 of Sept 23, 1998 on 29 September 1998 at 8:12:04 am'!
"Change Set:		paintingTweaks-sw
Date:			29 September 1998
Author:			Scott Wallace

When user chooses 'make new drawing' from the New Morph menu, she now gets an about-to-paint icon attached to the house; the first click lets her choose the receptor for the putative painting.

Adds a preference, #unlimitedPaintArea -- if true, no limits are put on the onion-skin area for painting; if false, a nominal limit (given by whatever is returned by Preferences defaultPaintingExtent) is used, in an effort to reduce the likelihood of running out of memory.

Also, exclude SketchMorph from the textual New Morph menu"!


!HandMorph methodsFor: 'world menu' stamp: 'sw 9/28/1998 17:48'!
newMorph
	| menu subMenu catDict shortCat class |
	menu _ (MenuMorph entitled: 'Add a new morph') defaultTarget: self.
	menu addStayUpItem.
	menu add: 'from paste buffer' action: #pasteMorph.
	menu add: 'grab patch from screen' action: #grabDrawingFromScreen.
	menu add: 'make new drawing' target: self action: #newDrawingFromMenu.

	menu addLine.
	catDict _ Dictionary new.
	SystemOrganization categories do:
		[:cat |
		((cat beginsWith: 'Morphic-')
				and: [(#('Morphic-Menus' 'Morphic-Support') includes: cat) not])
		ifTrue:
			[shortCat _ cat copyFrom: 'Morphic-' size+1 to: cat size.
			(SystemOrganization listAtCategoryNamed: cat) do:
				[:cName | class _ Smalltalk at: cName.
				((class inheritsFrom: Morph)
					and: [class includeInNewMorphMenu])
					ifTrue:
					[(catDict includesKey: shortCat) 
					ifTrue: [(catDict at: shortCat) addLast: class]
					ifFalse: [catDict at: shortCat put: (OrderedCollection with: class)]]]]].

	catDict keys asSortedCollection do:
		[:categ |
		subMenu _ MenuMorph new.
		((catDict at: categ) asSortedCollection: [:c1 :c2 | c1 name < c2 name]) do:
			[:cl | subMenu add: cl name
					target: self
					selector: #newMorphOfClass:event:
					argument: cl].
		menu add: categ subMenu: subMenu].

	menu popUpAt: self position forHand: self.
! !

!HandMorph methodsFor: 'world menu commands' stamp: 'sw 9/28/1998 17:48'!
newDrawingFromMenu
	self attachMorph: PaintInvokingMorph new markAsPartsDonor! !


!PasteUpMorph methodsFor: 'painting' stamp: 'sw 9/22/1998 12:26'!
paintingBoundsAround: aPoint
	"Return a rectangle for painting centered on the given point. Both the argument point and the result rectangle are in world coordinates."

	| paintExtent maxPaintArea myBnds |
	paintExtent _ self reasonablePaintingExtent.
	maxPaintArea _ paintExtent x * paintExtent y.
	myBnds _ self boundsInWorld.
	(myBnds area <= maxPaintArea) ifTrue: [^ myBnds].
	^ (aPoint - (paintExtent // 2) extent: paintExtent) intersect: myBnds
! !

!PasteUpMorph methodsFor: 'painting' stamp: 'sw 9/29/1998 07:35'!
reasonablePaintingExtent
	^ Preferences unlimitedPaintArea
		ifTrue:
			[3000 @ 3000]
		ifFalse:
			[Preferences defaultPaintingExtent]! !


!Preferences class methodsFor: 'parameters' stamp: 'sw 9/29/1998 07:35'!
defaultPaintingExtent
	"Answer the preferred size for the onion-skin paint area when launching a new painting within a paste-up morph.  Feel free to change the parameters to suit your configuration."

	^ 320 @ 240! !


!SketchMorph class methodsFor: 'as yet unclassified' stamp: 'sw 9/28/1998 17:15'!
includeInNewMorphMenu
	"Not to be instantiated from the menu"
	^ false! !


StandardScriptingSystem removeSelector: #reasonablePaintingExtent!
WorldMorph removeSelector: #reasonablePaintingExtent!
"Postscript:
"
Preferences setPreference: #unlimitedPaintArea toValue: false.!

