'From Squeak3.1alpha of 5 February 2001 [latest update: #3693] on 23 February 2001 at 11:00:11 am'!
"Change Set:		MoreClassicTiles
Date:			21 February 2001
Author:			Dan Ingalls

Refactors some of the 'classic' tile preference and behavior code so as not to interact with the new panel look.
"!


!MethodNode methodsFor: 'tiles' stamp: 'di 2/21/2001 11:56'!
asMorphicSyntaxUsing: aClass
	
	^ (aClass methodNodeOuter: self) finalAppearanceTweaks
		! !


!Preferences class methodsFor: 'initial values' stamp: 'di 2/23/2001 10:52'!
initialValuesAdditionscriptinglargeTiles
	^ #(#(#largeTiles #false #(#scripting) 'Governs whether universal tiles should appear and act like classic tiles when scripting in this project.') )! !


!SyntaxMorph methodsFor: 'node to morph' stamp: 'di 2/21/2001 11:48'!
methodNodeOuter: aNode

	| block |
	
	self borderWidth: 0.
	self alansTest1 ifTrue: [self addTemporaryControls].
	aNode asMorphicSyntaxIn: self.
	block _ self submorphs last.
	block submorphs size = 1 ifTrue: [^ self].	"keep '^ self' if that is the only thing in method"
	block submorphs last decompile string = '^  self ' ifTrue: [
		block submorphs last delete].
	^ self! !

!SyntaxMorph methodsFor: 'formatting options' stamp: 'di 2/21/2001 11:42'!
alansTest1
	
	| root |

	root _ self rootTile ifNil: [self].
	^root valueOfProperty: #alansNewStyle ifAbsent: [self usingClassicTiles not]! !

!SyntaxMorph methodsFor: 'formatting options' stamp: 'di 2/21/2001 12:38'!
finalAppearanceTweaks

	self usingClassicTiles
	ifTrue:
		[self allMorphsDo:
			[:each | (each isKindOf: SyntaxMorph) ifTrue:
				[each lookClassic]]]
	ifFalse:
		[SizeScaleFactor ifNil: [SizeScaleFactor _ 1.0]. 
		self allMorphsDo: [ :each |
			(each respondsTo: #setDeselectedColor) ifTrue: [each setDeselectedColor].
			(each hasProperty: #variableInsetSize) ifTrue: [
				each layoutInset: 
					((each valueOfProperty: #variableInsetSize) * SizeScaleFactor) rounded.
			].
		]].
! !

!SyntaxMorph methodsFor: 'formatting options' stamp: 'di 2/21/2001 12:30'!
lookClassic
	self isLeafTile ifTrue: [self layoutInset: 2@4]! !

!SyntaxMorph methodsFor: 'formatting options' stamp: 'di 2/21/2001 11:31'!
usingClassicTiles 

	^ Preferences largeTiles! !

SyntaxMorph removeSelector: #doLayoutIn:!
