'From Squeak3.1alpha of 5 February 2001 [latest update: #3758] on 1 March 2001 at 10:20:50 pm'!
"Change Set:		tabAmongFields-sw
Date:			1 March 2001
Author:			Scott Wallace

Fixes a couple of problems related to the tabAmongFields feature:
(1)  Items in parts bins are now never given keyboard focus upon tab.
(2)  One can now successfully cycle among items at different levels of nesting.  The nearest enclosing container that has the #tabAmongFields property is the one that gets to determine the successor field when tab is hit."!


!Morph methodsFor: 'structure' stamp: 'sw 3/1/2001 22:19'!
pasteUpMorphHandlingTabAmongFields
	"Answer the nearest PasteUpMorph in my owner chain that has the tabAmongFields property, or nil if none"

	| aPasteUp |
	aPasteUp _ self pasteUpMorph.
	[aPasteUp notNil] whileTrue:
		[(aPasteUp hasProperty: #tabAmongFields) ifTrue:
			[^ aPasteUp].
		aPasteUp _ aPasteUp pasteUpMorph].
	^ nil! !


!TextMorph methodsFor: 'editing' stamp: 'sw 3/1/2001 17:16'!
handleKeystroke: anEvent
	"System level event handling."

	| pasteUp |
	anEvent wasHandled ifTrue:[^self].
	(self handlesKeyboard: anEvent) ifFalse:	[^ self].
	anEvent wasHandled: true.
	anEvent keyCharacter = Character tab ifTrue:
		["Allow passing through text morph inside pasteups"
		(self wouldAcceptKeyboardFocusUponTab and:
				[(pasteUp _ self pasteUpMorphHandlingTabAmongFields) notNil])
			ifTrue:[^ pasteUp tabHitWithEvent: anEvent]].
	self keyStroke: anEvent! !

!TextMorph methodsFor: 'private' stamp: 'sw 3/1/2001 16:59'!
wouldAcceptKeyboardFocusUponTab
	"Answer whether the receiver might accept keyboard focus if tab were hit in some container playfield"

	^ self isLocked not and: [self inPartsBin not]! !

