'From Squeak3.1alpha of 21 February 2001 [latest update: #3776] on 5 March 2001 at 3:21:11 pm'!
"Change Set:		J3-Changes-3.0
Date:			5 March 2001
Author:			Marcus Denker

-> a bugfix for Object>>flushCache when running J3
-> removes some dead code from J1/2
-> fixes writeCompilerSourceFiles for 3.0"!


!Interpreter methodsFor: 'other primitives' stamp: 'md 2/12/2001 16:41'!
primitiveFlushCache
	"Clear the method lookup cache. This must be done after every programming change."

	self flushMethodCache.
	self compilerFlushCacheHook: nil.		"Flush the dynamic compiler's inline caches."
! !


!InterpreterSupportCode class methodsFor: 'compiler-j3' stamp: 'md 2/7/2001 14:12'!
nextPutExternDeclarations: tricky on: file
	file nextPutAll: 'static const unsigned ArgumentCountBit=	0x01; // prim reads argumentCount'; cr.
	file nextPutAll: 'static const unsigned StackPointerBit=	0x02; // prim reads stackPointer'; cr.
	file nextPutAll: 'static const unsigned SuccessFlagBit=	0x04; // prim writes successFlag'; cr.
	file nextPutAll: 'static const unsigned ActiveFrameBit=	0x08; // prim may cause GC'; cr.
	file nextPutAll: 'static const unsigned IntrinsicPrimBit=	0x10; // prim not exported to j3'; cr.
	file nextPutAll: 'static const unsigned PrimitiveFailBit=	0x20; // prim has no primitive response'; cr.
	file nextPutAll: 'static const unsigned FastPrimBit=		0x40; // prim nees no interrupt check'; cr.
	file cr.
	file nextPutAll: 'typedef int (*primitive_t)(void);'; cr; cr.
	file nextPutAll: 'extern primitive_t primitiveTable[];'; cr; cr.
	file nextPutAll: 'extern unsigned char primitiveFlags[];'; cr; cr.
	file nextPutAll: '// primitives imported from the Interpreter'; cr; cr.
	file nextPutAll: 'extern "C" {'; cr.
	tricky keysDo: [:prim | file nextPutAll: '  int '; nextPutAll: prim; nextPutAll: '(void);'; cr].
	file nextPutAll: '};'; cr; cr.! !

!InterpreterSupportCode class methodsFor: 'compiler-j3' stamp: 'md 2/7/2001 14:12'!
primitiveHeaderString: tricky			"InterpreterSupportCode primitiveHeaderString: self trickyPrimitiveList"
	"Answer the contents of the primitives.h file."

	^String streamContents: [:file |
		file nextPutAll: '// primitives.h -- primitive characteristics'; cr;
			nextPutAll: '//'; cr;
			nextPutAll: '// WARNING: this file was generated automatically -- DO NOT EDIT!!'; cr;
			nextPutAll: '//'; cr;
			nextPutAll: '// Author: Squeak3.0 (on behalf of Ian.Piumarta@INRIA.Fr)'; cr;
			nextPutAll: '//'; cr;
			nextPutAll: '// Last edited: NEVER (and woebetide anybody who dares to!!)'; cr; cr.
		self nextPutExternDeclarations: tricky on: file.
	]! !

!InterpreterSupportCode class methodsFor: 'compiler-j3' stamp: 'md 2/7/2001 12:27'!
trickyPrimitiveList
	"InterpreterSupportCode trickyPrimitiveList"

	| primitives internal method index ivars |
	"Instance variables of Interpreter that we might have to setup before running a primitive"
	ivars _ #(activeContext argumentCount instructionPointer lkupClass messageSelector
			method newMethod primitiveIndex receiver stackPointer successFlag theHomeContext).
	Interpreter initialize.
	primitives _ self internalPrimitives asArray.
	primitives _ IdentityDictionary withAll: ('scanning for reachable methods...' withCRs
		displayProgressAt: Sensor cursorPoint
		from: 1 to: primitives size
		during: [:bar |
			primitives withIndexCollect: [:sel :seq |
				bar value: seq.
				sel -> (self selectorsReachableFrom: sel)]]).
	internal _ Dictionary new.
	('scanning for inst var refs...' withCRs
		displayProgressAt: Sensor cursorPoint
		from: 1 to: ivars size
		during: [:bar |
			ivars withIndexCollect: [:ivar :seq |
				bar value: seq.
				index _ Interpreter allInstVarNames indexOf: ivar.
				ivar -> (primitives select: [:sels |
							nil ~~ (sels detect: [:sel |
											method _ (Interpreter compiledMethodAt: sel).
											(method readsField: index) or: [method writesField: index]]
										ifNone: [nil])]) keys]])
		associationsDo: [:assoc |
			assoc value do: [:sel |
				(internal at: sel ifAbsent: [internal at: sel put: Set new])
					add: assoc key]].
	primitives keysDo: [:sel | (internal includesKey: sel) ifFalse: [internal at: sel put: Set new]].
	internal addAll: (self externalPrimitives collect: [:prim | prim -> #(argumentCount stackPointer successFlag)]).
	(internal at: #primitiveStoreImageSegment) removeAll:
		#(activeContext lkupClass messageSelector method newMethod receiver).
	(internal at: #primitiveSnapshotEmbedded) removeAll:
		#(activeContext instructionPointer method).
	internal at: #primitiveFlushCache put:
		#(stackPointer activeFrame).
	^(internal associationsDo: [:assoc | assoc value: assoc value asSortedCollection])! !

SystemDictionary removeSelector: #compilerDisable!
SystemDictionary removeSelector: #compilerEnable!
InterpreterSupportCode class removeSelector: #comparativeBenchmarks!
InterpreterSupportCode class removeSelector: #compilerBenchmarks!
InterpreterSupportCode class removeSelector: #primitiveTableDeclaration!
InterpreterSupportCode class removeSelector: #primitiveTableDefinition!
"Postscript:"
InterpreterSupportCode class removeCategory: 'compiler'.
!

