'From Squeak3.1alpha of 6 February 2001 [latest update: #4173] on 18 August 2001 at 11:09:52 am'!
"Change Set:		BrowserFixes-jlb
Date:			14 August 2001
Author:			Jim Benson

Fixes a DNU if you left click into an empty method category pane."!


!Browser methodsFor: 'accessing' stamp: 'jlb 8/13/2001 15:26'!
contents
	"Depending on the current selection, different information is retrieved.
	Answer a string description of that information. This information is the
	method of the currently selected class and message."
	| comment theClass latestCompiledMethod |
	latestCompiledMethod _ currentCompiledMethod.
	currentCompiledMethod _ nil.

	editSelection == #none ifTrue: [^ ''].
	editSelection == #editSystemCategories 
		ifTrue: [^ systemOrganizer printString].
	editSelection == #newClass 
		ifTrue: [^ (theClass _ self selectedClass)
			ifNil:
				[Class template: self selectedSystemCategoryName]
			ifNotNil:
				[Class templateForSubclassOf: theClass category: self selectedSystemCategoryName]].
	editSelection == #editClass 
		ifTrue: [^ (theClass _ self selectedClassOrMetaClass)
					ifNil: [ "" ]
					ifNotNil: [
				 		theClass definitionST80: Preferences printAlternateSyntax not]].
	editSelection == #editComment 
		ifTrue: [(theClass _ self selectedClass) ifNil: [^ ''].
				comment _ theClass comment.
				comment size = 0
				ifTrue: [^ 'This class has not yet been commented.']
				ifFalse: [^ comment]].
	editSelection == #hierarchy 
		ifTrue: [^ self selectedClassOrMetaClass printHierarchy].
	editSelection == #editMessageCategories 
		ifTrue: [^ self classOrMetaClassOrganizer printString].
	editSelection == #newMessage
		ifTrue: [ ^ (theClass _ self selectedClassOrMetaClass) 
						ifNil: [ "" ]
						ifNotNil: [ theClass sourceCodeTemplate]].
	editSelection == #editMessage
		ifTrue:
			[self showingByteCodes ifTrue:
				[^ (self selectedClassOrMetaClass compiledMethodAt: self selectedMessageName) symbolic asText].
			currentCompiledMethod _ latestCompiledMethod.
			^ self selectedMessage].

	self error: 'Browser internal error: unknown edit selection.'! !

