'From Squeak 2.3 beta of Nov 25, 1998 on 7 December 1998 at 9:54:35 am'!
"Change Set:		accuratePreDebug-sw
Date:			7 December 1998
Author:			Scott Wallace

Makes more accurate determination of when to put proceed/debug buttons in the window title of PreDebug windows, and how to label them.  Formerly, we used an approximate algorithm just based on the number of characters in the window title, now we carefully determine the actual string width."!


!SystemWindow methodsFor: 'label' stamp: 'sw 12/2/1998 16:49'!
widthOfFullLabelText
	^ (QuickPrint newOn: Display box: Display boundingBox font: ((TextStyle default fontAt: 2) emphasized: 1)) stringWidth: labelString
! !


!PreDebugWindow methodsFor: 'all' stamp: 'sw 12/2/1998 16:51'!
initialize
	| aFont proceedLabel debugLabel aWidth |
	super initialize.
	(aWidth _ self widthOfFullLabelText) > 280 ifTrue: [^ self].   "No proceed/debug buttons if title too long"
	aWidth > 210
		ifTrue: "Abbreviated buttons if title pretty long"
			[proceedLabel _ 'p'.
			debugLabel _ 'd']
		ifFalse: "Full buttons if title short enough"
			[proceedLabel _ 'proceed'.
			debugLabel _ 'debug'].
	aFont _ Preferences fontForScriptorButtons.
	self addMorph: (proceedButton _ SimpleButtonMorph new borderWidth: 0;
			label: proceedLabel font: aFont; color: Color transparent;
			actionSelector: #proceed; target: self).
	proceedButton setBalloonText: 'continue execution'.
	self addMorph: (debugButton _ SimpleButtonMorph new borderWidth: 0;
			label: debugLabel font: aFont; color: Color transparent;
			actionSelector: #debug; target: self).
	debugButton setBalloonText: 'bring up a debugger'.

	proceedButton submorphs first color: Color blue.
	debugButton submorphs first color: Color red.

	self adjustBookControls! !


