'From Squeak3.3alpha of 18 January 2002 [latest update: #4905] on 4 July 2002 at 12:24:08 am'!
"Change Set:		watchCleanup-sw
Date:			3 July 2002
Author:			Scott Wallace

A resolution of the tension between the WatchMorph's wish to allow the user to specify a center color and its determination to draw the center either lighter or darker depending on whether it is AM or PM.
Removes an irrelevant method, adjusts the class comment.
Makes two toggle-like menu items use the checkbox mechanism.
Thanks to Alejandro Magistrello for bringing some of these issues to light."!


!WatchMorph commentStamp: 'sw 7/3/2002 23:20' prior: 0!
This class is a representation of a watch.
The labels' font is changeble. Labels' font size increase or decrease when resizing me.

WatchMorph new openInWorld
(WatchMorph fontName: 'ComicPlain' bgColor: Color transparent centerColor: Color transparent) openInWorld		" transparent "
(WatchMorph fontName: 'ComicBold' bgColor: Color white centerColor: Color black) openInWorld

Structure:
	fontName		String -- the labels' font name
	cColor			Color -- center color
	handsColor		Color
	romanNumerals	Boolean
	antialias		Boolean!


!WatchMorph methodsFor: 'accessing' stamp: 'sw 7/4/2002 00:19'!
centerColor: aColor
	"Set the center color as indicated; map nil into transparent"

	cColor _ aColor ifNil: [Color transparent]! !

!WatchMorph methodsFor: 'drawing' stamp: 'sw 7/4/2002 00:22'!
drawOn: aCanvas
	"Draw the watch on the given canvas"

	| pHour pMin pSec time centerColor |
	time _ Time now.
	pHour _ self radius: 0.6 hourAngle: time hours + (time minutes/60.0).
	pMin _ self radius: 0.72 hourAngle: (time minutes / 5.0).
	pSec _ self radius: 0.8 hourAngle: (time seconds / 5.0).
	centerColor _ cColor
		ifNil:
			[Color transparent]
		ifNotNil:
			[time hours < 12
				ifTrue: [cColor muchLighter]
				ifFalse: [cColor]].

	antialias ifTrue:
		[aCanvas asBalloonCanvas
			aaLevel: 4;
			drawOval: (bounds insetBy: borderWidth // 2 + 1) color: self fillStyle
				borderWidth: borderWidth borderColor: borderColor;
			drawOval: (bounds insetBy: self extent*0.35) color: centerColor
				borderWidth: 0 borderColor: Color black;
			drawPolygon: {self center. pHour}
				color: Color transparent borderWidth: 3 borderColor: handsColor;
			drawPolygon: {self center. pMin}
				color: Color transparent borderWidth: 2 borderColor: handsColor;
			drawPolygon: {self center. pSec}
				color: Color transparent borderWidth: 1 borderColor: handsColor]
		ifFalse:
			[super drawOn: aCanvas.
			aCanvas
				fillOval: (bounds insetBy: self extent*0.35) color: centerColor;
				line: self center to: pHour width: 3 color: handsColor;
				line: self center to: pMin width: 2 color: handsColor;
				line: self center to: pSec width: 1 color: handsColor]
! !

!WatchMorph methodsFor: 'menus' stamp: 'sw 7/4/2002 00:23'!
addCustomMenuItems: aMenu hand: aHandMorph
	"Add morph-specific items to the given menu which was invoked by the given hand."

	super addCustomMenuItems: aMenu hand: aHandMorph.
	aMenu addLine.
	aMenu addUpdating: #romanNumeralString action: #toggleRoman.
	aMenu addUpdating: #antiAliasString action: #toggleAntialias.
	aMenu addLine.
	aMenu add: 'change font...' action: #changeFont.
	aMenu balloonTextForLastItem: 'Allows you to change the font used to display the numbers.'.
	aMenu add: 'change hands color...' action: #changeHandsColor.
	aMenu balloonTextForLastItem: 'Allows you to specify a new color for the hands of the watch.  Note that actual *watch* color can be changed simply by using the halo''s recoloring handle.'.
	aMenu add: 'change center color...' action: #changeCenterColor.
	aMenu balloonTextForLastItem: 'Allows you to specify a new color to be used during PM hours for the center portion of the watch; during AM hours, a lighter shade of the same color will be used.'.! !

!WatchMorph methodsFor: 'menus' stamp: 'sw 7/4/2002 00:00'!
antiAliasString
	^  antialias
		ifTrue:['<on>anti-aliasing']
		ifFalse:['<off>anti-aliasing']! !

!WatchMorph methodsFor: 'menus' stamp: 'sw 7/4/2002 00:04'!
romanNumeralString
	"Answer a string governing the roman-numerals checkbox"

	^  romanNumerals
		ifTrue:	['<on>roman numerals']
		ifFalse:	['<off>roman numerals']! !

WatchMorph class removeSelector: #fontName:!
