'From Squeak3.3alpha of 18 January 2002 [latest update: #4918] on 19 July 2002 at 1:07:10 pm'!
"Change Set:		reportFullStack-sw
Date:			19 July 2002
Author:			Scott Wallace

In the error report, print out the short form of *all* stack frames in the same 'rcvr(class) >> selector' format, after printing out the long form of the first four stack frames.  This makes the entire compact summary available in a single, readable tableau.  Formerly, the first four stack frames did not appear in the compact summary."!


!ContextPart methodsFor: 'debugger access' stamp: 'sw 7/19/2002 13:04'!
errorReportOn: strm
	"Write a detailed error report on the stack (above me) on a stream.  For both the error file, and emailing a bug report.  Suppress any errors while getting printStrings.  Limit the length."

	| cnt aContext startPos |
 	strm print: Date today; space; print: Time now; cr.
	strm cr.
	strm nextPutAll: 'VM: ';
		nextPutAll: Smalltalk platformName asString;
		nextPutAll: ' - ';
		nextPutAll: Smalltalk vmVersion asString;
		cr.
	strm nextPutAll: 'Image: ';
		nextPutAll: Smalltalk version asString;
		nextPutAll: ' [';
		nextPutAll: Smalltalk lastUpdateString asString;
		nextPutAll: ']';
		cr.
	strm cr.

	"Note: The following is an open-coded version of ContextPart>>stackOfSize: since this method may be called during a low space condition and we might run out of space for allocating the full stack."
	cnt _ 0.  startPos _ strm position.
	aContext _ self.
	[aContext == nil] whileFalse:
		[[(cnt _ cnt + 1) < 5]
			whileTrue:
				[aContext printDetails: strm.	"variable values"
				strm cr.
				aContext _ aContext sender].

	strm cr; nextPutAll: '--- The full stack ---'; cr.
	aContext _ self.
	cnt _ 0.
	[aContext == nil] whileFalse:
		[cnt _ cnt + 1.
		cnt = 5 ifTrue: [strm nextPutAll: ' - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -'; cr].
		strm print: aContext; cr.  "just class>>selector"	

		strm position > (startPos+4000) ifTrue: [strm nextPutAll: '...etc...'.
			^ self]. 	"exit early"
		cnt > 60 ifTrue: [strm nextPutAll: '-- and more not shown --'.  ^ self].
		aContext _ aContext sender]]! !

