'From Squeak 2.3 beta of Nov 25, 1998 on 8 January 1999 at 2:58:16 pm'!
"Change Set:		showChangeSet-sw
Date:			8 January 1999
Author:			Scott Wallace

Changes the 'show' command in a Change Sorter such that it presents the alternatives in case-blind alphabetic order (not including leading numerals and spaces when doing the alphabetizing).  Useful for finding a change set whose name you know but whose position in the chronological list you do not know.

(The former implementation of the 'show' command became redundant when a change-set-name-list pane was added to change sorters a while back.)"!


!ChangeSorter methodsFor: 'changeSet menu' stamp: 'sw 1/8/1999 14:52'!
chooseCngSet
	"Present the user with an alphabetical list of change set names, and let her choose one"
	| index changeSetsSortedAlphabetically |
	self okToChange ifFalse: [^ self].
	ChangeSet instanceCount > AllChangeSets size ifTrue: [self class gatherChangeSets].
	changeSetsSortedAlphabetically _ AllChangeSets asSortedCollection:
		[:a :b | a name asLowercase withoutLeadingDigits < b name asLowercase withoutLeadingDigits].

	index _ (PopUpMenu labels: 
		(changeSetsSortedAlphabetically collect: [:each | each name]) asStringWithCr) startUp.
	index = 0 ifFalse: [self showChangeSet: (changeSetsSortedAlphabetically at: index)].
! !


!String methodsFor: 'converting' stamp: 'sw 1/8/1999 14:45'!
withoutLeadingDigits
	"Answer the portion of the receiver that follows any leading series of digits and blanks.  If the receiver consists entirely of digits and blanks, return an empty string"
	| firstNonDigit |
	firstNonDigit _ (self findFirst: [:m | m isDigit not and: [m ~~ $ ]]).
	^ firstNonDigit > 0
		ifTrue:
			[self copyFrom: firstNonDigit  to: self size]
		ifFalse:
			['']

"
'234Whoopie' withoutLeadingDigits
' 4321 BlastOff!!' withoutLeadingDigits
'wimpy' withoutLeadingDigits
'  89Ten ' withoutLeadingDigits
'78 92' withoutLeadingDigits
"
! !


