'From Squeak 2.3 of January 14, 1999 on 30 March 1999 at 9:51:21 am'!
"Change Set:		makeFlashUseCode-jhm
Date:			30 March 1999
Author:			John Maloney

Make the FlashFileReader use the new ADPCM codec. The results
in much faster Flash file sound parsing on 2.4 and later VM's.
"!


!FlashFileReader methodsFor: 'processing sounds' stamp: 'jm 3/30/1999 09:08'!
createSoundFrom: soundBuffers stereo: stereo samplingRate: samplingRate

	| snds |
	snds _ soundBuffers collect: [:buf |
		(SampledSound samples: buf samplingRate: samplingRate) loudness: 1.0].
	stereo
		ifTrue:[
			^ MixedSound new
				add: (snds at: 1) pan: 0.0;
				add: (snds at: 2) pan: 1.0;
				yourself]
		ifFalse: [
			^ snds at: 1].! !

!FlashFileReader methodsFor: 'processing sounds' stamp: 'jm 3/30/1999 08:55'!
decompressSound: aByteArray stereo: stereo samples: numSamples rate: samplingRate

	| buffers |
	buffers _ ADPCMCodec new
		decodeFlash: aByteArray sampleCount: numSamples stereo: stereo.
	^ self createSoundFrom: buffers stereo: stereo samplingRate: samplingRate
! !


!FlashMorphReader methodsFor: 'defining sounds' stamp: 'jm 3/30/1999 09:43'!
flushStreamingSound

	| bufs sound |
	streamingSound buffers ifNil: [^ self].
	streamingSound buffers first position = 0 ifFalse: [
		bufs _ streamingSound buffers collect: [:b | b contents].
		sound _ self createSoundFrom: bufs
					stereo: streamingSound stereo
					samplingRate: streamingSound samplingRate.
		player addSound: sound at: streamingSound firstFrame].
	streamingSound firstFrame: frame.
	streamingSound frameNumber: frame.
	streamingSound buffers do: [:s | s reset].
! !

!FlashMorphReader methodsFor: 'defining sounds' stamp: 'jm 3/30/1999 09:14'!
recordSoundStreamBlock: data

	| newBufs |
	streamingSound frameNumber + 1 = frame 
		ifFalse: [self flushStreamingSound].
	newBufs _ ADPCMCodec new
		decodeFlash: data
		sampleCount: streamingSound sampleCount
		stereo: streamingSound stereo.
	streamingSound buffers with: newBufs do:
		[:streamBuf :newBuf | streamBuf nextPutAll: newBuf].
	streamingSound frameNumber: frame.
! !


