'From Squeak 2.3 of January 14, 1999 on 12 April 1999 at 12:57:16 pm'!
"Change Set:		HiddenInfoFix
Date:			12 April 1999
Author:			Duane Maxwell

This changeset fixes a bug in the hidden info menu command, which copies
the action of a TextAction attribute into the clipboard.  The original
compared the attribute class names with an incomplete list of possible
TextActions.  As a result, Doit actions did not properly generate
information. The new one adds an default info method to the TextAction
class and uses kindOf to detect membership.
"!


!ParagraphEditor methodsFor: 'editing keys' stamp: 'DSM 3/30/1999 13:17'!
copyHiddenInfo
	"In TextLinks, TextDoits, TextColor, and TextURLs, there is hidden
info.  Copy that to the clipboard.  You can paste it and see what it is.
Usually enclosed in <>."

	| attrList |
	attrList _ paragraph text attributesAt: (startBlock stringIndex +
stopBlock stringIndex)//2.
	attrList do: [:attr |
		(attr isKindOf: TextAction) ifTrue: [
			^ self clipboardTextPut: ('<', attr info, '>') asText].
		].
	"If none of the above"
	attrList do: [:attr |
		attr class == TextColor ifTrue: [
			^ self clipboardTextPut: attr color printString
asText]].
	^ self clipboardTextPut: '[No hidden info]' asText! !


!TextAction methodsFor: 'as yet unclassified' stamp: 'DSM 3/30/1999 13:15'!
info
	^ 'no hidden info'! !


