'From Squeak 2.3 of January 14, 1999 on 17 April 1999 at 4:57:57 pm'!
"Change Set:		scriptRename-sw
Date:			17 April 1999
Author:			Scott Wallace

Works around bugs in the renaming of textually-scripted scripts by not allowing the user to rename a script unless it is currently in tile-scripted format."!


!Player methodsFor: 'scripts-kernel' stamp: 'sws 4/15/1999 15:58'!
renameScript: oldSelector
	| reply newSelector aUserScript |
	self flag: #deferred.
	aUserScript _ self class userScriptForPlayer: self selector: oldSelector.
	aUserScript isTextuallyCoded ifTrue:
		[self inform: 'Sorry, for now you can only rename tiled scripts'.
		^ self].

	reply _   FillInTheBlank request: 'Script Name' initialAnswer: oldSelector.
 	reply size == 0 ifTrue: [^ self].
	reply first isUppercase ifTrue: [^ self inform: 'Illegal script name'].
	(Scanner isLiteralSymbol: reply) ifFalse: [^ self inform: 'Bad script name, please try again'].
	((newSelector _ reply asSymbol) == oldSelector) ifTrue: [^ self].
	(ScriptingSystem isAcceptablePlayerScriptName: newSelector)
		ifFalse: [^ self inform: 'Sorry, "', newSelector, '" is reserved.'].
	self renameScript: oldSelector newSelector: newSelector
! !


!ScriptEditorMorph methodsFor: 'other' stamp: 'sws 4/15/1999 15:58'!
renameScript
	"Invoked at user menu request"
	| reply aPosition oldSelector dflt oldStatus oldOwner aUserScript |
	oldSelector _ self scriptName.
	self flag: #deferred.
	aUserScript _ playerScripted class userScriptForPlayer: self selector: oldSelector.
	aUserScript isTextuallyCoded ifTrue:
		[self inform: 'Sorry, for now you can only rename tiled scripts'.
		^ self].

	oldStatus _ self scriptInstantiation status.
	dflt _ self isAnonymous ifTrue: [''] ifFalse: [self scriptTitle].
	reply _   FillInTheBlank request: 'Script Name' initialAnswer: dflt.
 	reply size == 0 ifTrue: [^ self].
	reply first isUppercase ifTrue: [^ self inform: 'Illegal script name'].
	((reply _ reply asSymbol) == scriptName) ifTrue: [^ self].
	(Scanner isLiteralSymbol: reply) ifFalse: [^ self inform: 'Bad script name, please try again'].
	self titleMorph borderColor: Color black.
	scriptName _ reply.
	playerScripted class atSelector: reply putScriptEditor: self.
	self scriptInstantiation status: oldStatus.
	playerScripted class removeScriptNamed: oldSelector.
	playerScripted actorState instantiatedUserScriptsDictionary removeKey: oldSelector.
	submorphs first delete.  "the button row"
	self addMorphFront: self buttonRowForEditor.  "up to date"
	self install.
	aPosition _ self position.
	oldOwner _ self topRendererOrSelf owner.
	self delete
	playerScripted costume viewAfreshIn: oldOwner showingScript: scriptName at: aPosition! !


