'From Squeak3.1alpha of 28 February 2001 [latest update: #3880] on 26 March 2001 at 4:12:34 pm'!
"Change Set:		setterAndEmptyScript-sw
Date:			26 March 2001
Author:			Scott Wallace

Fixes bug that established the wrong setter selector for a user-defined slot.
Reestablishes the emptyScript feature in viewers, which had been temporarily lost during the recent swichover to vocabularies."!


!Player methodsFor: 'slots-kernel' stamp: 'sw 3/26/2001 15:39'!
methodInterfacesForInstanceVariablesCategoryIn: aViewer
	"Return a collection of methodInterfaces for the instance-variables category"

	| aList anInterface itsSlotName |
	aList _ OrderedCollection new.
	self slotInfo associationsDo:
		[:assoc |
			anInterface _ MethodInterface new.
			itsSlotName _ assoc key.

			anInterface wording: itsSlotName selector: (Utilities getterSelectorFor: itsSlotName) type: assoc value type setter: (Utilities setterSelectorFor: itsSlotName).
			aList add: anInterface].
	^ aList! !

!Player methodsFor: 'slots-kernel' stamp: 'sw 3/26/2001 16:02'!
methodInterfacesForScriptsCategoryIn: aViewer
	"Answer a list of method interfaces for the category #scripts in a Viewer"

	^ {self methodInterfaceForEmptyScript}, self class scripts values! !

!Player methodsFor: 'scripts-kernel' stamp: 'sw 3/26/2001 16:07'!
methodInterfaceForEmptyScript
	| anInterface |
	"Answer a MethodInterface representing Andreas's 'emptyScript' feature"

	anInterface _ MethodInterface new.
	anInterface documentation: 'an empty script; drop on desktop to get a new empty script for this object.'.
	anInterface receiverType: #player.
	anInterface flagAttribute: #scripts.
	anInterface wording: #emptyScript selector: #emptyScript type: nil setter: nil.
	^ anInterface! !

