'From Squeak3.1alpha of 5 February 2001 [latest update: #3884] on 27 March 2001 at 4:59:46 pm'!
"Change Set:		fasterSwikiDir
Date:			27 March 2001
Author:			Bob Arning

Speed up parsing of superswiki directory info"!


!SuperSwikiServer methodsFor: 'for real' stamp: 'RAA 3/27/2001 16:57'!
entries

	| answer c first |

	answer _ self sendToSwikiProjectServer: {
		'action: listallprojects'.
	}.
	(answer beginsWith: 'OK') ifFalse: [^#()].
	c _ self fastParseEntriesFrom: answer.
	c ifNotNil: [^c].
	c _ OrderedCollection new.
	first _ true.
	answer linesDo: [ :x |
		first ifFalse: [c add: (Compiler evaluate: x)].
		first _ false.
	].
	^c
! !

!SuperSwikiServer methodsFor: 'for real' stamp: 'RAA 3/27/2001 16:58'!
fastParseEntriesFrom: aString

	| c first strm xEntryName xCreationTime xModificationTime xIsDirectory xFileSize ch |

	c _ OrderedCollection new.
	first _ true.
	aString linesDo: [ :x |
		first ifFalse: [
			strm _ ReadStream on: x.
			(strm upTo: $ ) = '(DirectoryEntry' ifFalse: [^nil].
			(strm upTo: $ ) = 'name:' ifFalse: [^nil].
			xEntryName _ WriteStream on: String new.
			strm next = $' ifFalse: [^nil].
			[
				ch _ strm next.
				ch = $' and: [(strm peekFor: $') not]
			] whileFalse: [
				xEntryName nextPut: ch.
			].
			xEntryName _ xEntryName contents.
			strm skipSeparators.
			(strm upTo: $ ) = 'creationTime:' ifFalse: [^nil].
			xCreationTime _ (strm upTo: $ ) asNumber.
			(strm upTo: $ ) = 'modificationTime:' ifFalse: [^nil].
			xModificationTime _ (strm upTo: $ ) asNumber.
			(strm upTo: $ ) = 'isDirectory:' ifFalse: [^nil].
			xIsDirectory _ (strm upTo: $ ) = 'true'.
			(strm upTo: $ ) = 'fileSize:' ifFalse: [^nil].
			xFileSize _ (strm upTo: $ ) asNumber.

			c add: (DirectoryEntry 
				name: xEntryName 
				creationTime: xCreationTime 
				modificationTime: xModificationTime 
				isDirectory: xIsDirectory 
				fileSize: xFileSize
			)
		].
		first _ false.
	].
	^c
! !

