'From Squeak3.1alpha [latest update: #''Squeak3.1alpha'' of 28 February 2001 update 3936] on 19 April 2001 at 5:13:12 pm'!
"Change Set:		RefStream-tk
Date:			19 April 2001
Author:			Ted Kaehler

Incorporates Yoshiki Ohshima's fix to allow a ByteArray to hold a DataStream that might contain a String.
	Users should really use a RWBinaryOrTextStream instead for ReferenceStream and SmartRefStream.  Puts up an inform window when a ReadWriteStream is used.

Fix for LEDMorph>>step"!


!LedMorph methodsFor: 'accessing' stamp: 'tk 4/19/2001 16:55'!
stringToLed
	| i k actualString |
	i _ scroller ifNil: [1].
	k _ 1.
	actualString _ String new: chars.
	actualString do: 
		[:m | 
		i > string size ifFalse: [actualString at: k put: (string at: i) asUppercase asCharacter].
		i _ i + 1.
		k _ k + 1].
	i _ 1.
	submorphs do: 
		[:m | 
		m char: (actualString at: i).
		i _ i + 1].
	self changed! !

!LedMorph methodsFor: 'stepping' stamp: 'tk 4/19/2001 17:02'!
step
	(flash or: [flashing])
		ifTrue: 
			[flashing _ flashing not.
			self highlighted: flashing].
	scroller ifNil: [scroller _ 1].
	chars ifNil: [^ self].
	scroller + chars < (string size + 1)
		ifTrue: 
			[scroller _ scroller + 1.
			self stringToLed]
		ifFalse: [scrollLoop ifTrue: [scroller _ 1]]! !


!PositionableStream methodsFor: 'nonhomogeneous accessing' stamp: 'yo 4/16/2001 17:56'!
nextStringPut: s 
	"Append the string, s, to the receiver.  Only used by DataStream.  Max size of 64*256*256*256."

	| length |
	(length _ s size) < 192
		ifTrue: [self nextPut: length]
		ifFalse: 
			[self nextPut: (length digitAt: 4)+192.
			self nextPut: (length digitAt: 3).
			self nextPut: (length digitAt: 2).
			self nextPut: (length digitAt: 1)].
	self nextPutAll: s asByteArray.
	^s! !


!ReferenceStream class methodsFor: 'as yet unclassified' stamp: 'tk 4/19/2001 16:50'!
on: aStream
	"Open a new ReferenceStream on a place to put the raw data."

	aStream class == ReadWriteStream ifTrue: [
		self inform: 'Please consider using a RWBinaryOrTextStream 
instead of a ReadWriteStream'].

	^ super on: aStream
! !

