'From Squeak3.1alpha of 28 February 2001 [latest update: #4351] on 27 September 2001 at 6:37:15 pm'!
"Change Set:		noteCompilation-sw
Date:			27 September 2001
Author:			Scott Wallace

Adds a notification when a method is compiled, so that state in other objects that may be dependent on the presence and/or the content of particular methods can be updated or invalidated.
The immediate benefit is that one no longer needs to call 'Vocabulary initialize' whenever one changes an #additionsToViewerCategories method.
CAUTION: order in the update file is important, and has been hand-jimmied"!

!ClassDescription methodsFor: 'compiling' stamp: 'sw 9/25/2001 02:11'!
noteCompilationOf: aSelector meta: isMeta
	"A hook allowing some classes to react to recompilation of certain selectors"! !

!ClassDescription methodsFor: 'compiling' stamp: 'sw 9/25/2001 02:08'!
compile: text classified: category withStamp: changeStamp notifying: requestor logSource: logSource
	| selector priorMethod method methodNode newText |
	method _ self
		compile: text asString
		notifying: requestor
		trailer: #(0 0 0 0)
		ifFail: [^nil]
		elseSetSelectorAndNode: 
			[:sel :node | selector _ sel.
			priorMethod _ self methodDict at: selector ifAbsent: [nil].
			methodNode _ node].
	logSource ifTrue:
		[newText _ ((requestor == nil or: [requestor isKindOf: SyntaxError]) not
						and: [Preferences confirmFirstUseOfStyle])
			ifTrue: [text askIfAddStyle: priorMethod req: requestor]
			ifFalse: [text].
		 method putSource: newText
				fromParseNode: methodNode
				class: self category: category withStamp: changeStamp 
				inFile: 2 priorMethod: priorMethod].
	self organization classify: selector under: category.
	self theNonMetaClass noteCompilationOf: selector meta: self isMeta.
	^ selector! !


!Morph class methodsFor: 'misc' stamp: 'sw 9/27/2001 04:53'!
noteCompilationOf: aSelector meta: isMeta
	"Any change to an additionsToViewer... method can invalidate existing etoy vocabularies"

	(isMeta and: [aSelector beginsWith: 'additionsToViewer']) ifTrue:
		[Vocabulary changeMadeToViewerAdditions]! !


!Vocabulary class methodsFor: 'eToy vocabularies' stamp: 'sw 9/27/2001 04:53'!
changeMadeToViewerAdditions
	"A change to some morph-subclass class-side #additionsToViewer... was made, which means that the existing etoy vocabularies need updating."

	AllStandardVocabularies ifNotNil:
		[self addEToyVocabulary.
		self addEToyVectorVocabulary]
	
		 ! !

