'From Squeak3.2alpha of 10 October 2001 [latest update: #4599] on 19 December 2001 at 7:13:06 pm'!
"Change Set:		TTSampleStrRotationFix-mdr
Date:			19 December 2001
Author:			Mike Rutenberg

Change MatrixTransformMorph to always initialize the variable transform.  This fix prevents a walkback when you rotate TTSampleStringMorph.  
"!


!MatrixTransformMorph methodsFor: 'initialize' stamp: 'mdr 12/19/2001 19:08'!
initialize
	super initialize.
	transform _ MatrixTransform2x3 identity.
! !

!MatrixTransformMorph methodsFor: 'accessing' stamp: 'mdr 12/19/2001 10:47'!
transform
	^transform! !

!MatrixTransformMorph methodsFor: 'geometry' stamp: 'mdr 12/19/2001 10:48'!
boundsChangedFrom: oldBounds to: newBounds
	oldBounds extent = newBounds extent ifFalse:[
		transform _ transform composedWithGlobal:
			(MatrixTransform2x3 withOffset: oldBounds origin negated).
		transform _ transform composedWithGlobal:
			(MatrixTransform2x3 withScale: newBounds extent / oldBounds extent).
		transform _ transform composedWithGlobal:
			(MatrixTransform2x3 withOffset: newBounds origin).
	].
	transform offset: transform offset + (newBounds origin - oldBounds origin)! !

!MatrixTransformMorph methodsFor: 'flexing' stamp: 'mdr 12/19/2001 10:49'!
rotateBy: delta
	| pt m |
	delta = 0.0 ifTrue:[^self].
	self changed.
	pt _ self transformFromWorld globalPointToLocal: self referencePosition.
	m _ MatrixTransform2x3 withOffset: pt.
	m _ m composedWithLocal: (MatrixTransform2x3 withAngle: delta).
	m _ m composedWithLocal: (MatrixTransform2x3 withOffset: pt negated).
	self transform: (transform composedWithLocal: m).
	self changed.! !

