'From Squeak3.6beta of ''4 July 2003'' [latest update: #5373] on 31 July 2003 at 11:57:46 am'!
"Change Set:		DebuggerHighlightFix-ajh
Date:			31 July 2003
Author:			Anthony Hannan

Reverts back to skipping over highlighting of jumpIfTrue and jumpIfFalse, since the bytecode representation can be significantly different then the source code.  Also adds pc binding to ifNil:/ifNotNil: message nodes so they get highlighted on send: == to nil, instead of erroneously highlighting the next send."!


!ContextPart methodsFor: 'system simulation' stamp: 'hmm 7/30/2001 20:48'!
stepToSendOrReturn
	"Simulate the execution of bytecodes until either sending a message or 
	returning a value to the receiver (that is, until switching contexts)."

	| ctxt |
	[self willReallySend | self willReturn | self willStore]
		whileFalse: [
			ctxt _ self step.
			ctxt == self ifFalse: [self halt. 
				"Caused by mustBeBoolean handling"
				^ctxt]]! !


!MessageNode methodsFor: 'code generation' stamp: 'ajh 7/31/2003 11:26'!
emitIfNil: stack on: strm value: forValue

	| theNode theSize theSelector |
	theNode _ arguments first.
	theSize _ sizes at: 1.
	theSelector _ #ifNotNil:.
	receiver emitForValue: stack on: strm.
	forValue ifTrue: [strm nextPut: Dup. stack push: 1].
	strm nextPut: LdNil. stack push: 1.
	equalNode emit: stack args: 1 on: strm.
	self 
		emitBranchOn: (selector key == theSelector)
		dist: theSize 
		pop: stack 
		on: strm.
	pc _ strm position.
	forValue 
		ifTrue: 
			[strm nextPut: Pop. stack pop: 1.
			theNode emitForEvaluatedValue: stack on: strm]	
		ifFalse: [theNode emitForEvaluatedEffect: stack on: strm].! !

