'From Squeak3.6alpha of ''17 March 2003'' [latest update: #5278] on 29 June 2003 at 5:30:37 pm'!
"Change Set:		BrowseModelClass-nk
Date:			29 June 2003
Author:			Ned Konz
Original version:	9 April 2002
Compatible with:	3.6 > CS 5240

This adds 'browse model class' to the debug menu
for Morphs that are MorphicModels (windows, etc.)"!


!Morph methodsFor: 'debug and other' stamp: 'nk 6/29/2003 17:26'!
buildDebugMenu: aHand 
	"Answer a debugging menu for the receiver.  The hand argument is seemingly historical and plays no role presently"

	| aMenu aPlayer |
	aMenu := MenuMorph new defaultTarget: self.
	aMenu addStayUpItem.
	(self hasProperty: #errorOnDraw) 
		ifTrue: 
			[aMenu add: 'start drawing again' action: #resumeAfterDrawError.
			aMenu addLine].
	(self hasProperty: #errorOnStep) 
		ifTrue: 
			[aMenu add: 'start stepping again' action: #resumeAfterStepError.
			aMenu addLine].
	aMenu add: 'inspect morph' action: #inspectInMorphic:.
	aMenu add: 'inspect owner chain' action: #inspectOwnerChain.
	Smalltalk isMorphic 
		ifFalse: [aMenu add: 'inspect morph (in MVC)' action: #inspect].
	(self isMorphicModel) 
		ifTrue: 
			[aMenu 
				add: 'inspect model'
				target: self model
				action: #inspect].
	(aPlayer := self player) ifNotNil: 
			[aMenu 
				add: 'inspect player'
				target: aPlayer
				action: #inspect].
	aMenu 
		add: 'explore morph'
		target: self
		selector: #explore.
	aMenu addLine.
	aMenu 
		add: 'viewer for Player'
		target: self player
		action: #beViewed.
	aMenu 
		balloonTextForLastItem: 'Opens a viewer on my Player -- this is the same thing you get if you click on the cyan "View" halo handle'.
	aMenu 
		add: 'viewer for Morph'
		target: self
		action: #viewMorphDirectly.
	aMenu 
		balloonTextForLastItem: 'Opens a Viewer on this Morph, rather than on its Player'.
	aMenu addLine.
	aPlayer ifNotNil: 
			[aPlayer class isUniClass 
				ifTrue: 
					[aMenu 
						add: 'browse player class'
						target: aPlayer
						action: #browseHierarchy]].
	aMenu 
		add: 'browse morph class'
		target: self
		selector: #browseHierarchy.
	(self isMorphicModel)
		ifTrue: [aMenu
				add: 'browse model class'
				target: self model
				selector: #browseHierarchy].
	aMenu addLine.
	aPlayer ifNotNil: 
			[aMenu 
				add: 'player protocol (tiles)'
				target: aPlayer
				action: #openInstanceBrowserWithTiles
			"#browseProtocolForPlayer"].
	aMenu 
		add: 'morph protocol (text)'
		target: self
		selector: #haveFullProtocolBrowsed.
	aMenu 
		add: 'morph protocol (tiles)'
		target: self
		selector: #openInstanceBrowserWithTiles.
	aMenu addLine.
	self addViewingItemsTo: aMenu.
	aMenu
		add: 'make own subclass' action: #subclassMorph;
		add: 'internal name ' action: #choosePartName;
		add: 'save morph in file' action: #saveOnFile;
		addLine;
		add: 'call #tempCommand' action: #tempCommand;
		add: 'define #tempCommand' action: #defineTempCommand;
		addLine;
		add: 'control-menu...'
			target: self
			selector: #invokeMetaMenu:;
		add: 'edit balloon help' action: #editBalloonHelpText.
	^aMenu! !

