'From Squeak3.7alpha of ''11 September 2003'' [latest update: #5420] on 26 September 2003 at 1:34:25 pm'!
"Change Set:		ObjectsThumbnailFix-nk
Date:			7 September 2003
Author:			Ned Konz

This change set resets the thumbnails for the Objects Tool and Tools flap so that they aren't transparent in depth 32.

It also fixes a minor problem with the mode changing when you select the Objects Tool's 'reset thumbnails' menu choice.

NOTE: this CS has a postscript that resets the thumbnails!!"!


!IconicButton methodsFor: 'initialization' stamp: 'nk 9/7/2003 08:44'!
initializeWithThumbnail: aThumbnail withLabel: aLabel andSend: aSelector to: aReceiver 	
	"Initialize the receiver to show aThumbnail on its face, giving it the label supplied and arranging for it, when the button goes down on it, to obtain a new morph by sending the supplied selector to the supplied receiver"

	| labeledItem  |
	labeledItem _ AlignmentMorph newColumn beTransparent.
	labeledItem borderWidth: 0.
	labeledItem addMorph: aThumbnail.
	labeledItem addMorphBack: (Morph new extent: (4@4)) beTransparent.
	labeledItem addMorphBack: (BorderedStringMorph contents: aLabel font: (StrikeFont familyName: 'ComicBold' size: 15)).
	self
		beTransparent;
		labelGraphic: (labeledItem imageForm asFormOfDepth: 16);
		borderWidth: 0;
		target: aReceiver;
		actionSelector: #launchPartVia:label:;
		arguments: {aSelector. aLabel};
		actWhen: #buttonDown.

	self stationarySetup.! !


!ObjectsTool methodsFor: 'menu' stamp: 'nk 9/7/2003 07:42'!
resetThumbnails
	"Reset the thumbnail cache"

	PartsBin clearThumbnailCache.
	modeSymbol == #categories ifTrue: [self showCategories] ifFalse: [self showAlphabeticTabs]! !

"Postscript:
Re-build the icons."



| oldDepth |
(Display supportsDisplayDepth: 32) ifFalse: [ ^self inform: 'This system does not support 32 bit display depth.' ].
oldDepth _ Display depth.
Display newDepth: 32.
PartsBin clearThumbnailCache.
Flaps replaceToolsFlap.
ObjectsTool allSubInstancesDo: [ :ea | ea tweakAppearanceAfterModeShift ].
Display newDepth: oldDepth.!

