'From Squeak3.5 of ''11 April 2003'' [latest update: #5180] on 4 December 2003 at 8:27:51 pm'!
"Change Set:		BabelEToysTranslation-dgd
Date:			4 December 2003
Author:			Diego Gomez Deck <DiegoGomezDeck@ConsultAr.com>

A quick hack to translate eToys vocabularies using Babel.

A new preference named #translationWithBabel activates this hack.

The plan is to keep this hack (and the preference) to give time to the translators to cover in Babel the current translations (in #addEnglishVocabulary, #addGermanVocabulary, #addSpanishVocabulary, #addCatalanVocabulary, #addKiswahiliVocabulary, #addDutchVocabulary, #addNorwegianVocabulary and #addSwedishVocabulary).

When all the translation get migrated to Babel, I'll clean up the current multi-language support in eToys.

"

Preferences
	addPreference: #translationWithBabel
	category: #scripting
	default: false
	balloonHelp: 'If true, the eToys vocabularies will be translated using Babel.'.
!


!ElementTranslation methodsFor: 'translation' stamp: 'dgd 12/4/2003 20:22'!
translated
	"answer the receiver translated to the current language"
	| translatedWording translatedHelpMessage |
	
	translatedWording := wording isNil
				ifFalse: [wording asString translated].
	translatedHelpMessage := helpMessage isNil
				ifFalse: [helpMessage asString translated].
	""
	^ self class new
		wording: translatedWording
		helpMessage: translatedHelpMessage
		language: self currentWorld currentNaturalLanguage! !


!ObjectWithDocumentation methodsFor: 'translation' stamp: 'dgd 12/4/2003 19:08'!
translatedToLanguage: languageSymbol
	"Answer an ElementTranslation object in the prevailing natural language, or, if none found, in English"

	| fallback elSym el wrd doc |

	elSym _ self elementSymbol.
	^ naturalLanguageTranslations isEmptyOrNil 
		ifFalse:
			[naturalLanguageTranslations do:
				[:aTranslation |
					aTranslation language == languageSymbol
						ifTrue:
							[^ aTranslation].
					aTranslation language == #English
						ifTrue:
							[fallback _ aTranslation]].
			fallback ifNil: [ElementCategory new categoryName: #none]]

		ifTrue:
			[(el _ self elementSymbol) ifNotNil:
				[((el beginsWith: 'get') and: [elSym size > 3])
					ifTrue:
						[wrd _ (elSym copyFrom: 4 to: elSym size) withFirstCharacterDownshifted.
						doc _ 'get value of ', elSym]
					ifFalse:
						[((elSym beginsWith: 'set') and: [elSym size > 4])
							ifTrue:
								[wrd _ (elSym copyFrom: 4 to: elSym size - 1) withFirstCharacterDownshifted.
								doc _ 'set value of ', elSym]
							ifFalse:
								[wrd _ ScriptingSystem wordingForOperator: elSym.
								doc _ nil]]].
			^ ElementTranslation new wording: wrd helpMessage: doc language: #English]! !

!ObjectWithDocumentation methodsFor: 'translation' stamp: 'dgd 12/4/2003 19:09'!
translatedToPrevailingLanguage
	"Answer an ElementTranslation object in the prevailing natural language, or, if none found, in English"

	^ Preferences translationWithBabel
			ifTrue:[ self translatedToPrevailingLanguageUsingBabel ]
			ifFalse:[ self translatedToLanguage:self currentWorld currentNaturalLanguage]
! !

!ObjectWithDocumentation methodsFor: 'translation' stamp: 'dgd 12/4/2003 19:14'!
translatedToPrevailingLanguageUsingBabel
	"Answer an ElementTranslation object in the prevailing natural  
	language using the Babel mechanism"
	| elSym |
	elSym := self elementSymbol.
	""
	elSym isNil
		ifFalse: [""
			((elSym beginsWith: 'get')
					and: [elSym size > 3])
				ifTrue: [""
					^ ElementTranslation new
						wording: (elSym allButFirst: 3) withFirstCharacterDownshifted translated
						helpMessage: ('get value of {1}' translated format: {elSym})
						language: self currentWorld currentNaturalLanguage].
			""
			((elSym beginsWith: 'set')
					and: [elSym size > 4])
				ifTrue: [""
					^ ElementTranslation new
						wording: (elSym allButFirst: 3) withFirstCharacterDownshifted translated
						helpMessage: ('set value of {1}' translated format: {elSym})
						language: self currentWorld currentNaturalLanguage]].
	""
	^ (self translatedToLanguage: #English) translated! !


!ElementCategory methodsFor: 'translation' stamp: 'dgd 12/4/2003 20:22'!
translated
	"answer the receiver translated to the current language"
	
	^ self class new categoryName: categoryName asString translated asSymbol! !

