'From Squeak3.7alpha of 11 September 2003 [latest update: #5816] on 25 March 2004 at 11:34:30 pm'!
"Change Set:		HighlightCurrentFontChoices
Date:			25 March 2004
Author:			Alexander@Lazarevic.de

- changes the Standard List Font menu so that the currently in use fonts and point sizes are highlighted
- changes the Standard System Font menu so that it can be pinned and stays up for consecutive font selections
(removed extra unused method with 'hilight' in the selector -dew)
"!


!AbstractFont methodsFor: 'fonts-accessing' stamp: 'nk 3/22/2004 15:15'!
textStyleName
	"Answer the name to be used as a key in the TextConstants dictionary."
	^self familyName! !


!BalloonMorph class methodsFor: 'utility' stamp: 'laza 3/25/2004 23:09'!
chooseBalloonFont
	"BalloonMorph chooseBalloonFont"

	Preferences chooseFontWithPrompt:  'Select the font to be
used for balloon help'
		andSendTo: self withSelector: #setBalloonFontTo: highlight: BalloonFont! !


!PluggableListMorph methodsFor: 'menus' stamp: 'laza 3/25/2004 23:10'!
setListFont
	"set the font for the list"

	Preferences chooseFontWithPrompt: 'choose the font for this list' andSendTo: self withSelector: #font: highlight: self listMorph font! !


!Preferences class methodsFor: 'fonts' stamp: 'laza 3/25/2004 23:10'!
chooseCodeFont
	"Not currently sent, but once protocols are sorted out so that we can disriminate on whether a text object being launched is for code or not, will be reincorporated"

	self chooseFontWithPrompt: 'standard code font' andSendTo: self withSelector: #setCodeFontTo: highlight: self standardCodeFont.! !

!Preferences class methodsFor: 'fonts' stamp: 'laza 3/25/2004 23:10'!
chooseEToysFont
	"present a menu with the possible fonts for the eToys"
	self
		chooseFontWithPrompt: 'eToys font'
		andSendTo: self
		withSelector: #setEToysFontTo:
		highlight: self standardEToysFont! !

!Preferences class methodsFor: 'fonts' stamp: 'laza 3/25/2004 23:10'!
chooseFlapsFont
	self chooseFontWithPrompt: 'flaps font' andSendTo: self withSelector: #setFlapsFontTo: highlight: self standardFlapFont! !

!Preferences class methodsFor: 'fonts' stamp: 'laza 3/25/2004 23:11'!
chooseFontWithPrompt: aPrompt andSendTo: aReceiver withSelector: aSelector
	self chooseFontWithPrompt: aPrompt andSendTo: aReceiver withSelector: aSelector highlight: nil
! !

!Preferences class methodsFor: 'fonts' stamp: 'laza 3/25/2004 23:11'!
chooseFontWithPrompt: aPrompt andSendTo: aReceiver withSelector: aSelector highlight: currentFont
	Smalltalk isMorphic
		ifFalse:
			[TextStyle mvcPromptForFont: aPrompt andSendTo: aReceiver withSelector: aSelector]
		ifTrue:
			[TextStyle promptForFont: aPrompt andSendTo: aReceiver withSelector: aSelector highlight: currentFont]! !

!Preferences class methodsFor: 'fonts' stamp: 'laza 3/25/2004 23:11'!
chooseListFont
	self chooseFontWithPrompt: 'standard list font' andSendTo: self withSelector: #setListFontTo: highlight: self standardListFont! !

!Preferences class methodsFor: 'fonts' stamp: 'laza 3/25/2004 23:11'!
chooseMenuFont
	self chooseFontWithPrompt: 'standard menu font' andSendTo: self withSelector: #setMenuFontTo: highlight: self standardMenuFont! !

!Preferences class methodsFor: 'fonts' stamp: 'laza 3/25/2004 23:11'!
chooseSystemFont
	self chooseFontWithPrompt: 'Default text font' andSendTo: self withSelector: #setSystemFontTo: highlight: (TextConstants at: #DefaultTextStyle) defaultFont! !

!Preferences class methodsFor: 'fonts' stamp: 'laza 3/25/2004 23:11'!
chooseWindowTitleFont
	self chooseFontWithPrompt: 'window title font' andSendTo: self withSelector: #setWindowTitleFontTo: highlight: self windowTitleFont! !

!Preferences class methodsFor: 'fonts' stamp: 'laza 3/25/2004 12:44'!
fontConfigurationMenu
	| aMenu |
	aMenu := MenuMorph new defaultTarget: Preferences.
	aMenu addTitle: 'Standard System Fonts' translated.
	
	aMenu addStayUpIcons.
	
	aMenu add: 'default text font...' translated action: #chooseSystemFont.
	aMenu balloonTextForLastItem: 'Choose the default font to be used for code and  in workspaces, transcripts, etc.' translated.
	aMenu lastItem font: TextStyle defaultFont.
	
	aMenu add: 'list font...' translated action: #chooseListFont.
	aMenu lastItem font: Preferences standardListFont.
	aMenu balloonTextForLastItem: 'Choose the font to be used in list panes' translated.
	
	aMenu add: 'flaps font...' translated action: #chooseFlapsFont.
	aMenu lastItem font: Preferences standardFlapFont.
	aMenu balloonTextForLastItem: 'Choose the font to be used on textual flap tabs' translated.

	aMenu add: 'eToys font...' translated action: #chooseEToysFont.
	aMenu lastItem font: Preferences standardEToysFont.
	aMenu balloonTextForLastItem: 'Choose the font to be used on eToys environment' translated.

	aMenu add: 'menu font...' translated action: #chooseMenuFont.
	aMenu lastItem font: Preferences standardMenuFont.
	aMenu balloonTextForLastItem: 'Choose the font to be used in menus' translated.
	
	aMenu add: 'window-title font...' translated action: #chooseWindowTitleFont.
	aMenu lastItem font: Preferences windowTitleFont emphasis: 1.
	aMenu balloonTextForLastItem: 'Choose the font to be used in window titles.' translated.

	aMenu add: 'balloon-help font...' translated target: BalloonMorph action: #chooseBalloonFont.
	aMenu lastItem font: BalloonMorph balloonFont.
	aMenu balloonTextForLastItem: 'choose the font to be used when presenting balloon help.' translated.
	
	aMenu add: 'code font...' translated action: #chooseCodeFont. 
	aMenu lastItem font: Preferences standardCodeFont. 
	aMenu balloonTextForLastItem: 'Choose the font to be used in code panes.' translated.
	
	aMenu addLine.
	aMenu add: 'restore default font choices' translated action: #restoreDefaultFonts.
	aMenu balloonTextForLastItem: 'Use the standard system font defaults' translated.
	
	^ aMenu! !


!TextStyle class methodsFor: 'user interface' stamp: 'laza 3/25/2004 23:12'!
fontMenuForStyle: styleName target: target selector: selector
	^self fontMenuForStyle: styleName target: target selector: selector highlight: nil! !

!TextStyle class methodsFor: 'user interface' stamp: 'laza 3/25/2004 23:12'!
fontMenuForStyle: styleName target: target selector: selector highlight: currentSize
	"Offer a font menu for the given style. If one is selected, pass that font to target with a call to selector. The fonts will be displayed in that font."

 	| aMenu |
	aMenu _ MenuMorph entitled: styleName.
	TextConstants at: styleName ifPresent: [:s |
		(s isTTCStyle) ifTrue: [
			aMenu add: 'New Size' target: self selector: #chooseTTCFontSize: argument: {styleName. target. selector}.
		].
	].
 	(self pointSizesFor: styleName) do:
		[:aWidth | | font |
			font _ (self named: styleName) fontOfPointSize: aWidth.
			aMenu 
				add: (aWidth asString, ' Point') 
				target: target 
				selector: selector
				argument: font.
                aMenu lastItem font: font.
                aWidth = currentSize ifTrue: [aMenu lastItem color: Color blue darker]].
        ^ aMenu! !

!TextStyle class methodsFor: 'user interface' stamp: 'laza 3/25/2004 23:12'!
promptForFont: aPrompt andSendTo: aTarget withSelector: aSelector
	self promptForFont: aPrompt andSendTo: aTarget withSelector: aSelector highlight: nil! !

!TextStyle class methodsFor: 'user interface' stamp: 'laza 3/25/2004 23:12'!
promptForFont: aPrompt andSendTo: aTarget withSelector: aSelector highlight: currentFont
	"Morphic Only!! prompt for a font and if one is provided, send it to aTarget using a message with selector aSelector."

	"TextStyle promptForFont: 'Choose system font:' andSendTo: Preferences withSelector: #setSystemFontTo:"
	"Derived from a method written by Robin Gibson"

        | menu subMenu currentTextStyle currentSize |
        currentTextStyle _ currentFont ifNotNil: [currentFont textStyleName].
        menu _ MenuMorph entitled: aPrompt.
        self actualTextStyles keys do: [:styleName|
                currentSize _  (styleName = currentTextStyle ifTrue: [currentFont pointSize]).
                subMenu _ self fontMenuForStyle: styleName target: aTarget selector: aSelector highlight: currentSize.
                menu add: styleName subMenu: subMenu.
                menu lastItem font: ((self named: styleName) fontOfSize: 18).
                styleName = currentTextStyle ifTrue: [menu lastItem color: Color blue darker]].

        menu popUpInWorld: self currentWorld! !


!AbstractFont reorganize!
('accessing' characterToGlyphMap isRegular xTable)
('measuring' widthOf: widthOfString: widthOfString:from:to:)
('displaying' displayString:on:from:to:at:kern: installOn:foregroundColor:backgroundColor:)
('testing' isTTCFont)
('fonts-accessing' textStyleName)
!

