'From Squeak3.7-m17n of 29 June 2004 [latest update: #0] on 30 June 2004 at 2:58:53 pm'!
"Change Set:		Latin1Vera
Date:			30 June 2004
Author:			Yoshiki Ohshima

Re-load the latin1-encoded BitStream VeraFonts.  Pays reasonable effort to remove the references to the old font."!


!SystemWindow methodsFor: 'label' stamp: 'yo 6/30/2004 00:21'!
setLabelFont: aFont

	label ifNil: [^ self].
	label font: aFont.
! !


!TTFontReader methodsFor: 'processing' stamp: 'yo 6/29/2004 23:33'!
processCharacterMappingTable: entry
	"Read the font's character to glyph index mapping table.
	If an appropriate mapping can be found then return an association
	with the format identifier and the contents of the table"
	| copy initialOffset nSubTables pID sID offset cmap assoc |
	initialOffset _ entry offset.
	entry skip: 2. "Skip table version"
	nSubTables _ entry nextUShort.
	1 to: nSubTables do:[:i|
		pID _ entry nextUShort.
		sID _ entry nextUShort.
		offset _ entry nextULong.
		"Check if this is either a Macintosh encoded table
		or a Windows encoded table"
		(pID = 1 or:[pID = 3]) ifTrue:[
			"Go to the beginning of the table"
			copy _ entry copy.
			copy offset: initialOffset + offset.
			cmap _ self decodeCmapFmtTable: copy.
			(pID = 3 and: [cmap notNil]) "Prefer Windows encoding over everything else"
				ifTrue: [^ pID -> cmap].
			assoc _ pID -> cmap. "Keep it in case we don't find a Mac encoded table"
		].
	].
	^assoc! !

"Postscript:
"
Preferences setWindowTitleFontTo: ((TextStyle named: Preferences windowTitleFont familyName) fontOfPointSize: Preferences windowTitleFont pixelSize).
"Preferences setFlapsFontTo: ((TextStyle named: Preferences standardFlapFont familyName) fontOfPointSize: Preferences standardFlapFont pixelSize)."

SystemWindow allInstances do: [:e | e setLabelFont: Preferences windowTitleFont].
!

