'From Squeak3.8alpha of ''17 July 2004'' [latest update: #5976] on 17 August 2004 at 8:27:03 pm'!
"Change Set:		NLT-Fixes-dgd
Date:			13 August 2004
Author:			Diego Gomez Deck

- Add 'es' as a locale ID and remove the duplicated entry for 'sv'.

- Two new methods needed in LanguageEditor (NLT>>defaultBackgroundColor and NLT>>displayLanguage).


- Remove the unneeded class-variable Current. It's not only unneeded, it causes an error if you call #current, change the selected language, call #current again.

- Some others assorted changes.
"!

Object subclass: #NaturalLanguageTranslator
	instanceVariableNames: 'id generics contexts '
	classVariableNames: 'AllKnownPhrases CachedTranslations Current ExternalTranslations'
	poolDictionaries: ''
	category: 'System-Localization'!

!NaturalLanguageTranslator methodsFor: 'accessing' stamp: 'dgd 8/13/2004 21:12'!
displayLanguage
	^ id displayLanguage! !

!NaturalLanguageTranslator methodsFor: 'user interface' stamp: 'dgd 8/13/2004 21:54'!
defaultBackgroundColor
	"answer the receiver's defaultBackgroundColor for views"
	^ Color cyan! !

!NaturalLanguageTranslator methodsFor: 'private store-retrieve' stamp: 'dgd 8/13/2004 22:42'!
loadFromFileNamed: fileNameString 
	"Load translations from an external file"
	| stream |
stream := FileStream readOnlyFileNamed: fileNameString.
	[
	self loadFromStream: stream]
		ensure: [stream close]! !

!NaturalLanguageTranslator methodsFor: 'private store-retrieve' stamp: 'dgd 8/13/2004 22:43'!
loadFromStream: stream 
	"Load translations from an external file"
	| loadedArray refStream |
	refStream := ReferenceStream on: stream.
	[loadedArray := refStream next]
		ensure: [refStream close].
	self processExternalObject: loadedArray ! !


!NaturalLanguageTranslator class methodsFor: 'accessing' stamp: 'dgd 8/17/2004 19:29'!
current
	^ Locale current translator! !

Object subclass: #NaturalLanguageTranslator
	instanceVariableNames: 'id generics contexts'
	classVariableNames: 'AllKnownPhrases CachedTranslations ExternalTranslations'
	poolDictionaries: ''
	category: 'System-Localization'!

!NaturalLanguageTranslator reorganize!
('accessing' displayLanguage isoCountry isoLanguage localeID translations untranslated)
('initialize-release' localeID:)
('translation' checkPhrase:translation: phrase:translation: translate: translate:in: translationFor:)
('user interface' defaultBackgroundColor)
('private' generics)
('private store-retrieve' loadFromFileNamed: loadFromStream: mergeTranslations: processExternalObject: saveToFileNamed:)
!

