'From Squeakland 3.8.5976 of 19 August 2004 [latest update: #243] on 23 August 2004 at 7:28:37 pm'!
"Change Set:		releaseFix-mir
Date:			23 August 2004
Author:			Michael Rueger

Updates the release scripts to reflect the actually included fonts."!


!SystemDictionary methodsFor: 'squeakland' stamp: 'mir 8/3/2004 22:22'!
makeSqueaklandReleasePhasePrepare
	"Smalltalk makeSqueaklandReleasePhasePrepare"

	Undeclared removeUnreferencedKeys.
	StandardScriptingSystem initialize.
	Preferences initialize.
	(Object classPool at: #DependentsFields) size > 1 ifTrue: [self error:'Still have dependents'].
	Undeclared isEmpty ifFalse: [self error:'Please clean out Undeclared'].

	"Dump all projects"
	Project allSubInstancesDo:[:prj| prj == Project current ifFalse:[Project deletingProject: prj]].

	"Set new look so we don't need older fonts later"
	StandardScriptingSystem applyNewEToyLook.

	Browser initialize.
	ScriptingSystem deletePrivateGraphics.
	ChangeSorter removeChangeSetsNamedSuchThat:
		[:cs| cs name ~= ChangeSet current name].
	ChangeSet current clear.
	ChangeSet current name: 'Unnamed1'.
	Smalltalk garbageCollect.
	"Reinitialize DataStream; it may hold on to some zapped entitities"
	DataStream initialize.
	"Remove existing player references"
	References keys do:[:k| References removeKey: k].

	Smalltalk garbageCollect.
	ScheduledControllers _ nil.
	Smalltalk garbageCollect.
! !

!SystemDictionary methodsFor: 'squeakland' stamp: 'mir 8/3/2004 22:17'!
makeSqueaklandReleasePhaseStripping
	"Smalltalk makeSqueaklandReleasePhaseStripping"

	#(Helvetica Palatino Courier ComicSansMS ) do:
		[:n | TextConstants removeKey: n ifAbsent: []].
	Smalltalk at: #Player ifPresent:[:superCls|
		superCls allSubclassesDo:[:cls|
			cls isSystemDefined ifFalse:[cls removeFromSystem].
			cls _ nil]].
	Smalltalk garbageCollect.
	Smalltalk
		discardFFI;
"		discardMVC;"
		discardSUnit;
		discardSpeech;
		yourself.

	SystemOrganization removeEmptyCategories.

	Smalltalk garbageCollect.
	ScheduledControllers _ nil.
	Behavior flushObsoleteSubclasses.
	Smalltalk garbageCollect; garbageCollect.
	DataStream initialize.
	Smalltalk fixObsoleteReferences.

! !


!SmalltalkImage methodsFor: 'image cleanup' stamp: 'mir 8/23/2004 22:40'!
prepareReleaseImage
	"Perform various image cleanups in preparation for making a Squeak gamma release candidate image."
	"SmalltalkImage current prepareReleaseImage"
	
	| projectChangeSetNames |
	(self confirm: 'Are you sure you want to prepare a release image?
This will perform several irreversible cleanups on this image.')
		ifFalse: [^ self].

	Undeclared removeUnreferencedKeys.
	StandardScriptingSystem initialize.
	Preferences initialize.
	Preferences chooseInitialSettings.
	(Object classPool at: #DependentsFields) size > 1 ifTrue: [self error:'Still have dependents'].
	Undeclared isEmpty ifFalse: [self error:'Please clean out Undeclared'].

	Browser initialize.
	ScriptingSystem deletePrivateGraphics.  "?"
	
	"Delete all changesets except those currently used by existing projects."
	projectChangeSetNames _ Project allSubInstances collect: [:proj | proj changeSet name].
	ChangeSorter removeChangeSetsNamedSuchThat:
		[:cs | (projectChangeSetNames includes: cs) not].
	ChangeSet current clear.
	ChangeSet current name: 'Unnamed1'.
	Smalltalk garbageCollect.
	"Reinitialize DataStream; it may hold on to some zapped entitities"
	DataStream initialize.
	"Remove existing player references"
	References keys do:[:k| References removeKey: k].  "?"

	Smalltalk garbageCollect.
	ScheduledControllers _ nil.
	Smalltalk garbageCollect.
	
	SMSqueakMap default purge.
	
	Behavior flushObsoleteSubclasses.
	Smalltalk garbageCollect; garbageCollect.
	Smalltalk obsoleteBehaviors isEmpty ifFalse:[self error:'Still have obsolete behaviors'].

	DataStream initialize.
	self fixObsoleteReferences.
	Smalltalk forgetDoIts.  "?"
	Smalltalk flushClassNameCache.  "?"
	3 timesRepeat: [
		Smalltalk garbageCollect.
		Symbol compactSymbolTable.
	].
! !
