'From Squeakland 3.8.5976 of 25 August 2004 [latest update: #308] on 4 September 2004 at 7:17:25 pm'!
"Change Set:		BorderVocabFix-nk
Date:			4 September 2004
Author:			Ned Konz

Makes sure that the borderWidth, etc. items are visible in the 'color & border' category of Connectors.

Replaces an 'isKindOf: BorderedMorph' test in Player; adds missing lineWidth slot in Connectors.

"!


!Player methodsFor: 'costume' stamp: 'nk 9/4/2004 17:05'!
costumesDo: aBlock 
	"Evaluate aBlock against every real (not flex) costume known to the receiver,
	starting with the current costume."

	costume ifNotNil: [ aBlock value: costume renderedMorph ].
	costumes
		ifNil: [^ self].
	costumes
		do: [:aCostume | aCostume ~~ costume
				ifTrue: [aBlock value: aCostume renderedMorph]]! !

!Player methodsFor: 'costume' stamp: 'nk 9/4/2004 17:05'!
hasCostumeThatIsAWorld

	self costumesDo: [ :aCostume | (aCostume isWorldMorph) ifTrue: [^ true]].
	^ false! !

!Player methodsFor: 'costume' stamp: 'nk 9/4/2004 17:04'!
hasOnlySketchCostumes
	"Answer true if the only costumes assocaited with this Player are SketchMorph costumes"

	self costumesDo: [ :aCostume | aCostume isSketchMorph ifFalse: [^ false]].
	^ true! !


!PolygonMorph methodsFor: 'accessing' stamp: 'nk 9/4/2004 17:23'!
borderWidth: anInteger

	borderColor ifNil: [borderColor _ Color black].
	borderWidth _ anInteger max: 0.
	self computeBounds! !


!SelectionMorph methodsFor: 'accessing' stamp: 'nk 9/4/2004 17:33'!
borderColor: aColor

	| bordered |
	bordered _ selectedItems.
	undoProperties ifNil: [undoProperties _ bordered collect: [:m | m borderColor]].
	bordered do: [:m | m borderColor: aColor]! !

