'From Squeakland 3.8.5976 of 25 August 2004 [latest update: #348] on 3 November 2004 at 9:36:57 am'!
"Change Set:		CoordGuard-nk
Date:			3 November 2004
Author:			Ned Konz

Guards against fractional coordinates in Morph>>position:

Among other things, this avoids a problem that can be caused by making an Etoy script that sets a Morph's position (via setLeft:, for instance) to a non-integer value.
"!


!Morph methodsFor: 'geometry' stamp: 'nk 11/3/2004 09:34'!
position: aPoint
	"Change the position of this morph and and all of its submorphs."

	| delta box |
	delta _ aPoint asIntegerPoint - bounds topLeft.
	(delta x = 0 and: [delta y = 0]) ifTrue: [^ self].  "Null change"
	box _ self fullBounds.
	(delta dotProduct: delta) > 100 ifTrue:[
		"e.g., more than 10 pixels moved"
		self invalidRect: box.
		self invalidRect: (box translateBy: delta).
	] ifFalse:[
		self invalidRect: (box merge: (box translateBy: delta)).
	].
	self privateFullMoveBy: delta.
	owner ifNotNil:[owner layoutChanged].! !

