'From Squeak3.7beta of ''1 April 2004'' [latest update: #5923] on 14 August 2004 at 11:28:38 am'!
"Change Set:		CsvFileParsingTests-2-dtl
Date:			14 August 2004
Author:			David T. Lewis

SUnit tests for CsvVileParsing-2-dtl."!


!StringTest methodsFor: 'testing - tokenizing' stamp: 'dtl 6/7/2004 22:03'!
testFindTokensEscapedBy01

	| tokens |
	string _ 'this, is, "a, test"'.
	tokens _ string findTokens: ',' escapedBy: '"'.
	self assert: tokens size == 3! !

!StringTest methodsFor: 'testing - tokenizing' stamp: 'dtl 6/7/2004 22:10'!
testFindTokensEscapedBy02

	| tokens |
	string _ ''.
	tokens _ string findTokens: ',' escapedBy: '"'.
	self assert: tokens size == 0! !

!StringTest methodsFor: 'testing - tokenizing' stamp: 'dtl 6/7/2004 22:11'!
testFindTokensEscapedBy03

	| tokens |
	string _ 'this, is, a, test'.
	tokens _ string findTokens: ',' escapedBy: '"'.
	self assert: tokens size == 4! !

!StringTest methodsFor: 'testing - tokenizing' stamp: 'dtl 6/7/2004 22:11'!
testFindTokensEscapedBy04

	| tokens |
	string _ 'this, is, a"," test'.
	tokens _ string findTokens: ',' escapedBy: '"'.
	self assert: tokens size == 3.
	self assert: tokens third = ' a, test'! !

!StringTest methodsFor: 'testing - tokenizing' stamp: 'dtl 6/7/2004 22:18'!
testFindTokensEscapedBy05

	| tokens |
	string _ 'this, /is, a"," test/'.
	tokens _ string findTokens: ',#' escapedBy: '"/'.
	self assert: tokens size == 2.
	self assert: tokens first = 'this'.
	self assert: tokens second = ' is, a"," test'.! !

!StringTest methodsFor: 'testing - tokenizing' stamp: 'dtl 6/7/2004 22:29'!
testFindTokensEscapedBy06

	| tokens |
	string _ 'this, is, "a, test'.
	tokens _ string findTokens: ',' escapedBy: '"'.
	self assert: tokens size == 3.
	self assert: tokens third = ' a, test'! !

!StringTest methodsFor: 'testing - tokenizing' stamp: 'dtl 8/13/2004 19:24'!
testFindTokensEscapedBy07

	| tokens |
	string _ 'a:b::c'.
	tokens _ string findTokens: ':' escapedBy: '"'.
	self assert: tokens size == 4.
	self assert: tokens first = 'a'.
	self assert: tokens second = 'b'.
	self assert: tokens third = ''.
	self assert: tokens fourth = 'c'! !

!StringTest methodsFor: 'testing - tokenizing' stamp: 'dtl 8/14/2004 09:37'!
testFindTokensEscapedBy08

	| tokens |
	string _ 'this, is, ##a, test'.
	tokens _ string findTokens: ',' escapedBy: '#'.
	self assert: tokens size == 4.
	self assert: tokens third = ' a'.
	self assert: tokens fourth = ' test'! !

!StringTest methodsFor: 'testing - tokenizing' stamp: 'dtl 8/14/2004 09:36'!
testFindTokensEscapedBy09

	| tokens |
	string _ 'this, is, ###a, test#'.
	tokens _ string findTokens: ',' escapedBy: '#'.
	self assert: tokens size == 3.
	self assert: tokens third = ' #a, test'! !

!StringTest methodsFor: 'testing - tokenizing' stamp: 'dtl 8/14/2004 09:39'!
testFindTokensEscapedBy10

	| tokens |
	string _ 'this, is, ###a, test'.
	tokens _ string findTokens: ',' escapedBy: '#'.
	self assert: tokens size == 3.
	self assert: tokens third = ' #a, test'! !

!StringTest methodsFor: 'testing - tokenizing' stamp: 'dtl 8/14/2004 09:40'!
testFindTokensEscapedBy11

	| tokens |
	string _ 'this, is, """a, test"'.
	tokens _ string findTokens: ',' escapedBy: '"'.
	self assert: tokens size == 3.
	self assert: tokens third = ' "a, test'! !

!StringTest methodsFor: 'testing - tokenizing' stamp: 'dtl 8/14/2004 11:11'!
testFindTokensEscapedBy12

	| tokens |
	string _ 'one, two# three; four. five'.
	tokens _ string findTokens: ',#;.' escapedBy: '"'.
	self assert: tokens size == 5.
	self assert: tokens third = ' three'! !

!StringTest methodsFor: 'testing - tokenizing' stamp: 'dtl 8/14/2004 11:11'!
testFindTokensEscapedBy13

	| tokens |
	string _ 'one, two# three; four. five'.
	tokens _ string findTokens: ',#;.' escapedBy: nil.
	self assert: tokens size == 5.
	self assert: tokens third = ' three'! !

!StringTest methodsFor: 'testing - tokenizing' stamp: 'dtl 8/14/2004 11:17'!
testFindTokensEscapedBy14

	| tokens |
	string _ 'one, "two# three"; &four. five&'.
	tokens _ string findTokens: ',#;.' escapedBy: '"&'.
	self assert: tokens size == 3.
	self assert: tokens second = ' two# three'.
	self assert: tokens third = ' four. five'! !

!StringTest methodsFor: 'testing - tokenizing' stamp: 'dtl 8/14/2004 11:24'!
testFindTokensEscapedBy15

	| tokens |
	string _ 'one, "two# three"; &four. five&'.
	tokens _ string findTokens: nil escapedBy: '"&'.
	self assert: tokens size == 1.
	self assert: tokens first = 'one, two# three; four. five'! !

!StringTest methodsFor: 'testing - tokenizing' stamp: 'dtl 8/14/2004 11:23'!
testFindTokensEscapedBy16

	| tokens |
	string _ 'one, "two# three"; &four. five&'.
	tokens _ string findTokens: nil escapedBy: nil.
	self assert: tokens size == 1.
	self assert: tokens first = string! !

!StringTest methodsFor: 'testing - tokenizing' stamp: 'dtl 8/14/2004 10:24'!
testFindTokensEscapedBy21

	| tokens |
	string _ 'this, is, "a, test"'.
	tokens _ string findTokens: $, escapedBy: $".
	self assert: tokens size == 3! !

!StringTest methodsFor: 'testing - tokenizing' stamp: 'dtl 8/14/2004 10:24'!
testFindTokensEscapedBy22

	| tokens |
	string _ ''.
	tokens _ string findTokens: $, escapedBy: $".
	self assert: tokens size == 0! !

!StringTest methodsFor: 'testing - tokenizing' stamp: 'dtl 8/14/2004 10:24'!
testFindTokensEscapedBy23

	| tokens |
	string _ 'this, is, a, test'.
	tokens _ string findTokens: $, escapedBy: $".
	self assert: tokens size == 4! !

!StringTest methodsFor: 'testing - tokenizing' stamp: 'dtl 8/14/2004 10:25'!
testFindTokensEscapedBy24

	| tokens |
	string _ 'this, is, a"," test'.
	tokens _ string findTokens: $, escapedBy: $".
	self assert: tokens size == 3.
	self assert: tokens third = ' a, test'! !

!StringTest methodsFor: 'testing - tokenizing' stamp: 'dtl 8/14/2004 10:25'!
testFindTokensEscapedBy25

	| tokens |
	string _ 'this, /is, a"," test/'.
	tokens _ string findTokens: $, escapedBy: $/.
	self assert: tokens size == 2.
	self assert: tokens first = 'this'.
	self assert: tokens second = ' is, a"," test'.! !

!StringTest methodsFor: 'testing - tokenizing' stamp: 'dtl 8/14/2004 10:25'!
testFindTokensEscapedBy26

	| tokens |
	string _ 'this, is, "a, test'.
	tokens _ string findTokens: $, escapedBy: $".
	self assert: tokens size == 3.
	self assert: tokens third = ' a, test'! !

