'From Vancouver1.0 of 28 September 2004 [latest update: #353] on 30 December 2004 at 12:59:20 am'!
"Change Set:		visibleThumbnail-sw
Date:			29 December 2004
Author:			Scott Wallace

Assures that the thumbnails of objects with extreme aspect ratios do not vanish.."!

RectangleMorph subclass: #ThumbnailMorph
	instanceVariableNames: 'objectToView viewSelector lastSketchForm lastFormShown drawTime'
	classVariableNames: 'EccentricityThreshhold RecursionDepth RecursionMax'
	poolDictionaries: ''
	category: 'Morphic-Widgets'!

!PasteUpMorph methodsFor: 'world state' stamp: 'sw 12/30/2004 00:59'!
restoreMorphicDisplay
	"Restore the morphic display -- initiated by explicit user request"

	DisplayScreen startUp.
	ThumbnailMorph recursionReset.
	self
		extent: Display extent;
		viewBox: Display boundingBox;
		handsDo: [:h | h visible: true; showTemporaryCursor: nil];
		restoreFlapsDisplay;
		fullRepaintNeeded.
	WorldState addDeferredUIMessage:
		[Cursor normal show]! !

!ThumbnailMorph methodsFor: 'display' stamp: 'sw 12/30/2004 00:57'!
drawMeOn: aCanvas 
	"Draw a small view of a morph in another place.  Guard against infinite recursion if that morph has a thumbnail of itself inside.  Now also works if the thing to draw is a plain Form rather than a morph."

	| viewedMorphBox myBox scale c shrunkForm aWorld aFormOrMorph scaleX scaleY ratio factor  |
	super drawOn: aCanvas.
	((aFormOrMorph := self formOrMorphToView) isForm) 
		ifTrue: [^self drawForForm: aFormOrMorph on: aCanvas].
	(((aFormOrMorph notNil and: [(aWorld := aFormOrMorph world) notNil]) 
		and: [aWorld ~~ aFormOrMorph or: [lastFormShown isNil]]) 
			and: [RecursionDepth + 1 < RecursionMax]) 
			ifTrue: 
				[RecursionDepth := RecursionDepth + 1.
				viewedMorphBox := aFormOrMorph fullBounds.
				myBox := self innerBounds.
				scaleX _ myBox width asFloat / viewedMorphBox width.
				scaleY _ myBox height asFloat / viewedMorphBox height.
				ratio _ scaleX / scaleY.
				factor _ 1.0 / EccentricityThreshhold.
				ratio < factor
					ifTrue:
						[scale _ (scaleX) @ (factor * scaleY)]
					ifFalse:
						[ratio > EccentricityThreshhold
							ifTrue:
								[scale _ (factor * scaleX) @ scaleY]
							ifFalse:
								[scale _ scaleX min: scaleY]].
				c _ Display defaultCanvasClass extent: viewedMorphBox extent
							depth: aCanvas depth.
				c translateBy: viewedMorphBox topLeft negated
					during: 
						[:tempCanvas | 
						"recursion happens here"
						tempCanvas fullDrawMorph: aFormOrMorph].
				shrunkForm := c form 
							magnify: c form boundingBox
							by: scale
							smoothing: 1.
				lastFormShown := shrunkForm.
				RecursionDepth := RecursionDepth - 1]
			ifFalse: 
				["This branch used if we've recurred, or if the thumbnail views a World that's already been rendered once, or if the referent is not in a world at the moment"
				lastFormShown ifNotNil: [shrunkForm := lastFormShown]].
	shrunkForm ifNotNil: 
			[aCanvas paintImage: shrunkForm
				at: self center - shrunkForm boundingBox center]! !


!ThumbnailMorph class methodsFor: 'class initialization' stamp: 'sw 12/30/2004 00:47'!
initialize
	"Initialize the class variables of ThumbnailMorph"

	RecursionMax _ 2.
	RecursionDepth _ 0.
	EccentricityThreshhold _  Float pi

"ThumbnailMorph initialize"! !

ThumbnailMorph initialize!
